---
title: Cosmos SDK Documentation
sidebar_position: 0
---

Cosmos SDK is the world’s most popular framework for building application-specific blockchains.

## Getting Started

Read all about the SDK or dive straight into the code with tutorials.

* [**Introductions to the Cosmos SDK**](./intro/00-overview.md) - Learn about all the parts of the Cosmos SDK.
* [**SDK Tutorials**](https://tutorials.cosmos.network) - Build a complete blockchain application from scratch.

## Explore the SDK

Get familiar with the SDK and explore its main concepts.

* [**Introduction**](./intro/00-overview.md) - High-level overview of the Cosmos SDK.
* [**Basics**](./basics/00-app-anatomy.md) - Anatomy of a blockchain, transaction lifecycle, accounts and more.
* [**Core Concepts**](./core/00-baseapp.md) -  Read about the core concepts like baseapp, the store, or the server.
* [**Building Modules**](./building-modules/01-intro.md) -  Discover how to build modules for the Cosmos SDK.
* [**Running a Node**](./run-node/00-keyring.md) - Running and interacting with nodes using the CLI and API.
* [**Modules**](./modules/README.md) - Explore existing modules to build your application with.

## Explore the Stack

Check out the docs for the various parts of the Cosmos stack.

* [**Cosmos Hub**](https://hub.cosmos.network) - The first of thousands of interconnected blockchains on the Cosmos Network.
* [**Tendermint Core**](https://docs.tendermint.com) - The leading BFT engine for building blockchains, powering Cosmos SDK.

## Help & Support

* [**Discord**](https://discord.gg/cosmosnetwork) - Chat with Cosmos developers on Discord.
* [**GitHub Discussions**](https://github.com/cosmos/cosmos-sdk/discussions) - Ask questions and discuss SDK development on GitHub.
* [**Found an issue?**](https://github.com/cosmos/cosmos-sdk/edit/main/docs/docs/README.md) - Help us improve this page by suggesting edits on GitHub.
