// Code generated by protoc-gen-gogo. DO NOT EDIT.
// source: cosmos/staking/v1beta1/staking.proto

package types

import (
	bytes "bytes"
	compress_gzip "compress/gzip"
	fmt "fmt"
	_ "github.com/cosmos/cosmos-proto"
	types1 "github.com/cosmos/cosmos-sdk/codec/types"
	github_com_cosmos_cosmos_sdk_types "github.com/cosmos/cosmos-sdk/types"
	types2 "github.com/cosmos/cosmos-sdk/types"
	_ "github.com/cosmos/gogoproto/gogoproto"
	github_com_cosmos_gogoproto_proto "github.com/cosmos/gogoproto/proto"
	proto "github.com/cosmos/gogoproto/proto"
	github_com_cosmos_gogoproto_protoc_gen_gogo_descriptor "github.com/cosmos/gogoproto/protoc-gen-gogo/descriptor"
	github_com_cosmos_gogoproto_types "github.com/cosmos/gogoproto/types"
	types3 "github.com/tendermint/tendermint/abci/types"
	types "github.com/tendermint/tendermint/proto/tendermint/types"
	_ "google.golang.org/protobuf/types/known/durationpb"
	_ "google.golang.org/protobuf/types/known/timestamppb"
	io "io"
	io_ioutil "io/ioutil"
	math "math"
	math_bits "math/bits"
	reflect "reflect"
	strings "strings"
	time "time"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf
var _ = time.Kitchen

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.GoGoProtoPackageIsVersion3 // please upgrade the proto package

// BondStatus is the status of a validator.
type BondStatus int32

const (
	// UNSPECIFIED defines an invalid validator status.
	Unspecified BondStatus = 0
	// UNBONDED defines a validator that is not bonded.
	Unbonded BondStatus = 1
	// UNBONDING defines a validator that is unbonding.
	Unbonding BondStatus = 2
	// BONDED defines a validator that is bonded.
	Bonded BondStatus = 3
)

var BondStatus_name = map[int32]string{
	0: "BOND_STATUS_UNSPECIFIED",
	1: "BOND_STATUS_UNBONDED",
	2: "BOND_STATUS_UNBONDING",
	3: "BOND_STATUS_BONDED",
}

var BondStatus_value = map[string]int32{
	"BOND_STATUS_UNSPECIFIED": 0,
	"BOND_STATUS_UNBONDED":    1,
	"BOND_STATUS_UNBONDING":   2,
	"BOND_STATUS_BONDED":      3,
}

func (x BondStatus) String() string {
	return proto.EnumName(BondStatus_name, int32(x))
}

func (BondStatus) EnumDescriptor() ([]byte, []int) {
	return fileDescriptor_64c30c6cf92913c9, []int{0}
}

// Infraction indicates the infraction a validator commited.
type Infraction int32

const (
	// UNSPECIFIED defines an empty infraction.
	Infraction_INFRACTION_UNSPECIFIED Infraction = 0
	// DOUBLE_SIGN defines a validator that double-signs a block.
	Infraction_INFRACTION_DOUBLE_SIGN Infraction = 1
	// DOWNTIME defines a validator that missed signing too many blocks.
	Infraction_INFRACTION_DOWNTIME Infraction = 2
)

var Infraction_name = map[int32]string{
	0: "INFRACTION_UNSPECIFIED",
	1: "INFRACTION_DOUBLE_SIGN",
	2: "INFRACTION_DOWNTIME",
}

var Infraction_value = map[string]int32{
	"INFRACTION_UNSPECIFIED": 0,
	"INFRACTION_DOUBLE_SIGN": 1,
	"INFRACTION_DOWNTIME":    2,
}

func (x Infraction) String() string {
	return proto.EnumName(Infraction_name, int32(x))
}

func (Infraction) EnumDescriptor() ([]byte, []int) {
	return fileDescriptor_64c30c6cf92913c9, []int{1}
}

// HistoricalInfo contains header and validator information for a given block.
// It is stored as part of staking module's state, which persists the `n` most
// recent HistoricalInfo
// (`n` is set by the staking module's `historical_entries` parameter).
type HistoricalInfo struct {
	Header types.Header `protobuf:"bytes,1,opt,name=header,proto3" json:"header"`
	Valset []Validator  `protobuf:"bytes,2,rep,name=valset,proto3" json:"valset"`
}

func (m *HistoricalInfo) Reset()         { *m = HistoricalInfo{} }
func (m *HistoricalInfo) String() string { return proto.CompactTextString(m) }
func (*HistoricalInfo) ProtoMessage()    {}
func (*HistoricalInfo) Descriptor() ([]byte, []int) {
	return fileDescriptor_64c30c6cf92913c9, []int{0}
}
func (m *HistoricalInfo) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *HistoricalInfo) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_HistoricalInfo.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *HistoricalInfo) XXX_Merge(src proto.Message) {
	xxx_messageInfo_HistoricalInfo.Merge(m, src)
}
func (m *HistoricalInfo) XXX_Size() int {
	return m.Size()
}
func (m *HistoricalInfo) XXX_DiscardUnknown() {
	xxx_messageInfo_HistoricalInfo.DiscardUnknown(m)
}

var xxx_messageInfo_HistoricalInfo proto.InternalMessageInfo

func (m *HistoricalInfo) GetHeader() types.Header {
	if m != nil {
		return m.Header
	}
	return types.Header{}
}

func (m *HistoricalInfo) GetValset() []Validator {
	if m != nil {
		return m.Valset
	}
	return nil
}

// CommissionRates defines the initial commission rates to be used for creating
// a validator.
type CommissionRates struct {
	// rate is the commission rate charged to delegators, as a fraction.
	Rate github_com_cosmos_cosmos_sdk_types.Dec `protobuf:"bytes,1,opt,name=rate,proto3,customtype=github.com/cosmos/cosmos-sdk/types.Dec" json:"rate"`
	// max_rate defines the maximum commission rate which validator can ever charge, as a fraction.
	MaxRate github_com_cosmos_cosmos_sdk_types.Dec `protobuf:"bytes,2,opt,name=max_rate,json=maxRate,proto3,customtype=github.com/cosmos/cosmos-sdk/types.Dec" json:"max_rate"`
	// max_change_rate defines the maximum daily increase of the validator commission, as a fraction.
	MaxChangeRate github_com_cosmos_cosmos_sdk_types.Dec `protobuf:"bytes,3,opt,name=max_change_rate,json=maxChangeRate,proto3,customtype=github.com/cosmos/cosmos-sdk/types.Dec" json:"max_change_rate"`
}

func (m *CommissionRates) Reset()      { *m = CommissionRates{} }
func (*CommissionRates) ProtoMessage() {}
func (*CommissionRates) Descriptor() ([]byte, []int) {
	return fileDescriptor_64c30c6cf92913c9, []int{1}
}
func (m *CommissionRates) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *CommissionRates) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_CommissionRates.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *CommissionRates) XXX_Merge(src proto.Message) {
	xxx_messageInfo_CommissionRates.Merge(m, src)
}
func (m *CommissionRates) XXX_Size() int {
	return m.Size()
}
func (m *CommissionRates) XXX_DiscardUnknown() {
	xxx_messageInfo_CommissionRates.DiscardUnknown(m)
}

var xxx_messageInfo_CommissionRates proto.InternalMessageInfo

// Commission defines commission parameters for a given validator.
type Commission struct {
	// commission_rates defines the initial commission rates to be used for creating a validator.
	CommissionRates `protobuf:"bytes,1,opt,name=commission_rates,json=commissionRates,proto3,embedded=commission_rates" json:"commission_rates"`
	// update_time is the last time the commission rate was changed.
	UpdateTime time.Time `protobuf:"bytes,2,opt,name=update_time,json=updateTime,proto3,stdtime" json:"update_time"`
}

func (m *Commission) Reset()      { *m = Commission{} }
func (*Commission) ProtoMessage() {}
func (*Commission) Descriptor() ([]byte, []int) {
	return fileDescriptor_64c30c6cf92913c9, []int{2}
}
func (m *Commission) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *Commission) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_Commission.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *Commission) XXX_Merge(src proto.Message) {
	xxx_messageInfo_Commission.Merge(m, src)
}
func (m *Commission) XXX_Size() int {
	return m.Size()
}
func (m *Commission) XXX_DiscardUnknown() {
	xxx_messageInfo_Commission.DiscardUnknown(m)
}

var xxx_messageInfo_Commission proto.InternalMessageInfo

func (m *Commission) GetUpdateTime() time.Time {
	if m != nil {
		return m.UpdateTime
	}
	return time.Time{}
}

// Description defines a validator description.
type Description struct {
	// moniker defines a human-readable name for the validator.
	Moniker string `protobuf:"bytes,1,opt,name=moniker,proto3" json:"moniker,omitempty"`
	// identity defines an optional identity signature (ex. UPort or Keybase).
	Identity string `protobuf:"bytes,2,opt,name=identity,proto3" json:"identity,omitempty"`
	// website defines an optional website link.
	Website string `protobuf:"bytes,3,opt,name=website,proto3" json:"website,omitempty"`
	// security_contact defines an optional email for security contact.
	SecurityContact string `protobuf:"bytes,4,opt,name=security_contact,json=securityContact,proto3" json:"security_contact,omitempty"`
	// details define other optional details.
	Details string `protobuf:"bytes,5,opt,name=details,proto3" json:"details,omitempty"`
}

func (m *Description) Reset()      { *m = Description{} }
func (*Description) ProtoMessage() {}
func (*Description) Descriptor() ([]byte, []int) {
	return fileDescriptor_64c30c6cf92913c9, []int{3}
}
func (m *Description) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *Description) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_Description.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *Description) XXX_Merge(src proto.Message) {
	xxx_messageInfo_Description.Merge(m, src)
}
func (m *Description) XXX_Size() int {
	return m.Size()
}
func (m *Description) XXX_DiscardUnknown() {
	xxx_messageInfo_Description.DiscardUnknown(m)
}

var xxx_messageInfo_Description proto.InternalMessageInfo

func (m *Description) GetMoniker() string {
	if m != nil {
		return m.Moniker
	}
	return ""
}

func (m *Description) GetIdentity() string {
	if m != nil {
		return m.Identity
	}
	return ""
}

func (m *Description) GetWebsite() string {
	if m != nil {
		return m.Website
	}
	return ""
}

func (m *Description) GetSecurityContact() string {
	if m != nil {
		return m.SecurityContact
	}
	return ""
}

func (m *Description) GetDetails() string {
	if m != nil {
		return m.Details
	}
	return ""
}

// Validator defines a validator, together with the total amount of the
// Validator's bond shares and their exchange rate to coins. Slashing results in
// a decrease in the exchange rate, allowing correct calculation of future
// undelegations without iterating over delegators. When coins are delegated to
// this validator, the validator is credited with a delegation whose number of
// bond shares is based on the amount of coins delegated divided by the current
// exchange rate. Voting power can be calculated as total bonded shares
// multiplied by exchange rate.
type Validator struct {
	// operator_address defines the address of the validator's operator; bech encoded in JSON.
	OperatorAddress string `protobuf:"bytes,1,opt,name=operator_address,json=operatorAddress,proto3" json:"operator_address,omitempty"`
	// consensus_pubkey is the consensus public key of the validator, as a Protobuf Any.
	ConsensusPubkey *types1.Any `protobuf:"bytes,2,opt,name=consensus_pubkey,json=consensusPubkey,proto3" json:"consensus_pubkey,omitempty"`
	// jailed defined whether the validator has been jailed from bonded status or not.
	Jailed bool `protobuf:"varint,3,opt,name=jailed,proto3" json:"jailed,omitempty"`
	// status is the validator status (bonded/unbonding/unbonded).
	Status BondStatus `protobuf:"varint,4,opt,name=status,proto3,enum=cosmos.staking.v1beta1.BondStatus" json:"status,omitempty"`
	// tokens define the delegated tokens (incl. self-delegation).
	Tokens github_com_cosmos_cosmos_sdk_types.Int `protobuf:"bytes,5,opt,name=tokens,proto3,customtype=github.com/cosmos/cosmos-sdk/types.Int" json:"tokens"`
	// delegator_shares defines total shares issued to a validator's delegators.
	DelegatorShares github_com_cosmos_cosmos_sdk_types.Dec `protobuf:"bytes,6,opt,name=delegator_shares,json=delegatorShares,proto3,customtype=github.com/cosmos/cosmos-sdk/types.Dec" json:"delegator_shares"`
	// description defines the description terms for the validator.
	Description Description `protobuf:"bytes,7,opt,name=description,proto3" json:"description"`
	// unbonding_height defines, if unbonding, the height at which this validator has begun unbonding.
	UnbondingHeight int64 `protobuf:"varint,8,opt,name=unbonding_height,json=unbondingHeight,proto3" json:"unbonding_height,omitempty"`
	// unbonding_time defines, if unbonding, the min time for the validator to complete unbonding.
	UnbondingTime time.Time `protobuf:"bytes,9,opt,name=unbonding_time,json=unbondingTime,proto3,stdtime" json:"unbonding_time"`
	// commission defines the commission parameters.
	Commission Commission `protobuf:"bytes,10,opt,name=commission,proto3" json:"commission"`
	// min_self_delegation is the validator's self declared minimum self delegation.
	//
	// Since: cosmos-sdk 0.46
	MinSelfDelegation github_com_cosmos_cosmos_sdk_types.Int `protobuf:"bytes,11,opt,name=min_self_delegation,json=minSelfDelegation,proto3,customtype=github.com/cosmos/cosmos-sdk/types.Int" json:"min_self_delegation"`
	// strictly positive if this validator's unbonding has been stopped by external modules
	UnbondingOnHoldRefCount int64 `protobuf:"varint,12,opt,name=unbonding_on_hold_ref_count,json=unbondingOnHoldRefCount,proto3" json:"unbonding_on_hold_ref_count,omitempty"`
	// list of unbonding ids, each uniquely identifing an unbonding of this validator
	UnbondingIds []uint64 `protobuf:"varint,13,rep,packed,name=unbonding_ids,json=unbondingIds,proto3" json:"unbonding_ids,omitempty"`
}

func (m *Validator) Reset()      { *m = Validator{} }
func (*Validator) ProtoMessage() {}
func (*Validator) Descriptor() ([]byte, []int) {
	return fileDescriptor_64c30c6cf92913c9, []int{4}
}
func (m *Validator) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *Validator) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_Validator.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *Validator) XXX_Merge(src proto.Message) {
	xxx_messageInfo_Validator.Merge(m, src)
}
func (m *Validator) XXX_Size() int {
	return m.Size()
}
func (m *Validator) XXX_DiscardUnknown() {
	xxx_messageInfo_Validator.DiscardUnknown(m)
}

var xxx_messageInfo_Validator proto.InternalMessageInfo

// ValAddresses defines a repeated set of validator addresses.
type ValAddresses struct {
	Addresses []string `protobuf:"bytes,1,rep,name=addresses,proto3" json:"addresses,omitempty"`
}

func (m *ValAddresses) Reset()      { *m = ValAddresses{} }
func (*ValAddresses) ProtoMessage() {}
func (*ValAddresses) Descriptor() ([]byte, []int) {
	return fileDescriptor_64c30c6cf92913c9, []int{5}
}
func (m *ValAddresses) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *ValAddresses) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_ValAddresses.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *ValAddresses) XXX_Merge(src proto.Message) {
	xxx_messageInfo_ValAddresses.Merge(m, src)
}
func (m *ValAddresses) XXX_Size() int {
	return m.Size()
}
func (m *ValAddresses) XXX_DiscardUnknown() {
	xxx_messageInfo_ValAddresses.DiscardUnknown(m)
}

var xxx_messageInfo_ValAddresses proto.InternalMessageInfo

func (m *ValAddresses) GetAddresses() []string {
	if m != nil {
		return m.Addresses
	}
	return nil
}

// DVPair is struct that just has a delegator-validator pair with no other data.
// It is intended to be used as a marshalable pointer. For example, a DVPair can
// be used to construct the key to getting an UnbondingDelegation from state.
type DVPair struct {
	DelegatorAddress string `protobuf:"bytes,1,opt,name=delegator_address,json=delegatorAddress,proto3" json:"delegator_address,omitempty"`
	ValidatorAddress string `protobuf:"bytes,2,opt,name=validator_address,json=validatorAddress,proto3" json:"validator_address,omitempty"`
}

func (m *DVPair) Reset()      { *m = DVPair{} }
func (*DVPair) ProtoMessage() {}
func (*DVPair) Descriptor() ([]byte, []int) {
	return fileDescriptor_64c30c6cf92913c9, []int{6}
}
func (m *DVPair) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *DVPair) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_DVPair.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *DVPair) XXX_Merge(src proto.Message) {
	xxx_messageInfo_DVPair.Merge(m, src)
}
func (m *DVPair) XXX_Size() int {
	return m.Size()
}
func (m *DVPair) XXX_DiscardUnknown() {
	xxx_messageInfo_DVPair.DiscardUnknown(m)
}

var xxx_messageInfo_DVPair proto.InternalMessageInfo

// DVPairs defines an array of DVPair objects.
type DVPairs struct {
	Pairs []DVPair `protobuf:"bytes,1,rep,name=pairs,proto3" json:"pairs"`
}

func (m *DVPairs) Reset()         { *m = DVPairs{} }
func (m *DVPairs) String() string { return proto.CompactTextString(m) }
func (*DVPairs) ProtoMessage()    {}
func (*DVPairs) Descriptor() ([]byte, []int) {
	return fileDescriptor_64c30c6cf92913c9, []int{7}
}
func (m *DVPairs) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *DVPairs) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_DVPairs.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *DVPairs) XXX_Merge(src proto.Message) {
	xxx_messageInfo_DVPairs.Merge(m, src)
}
func (m *DVPairs) XXX_Size() int {
	return m.Size()
}
func (m *DVPairs) XXX_DiscardUnknown() {
	xxx_messageInfo_DVPairs.DiscardUnknown(m)
}

var xxx_messageInfo_DVPairs proto.InternalMessageInfo

func (m *DVPairs) GetPairs() []DVPair {
	if m != nil {
		return m.Pairs
	}
	return nil
}

// DVVTriplet is struct that just has a delegator-validator-validator triplet
// with no other data. It is intended to be used as a marshalable pointer. For
// example, a DVVTriplet can be used to construct the key to getting a
// Redelegation from state.
type DVVTriplet struct {
	DelegatorAddress    string `protobuf:"bytes,1,opt,name=delegator_address,json=delegatorAddress,proto3" json:"delegator_address,omitempty"`
	ValidatorSrcAddress string `protobuf:"bytes,2,opt,name=validator_src_address,json=validatorSrcAddress,proto3" json:"validator_src_address,omitempty"`
	ValidatorDstAddress string `protobuf:"bytes,3,opt,name=validator_dst_address,json=validatorDstAddress,proto3" json:"validator_dst_address,omitempty"`
}

func (m *DVVTriplet) Reset()      { *m = DVVTriplet{} }
func (*DVVTriplet) ProtoMessage() {}
func (*DVVTriplet) Descriptor() ([]byte, []int) {
	return fileDescriptor_64c30c6cf92913c9, []int{8}
}
func (m *DVVTriplet) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *DVVTriplet) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_DVVTriplet.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *DVVTriplet) XXX_Merge(src proto.Message) {
	xxx_messageInfo_DVVTriplet.Merge(m, src)
}
func (m *DVVTriplet) XXX_Size() int {
	return m.Size()
}
func (m *DVVTriplet) XXX_DiscardUnknown() {
	xxx_messageInfo_DVVTriplet.DiscardUnknown(m)
}

var xxx_messageInfo_DVVTriplet proto.InternalMessageInfo

// DVVTriplets defines an array of DVVTriplet objects.
type DVVTriplets struct {
	Triplets []DVVTriplet `protobuf:"bytes,1,rep,name=triplets,proto3" json:"triplets"`
}

func (m *DVVTriplets) Reset()         { *m = DVVTriplets{} }
func (m *DVVTriplets) String() string { return proto.CompactTextString(m) }
func (*DVVTriplets) ProtoMessage()    {}
func (*DVVTriplets) Descriptor() ([]byte, []int) {
	return fileDescriptor_64c30c6cf92913c9, []int{9}
}
func (m *DVVTriplets) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *DVVTriplets) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_DVVTriplets.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *DVVTriplets) XXX_Merge(src proto.Message) {
	xxx_messageInfo_DVVTriplets.Merge(m, src)
}
func (m *DVVTriplets) XXX_Size() int {
	return m.Size()
}
func (m *DVVTriplets) XXX_DiscardUnknown() {
	xxx_messageInfo_DVVTriplets.DiscardUnknown(m)
}

var xxx_messageInfo_DVVTriplets proto.InternalMessageInfo

func (m *DVVTriplets) GetTriplets() []DVVTriplet {
	if m != nil {
		return m.Triplets
	}
	return nil
}

// Delegation represents the bond with tokens held by an account. It is
// owned by one delegator, and is associated with the voting power of one
// validator.
type Delegation struct {
	// delegator_address is the bech32-encoded address of the delegator.
	DelegatorAddress string `protobuf:"bytes,1,opt,name=delegator_address,json=delegatorAddress,proto3" json:"delegator_address,omitempty"`
	// validator_address is the bech32-encoded address of the validator.
	ValidatorAddress string `protobuf:"bytes,2,opt,name=validator_address,json=validatorAddress,proto3" json:"validator_address,omitempty"`
	// shares define the delegation shares received.
	Shares github_com_cosmos_cosmos_sdk_types.Dec `protobuf:"bytes,3,opt,name=shares,proto3,customtype=github.com/cosmos/cosmos-sdk/types.Dec" json:"shares"`
}

func (m *Delegation) Reset()      { *m = Delegation{} }
func (*Delegation) ProtoMessage() {}
func (*Delegation) Descriptor() ([]byte, []int) {
	return fileDescriptor_64c30c6cf92913c9, []int{10}
}
func (m *Delegation) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *Delegation) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_Delegation.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *Delegation) XXX_Merge(src proto.Message) {
	xxx_messageInfo_Delegation.Merge(m, src)
}
func (m *Delegation) XXX_Size() int {
	return m.Size()
}
func (m *Delegation) XXX_DiscardUnknown() {
	xxx_messageInfo_Delegation.DiscardUnknown(m)
}

var xxx_messageInfo_Delegation proto.InternalMessageInfo

// UnbondingDelegation stores all of a single delegator's unbonding bonds
// for a single validator in an time-ordered list.
type UnbondingDelegation struct {
	// delegator_address is the bech32-encoded address of the delegator.
	DelegatorAddress string `protobuf:"bytes,1,opt,name=delegator_address,json=delegatorAddress,proto3" json:"delegator_address,omitempty"`
	// validator_address is the bech32-encoded address of the validator.
	ValidatorAddress string `protobuf:"bytes,2,opt,name=validator_address,json=validatorAddress,proto3" json:"validator_address,omitempty"`
	// entries are the unbonding delegation entries.
	Entries []UnbondingDelegationEntry `protobuf:"bytes,3,rep,name=entries,proto3" json:"entries"`
}

func (m *UnbondingDelegation) Reset()      { *m = UnbondingDelegation{} }
func (*UnbondingDelegation) ProtoMessage() {}
func (*UnbondingDelegation) Descriptor() ([]byte, []int) {
	return fileDescriptor_64c30c6cf92913c9, []int{11}
}
func (m *UnbondingDelegation) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *UnbondingDelegation) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_UnbondingDelegation.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *UnbondingDelegation) XXX_Merge(src proto.Message) {
	xxx_messageInfo_UnbondingDelegation.Merge(m, src)
}
func (m *UnbondingDelegation) XXX_Size() int {
	return m.Size()
}
func (m *UnbondingDelegation) XXX_DiscardUnknown() {
	xxx_messageInfo_UnbondingDelegation.DiscardUnknown(m)
}

var xxx_messageInfo_UnbondingDelegation proto.InternalMessageInfo

// UnbondingDelegationEntry defines an unbonding object with relevant metadata.
type UnbondingDelegationEntry struct {
	// creation_height is the height which the unbonding took place.
	CreationHeight int64 `protobuf:"varint,1,opt,name=creation_height,json=creationHeight,proto3" json:"creation_height,omitempty"`
	// completion_time is the unix time for unbonding completion.
	CompletionTime time.Time `protobuf:"bytes,2,opt,name=completion_time,json=completionTime,proto3,stdtime" json:"completion_time"`
	// initial_balance defines the tokens initially scheduled to receive at completion.
	InitialBalance github_com_cosmos_cosmos_sdk_types.Int `protobuf:"bytes,3,opt,name=initial_balance,json=initialBalance,proto3,customtype=github.com/cosmos/cosmos-sdk/types.Int" json:"initial_balance"`
	// balance defines the tokens to receive at completion.
	Balance github_com_cosmos_cosmos_sdk_types.Int `protobuf:"bytes,4,opt,name=balance,proto3,customtype=github.com/cosmos/cosmos-sdk/types.Int" json:"balance"`
	// Incrementing id that uniquely identifies this entry
	UnbondingId uint64 `protobuf:"varint,5,opt,name=unbonding_id,json=unbondingId,proto3" json:"unbonding_id,omitempty"`
	// Strictly positive if this entry's unbonding has been stopped by external modules
	UnbondingOnHoldRefCount int64 `protobuf:"varint,6,opt,name=unbonding_on_hold_ref_count,json=unbondingOnHoldRefCount,proto3" json:"unbonding_on_hold_ref_count,omitempty"`
}

func (m *UnbondingDelegationEntry) Reset()      { *m = UnbondingDelegationEntry{} }
func (*UnbondingDelegationEntry) ProtoMessage() {}
func (*UnbondingDelegationEntry) Descriptor() ([]byte, []int) {
	return fileDescriptor_64c30c6cf92913c9, []int{12}
}
func (m *UnbondingDelegationEntry) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *UnbondingDelegationEntry) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_UnbondingDelegationEntry.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *UnbondingDelegationEntry) XXX_Merge(src proto.Message) {
	xxx_messageInfo_UnbondingDelegationEntry.Merge(m, src)
}
func (m *UnbondingDelegationEntry) XXX_Size() int {
	return m.Size()
}
func (m *UnbondingDelegationEntry) XXX_DiscardUnknown() {
	xxx_messageInfo_UnbondingDelegationEntry.DiscardUnknown(m)
}

var xxx_messageInfo_UnbondingDelegationEntry proto.InternalMessageInfo

func (m *UnbondingDelegationEntry) GetCreationHeight() int64 {
	if m != nil {
		return m.CreationHeight
	}
	return 0
}

func (m *UnbondingDelegationEntry) GetCompletionTime() time.Time {
	if m != nil {
		return m.CompletionTime
	}
	return time.Time{}
}

func (m *UnbondingDelegationEntry) GetUnbondingId() uint64 {
	if m != nil {
		return m.UnbondingId
	}
	return 0
}

func (m *UnbondingDelegationEntry) GetUnbondingOnHoldRefCount() int64 {
	if m != nil {
		return m.UnbondingOnHoldRefCount
	}
	return 0
}

// RedelegationEntry defines a redelegation object with relevant metadata.
type RedelegationEntry struct {
	// creation_height  defines the height which the redelegation took place.
	CreationHeight int64 `protobuf:"varint,1,opt,name=creation_height,json=creationHeight,proto3" json:"creation_height,omitempty"`
	// completion_time defines the unix time for redelegation completion.
	CompletionTime time.Time `protobuf:"bytes,2,opt,name=completion_time,json=completionTime,proto3,stdtime" json:"completion_time"`
	// initial_balance defines the initial balance when redelegation started.
	InitialBalance github_com_cosmos_cosmos_sdk_types.Int `protobuf:"bytes,3,opt,name=initial_balance,json=initialBalance,proto3,customtype=github.com/cosmos/cosmos-sdk/types.Int" json:"initial_balance"`
	// shares_dst is the amount of destination-validator shares created by redelegation.
	SharesDst github_com_cosmos_cosmos_sdk_types.Dec `protobuf:"bytes,4,opt,name=shares_dst,json=sharesDst,proto3,customtype=github.com/cosmos/cosmos-sdk/types.Dec" json:"shares_dst"`
	// Incrementing id that uniquely identifies this entry
	UnbondingId uint64 `protobuf:"varint,5,opt,name=unbonding_id,json=unbondingId,proto3" json:"unbonding_id,omitempty"`
	// Strictly positive if this entry's unbonding has been stopped by external modules
	UnbondingOnHoldRefCount int64 `protobuf:"varint,6,opt,name=unbonding_on_hold_ref_count,json=unbondingOnHoldRefCount,proto3" json:"unbonding_on_hold_ref_count,omitempty"`
}

func (m *RedelegationEntry) Reset()      { *m = RedelegationEntry{} }
func (*RedelegationEntry) ProtoMessage() {}
func (*RedelegationEntry) Descriptor() ([]byte, []int) {
	return fileDescriptor_64c30c6cf92913c9, []int{13}
}
func (m *RedelegationEntry) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *RedelegationEntry) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_RedelegationEntry.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *RedelegationEntry) XXX_Merge(src proto.Message) {
	xxx_messageInfo_RedelegationEntry.Merge(m, src)
}
func (m *RedelegationEntry) XXX_Size() int {
	return m.Size()
}
func (m *RedelegationEntry) XXX_DiscardUnknown() {
	xxx_messageInfo_RedelegationEntry.DiscardUnknown(m)
}

var xxx_messageInfo_RedelegationEntry proto.InternalMessageInfo

func (m *RedelegationEntry) GetCreationHeight() int64 {
	if m != nil {
		return m.CreationHeight
	}
	return 0
}

func (m *RedelegationEntry) GetCompletionTime() time.Time {
	if m != nil {
		return m.CompletionTime
	}
	return time.Time{}
}

func (m *RedelegationEntry) GetUnbondingId() uint64 {
	if m != nil {
		return m.UnbondingId
	}
	return 0
}

func (m *RedelegationEntry) GetUnbondingOnHoldRefCount() int64 {
	if m != nil {
		return m.UnbondingOnHoldRefCount
	}
	return 0
}

// Redelegation contains the list of a particular delegator's redelegating bonds
// from a particular source validator to a particular destination validator.
type Redelegation struct {
	// delegator_address is the bech32-encoded address of the delegator.
	DelegatorAddress string `protobuf:"bytes,1,opt,name=delegator_address,json=delegatorAddress,proto3" json:"delegator_address,omitempty"`
	// validator_src_address is the validator redelegation source operator address.
	ValidatorSrcAddress string `protobuf:"bytes,2,opt,name=validator_src_address,json=validatorSrcAddress,proto3" json:"validator_src_address,omitempty"`
	// validator_dst_address is the validator redelegation destination operator address.
	ValidatorDstAddress string `protobuf:"bytes,3,opt,name=validator_dst_address,json=validatorDstAddress,proto3" json:"validator_dst_address,omitempty"`
	// entries are the redelegation entries.
	Entries []RedelegationEntry `protobuf:"bytes,4,rep,name=entries,proto3" json:"entries"`
}

func (m *Redelegation) Reset()      { *m = Redelegation{} }
func (*Redelegation) ProtoMessage() {}
func (*Redelegation) Descriptor() ([]byte, []int) {
	return fileDescriptor_64c30c6cf92913c9, []int{14}
}
func (m *Redelegation) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *Redelegation) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_Redelegation.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *Redelegation) XXX_Merge(src proto.Message) {
	xxx_messageInfo_Redelegation.Merge(m, src)
}
func (m *Redelegation) XXX_Size() int {
	return m.Size()
}
func (m *Redelegation) XXX_DiscardUnknown() {
	xxx_messageInfo_Redelegation.DiscardUnknown(m)
}

var xxx_messageInfo_Redelegation proto.InternalMessageInfo

// Params defines the parameters for the x/staking module.
type Params struct {
	// unbonding_time is the time duration of unbonding.
	UnbondingTime time.Duration `protobuf:"bytes,1,opt,name=unbonding_time,json=unbondingTime,proto3,stdduration" json:"unbonding_time"`
	// max_validators is the maximum number of validators.
	MaxValidators uint32 `protobuf:"varint,2,opt,name=max_validators,json=maxValidators,proto3" json:"max_validators,omitempty"`
	// max_entries is the max entries for either unbonding delegation or redelegation (per pair/trio).
	MaxEntries uint32 `protobuf:"varint,3,opt,name=max_entries,json=maxEntries,proto3" json:"max_entries,omitempty"`
	// historical_entries is the number of historical entries to persist.
	HistoricalEntries uint32 `protobuf:"varint,4,opt,name=historical_entries,json=historicalEntries,proto3" json:"historical_entries,omitempty"`
	// bond_denom defines the bondable coin denomination.
	BondDenom string `protobuf:"bytes,5,opt,name=bond_denom,json=bondDenom,proto3" json:"bond_denom,omitempty"`
	// min_commission_rate is the chain-wide minimum commission rate that a validator can charge their delegators
	MinCommissionRate github_com_cosmos_cosmos_sdk_types.Dec `protobuf:"bytes,6,opt,name=min_commission_rate,json=minCommissionRate,proto3,customtype=github.com/cosmos/cosmos-sdk/types.Dec" json:"min_commission_rate" yaml:"min_commission_rate"`
}

func (m *Params) Reset()      { *m = Params{} }
func (*Params) ProtoMessage() {}
func (*Params) Descriptor() ([]byte, []int) {
	return fileDescriptor_64c30c6cf92913c9, []int{15}
}
func (m *Params) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *Params) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_Params.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *Params) XXX_Merge(src proto.Message) {
	xxx_messageInfo_Params.Merge(m, src)
}
func (m *Params) XXX_Size() int {
	return m.Size()
}
func (m *Params) XXX_DiscardUnknown() {
	xxx_messageInfo_Params.DiscardUnknown(m)
}

var xxx_messageInfo_Params proto.InternalMessageInfo

func (m *Params) GetUnbondingTime() time.Duration {
	if m != nil {
		return m.UnbondingTime
	}
	return 0
}

func (m *Params) GetMaxValidators() uint32 {
	if m != nil {
		return m.MaxValidators
	}
	return 0
}

func (m *Params) GetMaxEntries() uint32 {
	if m != nil {
		return m.MaxEntries
	}
	return 0
}

func (m *Params) GetHistoricalEntries() uint32 {
	if m != nil {
		return m.HistoricalEntries
	}
	return 0
}

func (m *Params) GetBondDenom() string {
	if m != nil {
		return m.BondDenom
	}
	return ""
}

// DelegationResponse is equivalent to Delegation except that it contains a
// balance in addition to shares which is more suitable for client responses.
type DelegationResponse struct {
	Delegation Delegation  `protobuf:"bytes,1,opt,name=delegation,proto3" json:"delegation"`
	Balance    types2.Coin `protobuf:"bytes,2,opt,name=balance,proto3" json:"balance"`
}

func (m *DelegationResponse) Reset()      { *m = DelegationResponse{} }
func (*DelegationResponse) ProtoMessage() {}
func (*DelegationResponse) Descriptor() ([]byte, []int) {
	return fileDescriptor_64c30c6cf92913c9, []int{16}
}
func (m *DelegationResponse) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *DelegationResponse) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_DelegationResponse.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *DelegationResponse) XXX_Merge(src proto.Message) {
	xxx_messageInfo_DelegationResponse.Merge(m, src)
}
func (m *DelegationResponse) XXX_Size() int {
	return m.Size()
}
func (m *DelegationResponse) XXX_DiscardUnknown() {
	xxx_messageInfo_DelegationResponse.DiscardUnknown(m)
}

var xxx_messageInfo_DelegationResponse proto.InternalMessageInfo

func (m *DelegationResponse) GetDelegation() Delegation {
	if m != nil {
		return m.Delegation
	}
	return Delegation{}
}

func (m *DelegationResponse) GetBalance() types2.Coin {
	if m != nil {
		return m.Balance
	}
	return types2.Coin{}
}

// RedelegationEntryResponse is equivalent to a RedelegationEntry except that it
// contains a balance in addition to shares which is more suitable for client
// responses.
type RedelegationEntryResponse struct {
	RedelegationEntry RedelegationEntry                      `protobuf:"bytes,1,opt,name=redelegation_entry,json=redelegationEntry,proto3" json:"redelegation_entry"`
	Balance           github_com_cosmos_cosmos_sdk_types.Int `protobuf:"bytes,4,opt,name=balance,proto3,customtype=github.com/cosmos/cosmos-sdk/types.Int" json:"balance"`
}

func (m *RedelegationEntryResponse) Reset()         { *m = RedelegationEntryResponse{} }
func (m *RedelegationEntryResponse) String() string { return proto.CompactTextString(m) }
func (*RedelegationEntryResponse) ProtoMessage()    {}
func (*RedelegationEntryResponse) Descriptor() ([]byte, []int) {
	return fileDescriptor_64c30c6cf92913c9, []int{17}
}
func (m *RedelegationEntryResponse) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *RedelegationEntryResponse) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_RedelegationEntryResponse.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *RedelegationEntryResponse) XXX_Merge(src proto.Message) {
	xxx_messageInfo_RedelegationEntryResponse.Merge(m, src)
}
func (m *RedelegationEntryResponse) XXX_Size() int {
	return m.Size()
}
func (m *RedelegationEntryResponse) XXX_DiscardUnknown() {
	xxx_messageInfo_RedelegationEntryResponse.DiscardUnknown(m)
}

var xxx_messageInfo_RedelegationEntryResponse proto.InternalMessageInfo

func (m *RedelegationEntryResponse) GetRedelegationEntry() RedelegationEntry {
	if m != nil {
		return m.RedelegationEntry
	}
	return RedelegationEntry{}
}

// RedelegationResponse is equivalent to a Redelegation except that its entries
// contain a balance in addition to shares which is more suitable for client
// responses.
type RedelegationResponse struct {
	Redelegation Redelegation                `protobuf:"bytes,1,opt,name=redelegation,proto3" json:"redelegation"`
	Entries      []RedelegationEntryResponse `protobuf:"bytes,2,rep,name=entries,proto3" json:"entries"`
}

func (m *RedelegationResponse) Reset()         { *m = RedelegationResponse{} }
func (m *RedelegationResponse) String() string { return proto.CompactTextString(m) }
func (*RedelegationResponse) ProtoMessage()    {}
func (*RedelegationResponse) Descriptor() ([]byte, []int) {
	return fileDescriptor_64c30c6cf92913c9, []int{18}
}
func (m *RedelegationResponse) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *RedelegationResponse) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_RedelegationResponse.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *RedelegationResponse) XXX_Merge(src proto.Message) {
	xxx_messageInfo_RedelegationResponse.Merge(m, src)
}
func (m *RedelegationResponse) XXX_Size() int {
	return m.Size()
}
func (m *RedelegationResponse) XXX_DiscardUnknown() {
	xxx_messageInfo_RedelegationResponse.DiscardUnknown(m)
}

var xxx_messageInfo_RedelegationResponse proto.InternalMessageInfo

func (m *RedelegationResponse) GetRedelegation() Redelegation {
	if m != nil {
		return m.Redelegation
	}
	return Redelegation{}
}

func (m *RedelegationResponse) GetEntries() []RedelegationEntryResponse {
	if m != nil {
		return m.Entries
	}
	return nil
}

// Pool is used for tracking bonded and not-bonded token supply of the bond
// denomination.
type Pool struct {
	NotBondedTokens github_com_cosmos_cosmos_sdk_types.Int `protobuf:"bytes,1,opt,name=not_bonded_tokens,json=notBondedTokens,proto3,customtype=github.com/cosmos/cosmos-sdk/types.Int" json:"not_bonded_tokens"`
	BondedTokens    github_com_cosmos_cosmos_sdk_types.Int `protobuf:"bytes,2,opt,name=bonded_tokens,json=bondedTokens,proto3,customtype=github.com/cosmos/cosmos-sdk/types.Int" json:"bonded_tokens"`
}

func (m *Pool) Reset()         { *m = Pool{} }
func (m *Pool) String() string { return proto.CompactTextString(m) }
func (*Pool) ProtoMessage()    {}
func (*Pool) Descriptor() ([]byte, []int) {
	return fileDescriptor_64c30c6cf92913c9, []int{19}
}
func (m *Pool) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *Pool) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_Pool.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *Pool) XXX_Merge(src proto.Message) {
	xxx_messageInfo_Pool.Merge(m, src)
}
func (m *Pool) XXX_Size() int {
	return m.Size()
}
func (m *Pool) XXX_DiscardUnknown() {
	xxx_messageInfo_Pool.DiscardUnknown(m)
}

var xxx_messageInfo_Pool proto.InternalMessageInfo

// ValidatorUpdates defines an array of abci.ValidatorUpdate objects.
// TODO: explore moving this to proto/cosmos/base to separate modules from tendermint dependence
type ValidatorUpdates struct {
	Updates []types3.ValidatorUpdate `protobuf:"bytes,1,rep,name=updates,proto3" json:"updates"`
}

func (m *ValidatorUpdates) Reset()         { *m = ValidatorUpdates{} }
func (m *ValidatorUpdates) String() string { return proto.CompactTextString(m) }
func (*ValidatorUpdates) ProtoMessage()    {}
func (*ValidatorUpdates) Descriptor() ([]byte, []int) {
	return fileDescriptor_64c30c6cf92913c9, []int{20}
}
func (m *ValidatorUpdates) XXX_Unmarshal(b []byte) error {
	return m.Unmarshal(b)
}
func (m *ValidatorUpdates) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	if deterministic {
		return xxx_messageInfo_ValidatorUpdates.Marshal(b, m, deterministic)
	} else {
		b = b[:cap(b)]
		n, err := m.MarshalToSizedBuffer(b)
		if err != nil {
			return nil, err
		}
		return b[:n], nil
	}
}
func (m *ValidatorUpdates) XXX_Merge(src proto.Message) {
	xxx_messageInfo_ValidatorUpdates.Merge(m, src)
}
func (m *ValidatorUpdates) XXX_Size() int {
	return m.Size()
}
func (m *ValidatorUpdates) XXX_DiscardUnknown() {
	xxx_messageInfo_ValidatorUpdates.DiscardUnknown(m)
}

var xxx_messageInfo_ValidatorUpdates proto.InternalMessageInfo

func (m *ValidatorUpdates) GetUpdates() []types3.ValidatorUpdate {
	if m != nil {
		return m.Updates
	}
	return nil
}

func init() {
	proto.RegisterEnum("cosmos.staking.v1beta1.BondStatus", BondStatus_name, BondStatus_value)
	proto.RegisterEnum("cosmos.staking.v1beta1.Infraction", Infraction_name, Infraction_value)
	proto.RegisterType((*HistoricalInfo)(nil), "cosmos.staking.v1beta1.HistoricalInfo")
	proto.RegisterType((*CommissionRates)(nil), "cosmos.staking.v1beta1.CommissionRates")
	proto.RegisterType((*Commission)(nil), "cosmos.staking.v1beta1.Commission")
	proto.RegisterType((*Description)(nil), "cosmos.staking.v1beta1.Description")
	proto.RegisterType((*Validator)(nil), "cosmos.staking.v1beta1.Validator")
	proto.RegisterType((*ValAddresses)(nil), "cosmos.staking.v1beta1.ValAddresses")
	proto.RegisterType((*DVPair)(nil), "cosmos.staking.v1beta1.DVPair")
	proto.RegisterType((*DVPairs)(nil), "cosmos.staking.v1beta1.DVPairs")
	proto.RegisterType((*DVVTriplet)(nil), "cosmos.staking.v1beta1.DVVTriplet")
	proto.RegisterType((*DVVTriplets)(nil), "cosmos.staking.v1beta1.DVVTriplets")
	proto.RegisterType((*Delegation)(nil), "cosmos.staking.v1beta1.Delegation")
	proto.RegisterType((*UnbondingDelegation)(nil), "cosmos.staking.v1beta1.UnbondingDelegation")
	proto.RegisterType((*UnbondingDelegationEntry)(nil), "cosmos.staking.v1beta1.UnbondingDelegationEntry")
	proto.RegisterType((*RedelegationEntry)(nil), "cosmos.staking.v1beta1.RedelegationEntry")
	proto.RegisterType((*Redelegation)(nil), "cosmos.staking.v1beta1.Redelegation")
	proto.RegisterType((*Params)(nil), "cosmos.staking.v1beta1.Params")
	proto.RegisterType((*DelegationResponse)(nil), "cosmos.staking.v1beta1.DelegationResponse")
	proto.RegisterType((*RedelegationEntryResponse)(nil), "cosmos.staking.v1beta1.RedelegationEntryResponse")
	proto.RegisterType((*RedelegationResponse)(nil), "cosmos.staking.v1beta1.RedelegationResponse")
	proto.RegisterType((*Pool)(nil), "cosmos.staking.v1beta1.Pool")
	proto.RegisterType((*ValidatorUpdates)(nil), "cosmos.staking.v1beta1.ValidatorUpdates")
}

func init() {
	proto.RegisterFile("cosmos/staking/v1beta1/staking.proto", fileDescriptor_64c30c6cf92913c9)
}

var fileDescriptor_64c30c6cf92913c9 = []byte{
	// 1843 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xe4, 0x58, 0x4d, 0x6c, 0x1b, 0xc7,
	0x15, 0xe6, 0x52, 0x0c, 0x25, 0x3d, 0x4a, 0x22, 0x35, 0x76, 0x6c, 0x9a, 0x69, 0x45, 0x86, 0x49,
	0x13, 0x25, 0x88, 0xa9, 0x5a, 0x05, 0x02, 0x54, 0x08, 0xd0, 0x9a, 0x22, 0x1d, 0xb1, 0xb6, 0x65,
	0x65, 0x49, 0x29, 0xe8, 0xef, 0x62, 0xb8, 0x3b, 0xa2, 0xa6, 0x5a, 0xce, 0x12, 0x3b, 0x43, 0x57,
	0x04, 0x5a, 0xa0, 0x40, 0x2f, 0xa9, 0x4f, 0x39, 0xe6, 0x62, 0xc0, 0x40, 0x7a, 0xcc, 0x31, 0xe8,
	0xa1, 0x2d, 0xd0, 0x6b, 0x90, 0x93, 0x91, 0x53, 0x5b, 0x14, 0x6a, 0x61, 0x5f, 0x8a, 0x9e, 0x8a,
	0xdc, 0x5b, 0x14, 0x33, 0x3b, 0xfb, 0x23, 0x52, 0x92, 0xa5, 0x40, 0x2d, 0x02, 0xe4, 0x22, 0x71,
	0x66, 0xde, 0xfb, 0xf6, 0xbd, 0xef, 0xfd, 0xcc, 0x0f, 0xbc, 0x6c, 0x7b, 0xbc, 0xef, 0xf1, 0x15,
	0x2e, 0xf0, 0x3e, 0x65, 0xbd, 0x95, 0xfb, 0x37, 0xba, 0x44, 0xe0, 0x1b, 0xe1, 0xb8, 0x36, 0xf0,
	0x3d, 0xe1, 0xa1, 0x2b, 0x81, 0x54, 0x2d, 0x9c, 0xd5, 0x52, 0xa5, 0xcb, 0x3d, 0xaf, 0xe7, 0x29,
	0x91, 0x15, 0xf9, 0x2b, 0x90, 0x2e, 0x5d, 0xeb, 0x79, 0x5e, 0xcf, 0x25, 0x2b, 0x6a, 0xd4, 0x1d,
	0xee, 0xae, 0x60, 0x36, 0xd2, 0x4b, 0x4b, 0xe3, 0x4b, 0xce, 0xd0, 0xc7, 0x82, 0x7a, 0x4c, 0xaf,
	0x97, 0xc7, 0xd7, 0x05, 0xed, 0x13, 0x2e, 0x70, 0x7f, 0x10, 0x62, 0x07, 0x96, 0x58, 0xc1, 0x47,
	0xb5, 0x59, 0x1a, 0x5b, 0xbb, 0xd2, 0xc5, 0x9c, 0x44, 0x7e, 0xd8, 0x1e, 0x0d, 0xb1, 0xbf, 0x26,
	0x08, 0x73, 0x88, 0xdf, 0xa7, 0x4c, 0xac, 0x88, 0xd1, 0x80, 0xf0, 0xe0, 0xaf, 0x5e, 0x7d, 0x21,
	0xb1, 0x8a, 0xbb, 0x36, 0x4d, 0x2e, 0x56, 0x7f, 0x6d, 0xc0, 0xc2, 0x06, 0xe5, 0xc2, 0xf3, 0xa9,
	0x8d, 0xdd, 0x16, 0xdb, 0xf5, 0xd0, 0x9b, 0x90, 0xdd, 0x23, 0xd8, 0x21, 0x7e, 0xd1, 0xa8, 0x18,
	0xcb, 0xb9, 0xd5, 0x62, 0x2d, 0x06, 0xa8, 0x05, 0xba, 0x1b, 0x6a, 0xbd, 0x9e, 0xf9, 0xe4, 0xb0,
	0x9c, 0x32, 0xb5, 0x34, 0xfa, 0x0e, 0x64, 0xef, 0x63, 0x97, 0x13, 0x51, 0x4c, 0x57, 0xa6, 0x96,
	0x73, 0xab, 0x2f, 0xd6, 0x8e, 0xe7, 0xb6, 0xb6, 0x83, 0x5d, 0xea, 0x60, 0xe1, 0x45, 0x00, 0x81,
	0x5a, 0xf5, 0xa3, 0x34, 0xe4, 0xd7, 0xbd, 0x7e, 0x9f, 0x72, 0x4e, 0x3d, 0x66, 0x62, 0x41, 0x38,
	0xda, 0x82, 0x8c, 0x8f, 0x05, 0x51, 0xa6, 0xcc, 0xd6, 0xdf, 0x92, 0xf2, 0x7f, 0x39, 0x2c, 0xbf,
	0xd2, 0xa3, 0x62, 0x6f, 0xd8, 0xad, 0xd9, 0x5e, 0x5f, 0x33, 0xa5, 0xff, 0x5d, 0xe7, 0xce, 0xbe,
	0xf6, 0xaf, 0x41, 0xec, 0xcf, 0x3e, 0xbe, 0x0e, 0xda, 0x86, 0x06, 0xb1, 0x4d, 0x85, 0x84, 0xde,
	0x85, 0x99, 0x3e, 0x3e, 0xb0, 0x14, 0x6a, 0xfa, 0x02, 0x50, 0xa7, 0xfb, 0xf8, 0x40, 0xda, 0x8a,
	0x1c, 0xc8, 0x4b, 0x60, 0x7b, 0x0f, 0xb3, 0x1e, 0x09, 0xf0, 0xa7, 0x2e, 0x00, 0x7f, 0xbe, 0x8f,
	0x0f, 0xd6, 0x15, 0xa6, 0xfc, 0xca, 0xda, 0xcc, 0x07, 0x8f, 0xca, 0xa9, 0x7f, 0x3c, 0x2a, 0x1b,
	0xd5, 0xdf, 0x1b, 0x00, 0x31, 0x5d, 0xe8, 0x47, 0x50, 0xb0, 0xa3, 0x91, 0xfa, 0x3c, 0xd7, 0x01,
	0x7c, 0xf5, 0xa4, 0x40, 0x8c, 0x91, 0x5d, 0x9f, 0x91, 0x86, 0x3e, 0x3e, 0x2c, 0x1b, 0x66, 0xde,
	0x1e, 0x8b, 0x43, 0x13, 0x72, 0xc3, 0x81, 0x83, 0x05, 0xb1, 0x64, 0xde, 0x2a, 0xe2, 0x72, 0xab,
	0xa5, 0x5a, 0x90, 0xd4, 0xb5, 0x30, 0xa9, 0x6b, 0x9d, 0x30, 0xa9, 0x03, 0xac, 0xf7, 0xff, 0x56,
	0x36, 0x4c, 0x08, 0x14, 0xe5, 0x52, 0xc2, 0xfa, 0x8f, 0x0c, 0xc8, 0x35, 0x08, 0xb7, 0x7d, 0x3a,
	0x90, 0x55, 0x82, 0x8a, 0x30, 0xdd, 0xf7, 0x18, 0xdd, 0xd7, 0x69, 0x37, 0x6b, 0x86, 0x43, 0x54,
	0x82, 0x19, 0xea, 0x10, 0x26, 0xa8, 0x18, 0x05, 0x01, 0x33, 0xa3, 0xb1, 0xd4, 0xfa, 0x19, 0xe9,
	0x72, 0x1a, 0x72, 0x6d, 0x86, 0x43, 0xf4, 0x1a, 0x14, 0x38, 0xb1, 0x87, 0x3e, 0x15, 0x23, 0xcb,
	0xf6, 0x98, 0xc0, 0xb6, 0x28, 0x66, 0x94, 0x48, 0x3e, 0x9c, 0x5f, 0x0f, 0xa6, 0x25, 0x88, 0x43,
	0x04, 0xa6, 0x2e, 0x2f, 0x3e, 0x17, 0x80, 0xe8, 0x61, 0xd2, 0xdc, 0x69, 0x98, 0x8d, 0xf2, 0x16,
	0xad, 0x43, 0xc1, 0x1b, 0x10, 0x5f, 0xfe, 0xb6, 0xb0, 0xe3, 0xf8, 0x84, 0x73, 0x9d, 0xa1, 0xc5,
	0xcf, 0x3e, 0xbe, 0x7e, 0x59, 0xd3, 0x7d, 0x33, 0x58, 0x69, 0x0b, 0x9f, 0xb2, 0x9e, 0x99, 0x0f,
	0x35, 0xf4, 0x34, 0xfa, 0xbe, 0x0c, 0x18, 0xe3, 0x84, 0xf1, 0x21, 0xb7, 0x06, 0xc3, 0xee, 0x3e,
	0x19, 0x69, 0x5e, 0x2f, 0x4f, 0xf0, 0x7a, 0x93, 0x8d, 0xea, 0xc5, 0x4f, 0x63, 0x68, 0xdb, 0x1f,
	0x0d, 0x84, 0x57, 0xdb, 0x1a, 0x76, 0x6f, 0x93, 0x91, 0x8c, 0x96, 0xc6, 0xd9, 0x52, 0x30, 0xe8,
	0x0a, 0x64, 0x7f, 0x8a, 0xa9, 0x4b, 0x1c, 0xc5, 0xca, 0x8c, 0xa9, 0x47, 0x68, 0x0d, 0xb2, 0x5c,
	0x60, 0x31, 0xe4, 0x8a, 0x8a, 0x85, 0xd5, 0xea, 0x49, 0x99, 0x51, 0xf7, 0x98, 0xd3, 0x56, 0x92,
	0xa6, 0xd6, 0x40, 0x1d, 0xc8, 0x0a, 0x6f, 0x9f, 0x30, 0x4d, 0xd2, 0xb9, 0xb2, 0xba, 0xc5, 0x44,
	0x22, 0xab, 0x5b, 0x4c, 0x98, 0x1a, 0x0b, 0xf5, 0xa0, 0xe0, 0x10, 0x97, 0xf4, 0x14, 0x95, 0x7c,
	0x0f, 0xfb, 0x84, 0x17, 0xb3, 0x17, 0x50, 0x35, 0xf9, 0x08, 0xb5, 0xad, 0x40, 0xd1, 0x6d, 0xc8,
	0x39, 0x71, 0xba, 0x15, 0xa7, 0x15, 0xd1, 0x2f, 0x9d, 0xe4, 0x7f, 0x22, 0x33, 0x75, 0x93, 0x4a,
	0x6a, 0xcb, 0xe4, 0x1a, 0xb2, 0xae, 0xc7, 0x1c, 0xca, 0x7a, 0xd6, 0x1e, 0xa1, 0xbd, 0x3d, 0x51,
	0x9c, 0xa9, 0x18, 0xcb, 0x53, 0x66, 0x3e, 0x9a, 0xdf, 0x50, 0xd3, 0xe8, 0x36, 0x2c, 0xc4, 0xa2,
	0xaa, 0x76, 0x66, 0xcf, 0x51, 0x3b, 0xf3, 0x91, 0xae, 0x5c, 0x45, 0x1b, 0x00, 0x71, 0x61, 0x16,
	0x41, 0x01, 0x55, 0x9f, 0x5d, 0xdd, 0xda, 0x85, 0x84, 0x2e, 0x72, 0xe1, 0x52, 0x9f, 0x32, 0x8b,
	0x13, 0x77, 0xd7, 0xd2, 0x54, 0x49, 0xc8, 0xdc, 0x05, 0x84, 0x76, 0xb1, 0x4f, 0x59, 0x9b, 0xb8,
	0xbb, 0x8d, 0x08, 0x16, 0xbd, 0x05, 0x2f, 0xc4, 0x24, 0x78, 0xcc, 0xda, 0xf3, 0x5c, 0xc7, 0xf2,
	0xc9, 0xae, 0x65, 0x7b, 0x43, 0x26, 0x8a, 0x73, 0x8a, 0xba, 0xab, 0x91, 0xc8, 0x3d, 0xb6, 0xe1,
	0xb9, 0x8e, 0x49, 0x76, 0xd7, 0xe5, 0x32, 0x7a, 0x09, 0x62, 0x1a, 0x2c, 0xea, 0xf0, 0xe2, 0x7c,
	0x65, 0x6a, 0x39, 0x63, 0xce, 0x45, 0x93, 0x2d, 0x87, 0xaf, 0xcd, 0xbd, 0xf7, 0xa8, 0x9c, 0xd2,
	0xe5, 0x9a, 0xaa, 0x6e, 0xc1, 0xdc, 0x0e, 0x76, 0x75, 0xa5, 0x11, 0x8e, 0xde, 0x84, 0x59, 0x1c,
	0x0e, 0x8a, 0x46, 0x65, 0xea, 0xd4, 0x4a, 0x8d, 0x45, 0x83, 0x06, 0xf0, 0xcb, 0xbf, 0x56, 0x8c,
	0xea, 0x6f, 0x0c, 0xc8, 0x36, 0x76, 0xb6, 0x30, 0xf5, 0x51, 0x13, 0x16, 0xe3, 0x9c, 0x3d, 0x6b,
	0xf9, 0xc7, 0x69, 0x1e, 0xd6, 0x7f, 0x13, 0x16, 0xef, 0x87, 0x1d, 0x25, 0x82, 0x49, 0x3f, 0x0b,
	0x26, 0x52, 0xd1, 0xf3, 0x63, 0x8e, 0x37, 0x61, 0x3a, 0xb0, 0x92, 0xa3, 0x35, 0x78, 0x6e, 0x20,
	0x7f, 0x28, 0x7f, 0x73, 0xab, 0x4b, 0x27, 0xe6, 0xba, 0x92, 0xd7, 0x39, 0x12, 0xa8, 0x54, 0xff,
	0x6d, 0x00, 0x34, 0x76, 0x76, 0x3a, 0x3e, 0x1d, 0xb8, 0x44, 0x5c, 0x94, 0xc7, 0x77, 0xe0, 0xf9,
	0xd8, 0x63, 0xee, 0xdb, 0x67, 0xf6, 0xfa, 0x52, 0xa4, 0xd6, 0xf6, 0xed, 0x63, 0xd1, 0x1c, 0x2e,
	0x22, 0xb4, 0xa9, 0x33, 0xa3, 0x35, 0xb8, 0x38, 0x9e, 0xc6, 0x36, 0xe4, 0x62, 0xf7, 0x39, 0x6a,
	0xc0, 0x8c, 0xd0, 0xbf, 0x35, 0x9b, 0xd5, 0x93, 0xd9, 0x0c, 0xd5, 0x34, 0xa3, 0x91, 0x66, 0xf5,
	0x3f, 0x92, 0xd4, 0xb8, 0x28, 0xbe, 0x54, 0x69, 0x24, 0xdb, 0xbb, 0x6e, 0xbf, 0x17, 0x71, 0x68,
	0xd1, 0x58, 0x63, 0xac, 0xfe, 0x2a, 0x0d, 0x97, 0xb6, 0xc3, 0xa2, 0xfd, 0xd2, 0x32, 0xb1, 0x05,
	0xd3, 0x84, 0x09, 0x9f, 0x2a, 0x2a, 0x64, 0xac, 0xbf, 0x79, 0x52, 0xac, 0x8f, 0xf1, 0xa5, 0xc9,
	0x84, 0x3f, 0xd2, 0x91, 0x0f, 0x61, 0xc6, 0x58, 0xf8, 0xc3, 0x14, 0x14, 0x4f, 0xd2, 0x44, 0xaf,
	0x42, 0xde, 0xf6, 0x89, 0x9a, 0x08, 0x37, 0x16, 0x43, 0x75, 0xc7, 0x85, 0x70, 0x5a, 0xef, 0x2b,
	0x77, 0x41, 0x9e, 0xd1, 0x64, 0x62, 0x49, 0xd1, 0x73, 0x1f, 0xca, 0x16, 0x62, 0x65, 0xb5, 0xb3,
	0x10, 0xc8, 0x53, 0x46, 0x05, 0xc5, 0xae, 0xd5, 0xc5, 0x2e, 0x66, 0xf6, 0x17, 0x39, 0xbc, 0x4e,
	0xee, 0x05, 0x0b, 0x1a, 0xb4, 0x1e, 0x60, 0xa2, 0x1d, 0x98, 0x0e, 0xe1, 0x33, 0x17, 0x00, 0x1f,
	0x82, 0xa1, 0x17, 0x61, 0x2e, 0xb9, 0x45, 0xa8, 0x23, 0x4a, 0xc6, 0xcc, 0x25, 0x76, 0x88, 0x67,
	0xed, 0x41, 0xd9, 0x53, 0xf7, 0xa0, 0xc4, 0x49, 0xf0, 0x77, 0x53, 0xb0, 0x68, 0x12, 0xe7, 0xab,
	0x15, 0xb7, 0x1f, 0x02, 0x04, 0x15, 0x2d, 0x1b, 0xed, 0x17, 0x08, 0xdd, 0x64, 0x87, 0x98, 0x0d,
	0xf0, 0x1a, 0x5c, 0xfc, 0x3f, 0x83, 0xf7, 0x69, 0x1a, 0xe6, 0x92, 0xc1, 0xfb, 0x0a, 0xec, 0x6c,
	0xa8, 0x15, 0xf7, 0xb3, 0x8c, 0xea, 0x67, 0xaf, 0x9d, 0xd4, 0xcf, 0x26, 0xd2, 0xfa, 0xf4, 0x46,
	0xf6, 0x79, 0x1a, 0xb2, 0x5b, 0xd8, 0xc7, 0x7d, 0x8e, 0xbe, 0x37, 0x71, 0xca, 0x0d, 0xae, 0x9e,
	0xd7, 0x26, 0x92, 0xba, 0xa1, 0x9f, 0x45, 0x82, 0x9c, 0xfe, 0xe0, 0x98, 0x43, 0xee, 0x37, 0x60,
	0x41, 0xde, 0xa3, 0x23, 0x57, 0x02, 0x12, 0xe7, 0xd5, 0x45, 0x38, 0xba, 0x82, 0x71, 0x54, 0x86,
	0x9c, 0x14, 0x8b, 0x5b, 0xb5, 0x94, 0x81, 0x3e, 0x3e, 0x68, 0x06, 0x33, 0xe8, 0x3a, 0xa0, 0xbd,
	0xe8, 0x65, 0xc3, 0x8a, 0x29, 0x90, 0x72, 0x8b, 0xf1, 0x4a, 0x28, 0xfe, 0x75, 0x00, 0x69, 0x85,
	0xe5, 0x10, 0xe6, 0xf5, 0xf5, 0x45, 0x70, 0x56, 0xce, 0x34, 0xe4, 0x04, 0xfa, 0x79, 0x70, 0x60,
	0x1e, 0xbb, 0x62, 0xeb, 0xbb, 0xca, 0x9d, 0xf3, 0x95, 0xc2, 0xe7, 0x87, 0xe5, 0xd2, 0x08, 0xf7,
	0xdd, 0xb5, 0xea, 0x31, 0x90, 0x55, 0x75, 0x80, 0x3e, 0x7a, 0x35, 0x4f, 0x64, 0xf0, 0x87, 0x06,
	0xa0, 0x78, 0xd3, 0x30, 0x09, 0x1f, 0xc8, 0xbb, 0x9f, 0xbc, 0x19, 0x24, 0x8e, 0xf1, 0xc6, 0xe9,
	0x37, 0x83, 0x58, 0x3f, 0xbc, 0x19, 0x24, 0x2a, 0xe2, 0xdb, 0x71, 0x8b, 0x4e, 0xeb, 0x18, 0x6a,
	0x98, 0x2e, 0xe6, 0x24, 0x71, 0xbb, 0xa0, 0xa1, 0x76, 0x28, 0x1f, 0x59, 0x99, 0xaa, 0xfe, 0xd9,
	0x80, 0x6b, 0x13, 0xd9, 0x14, 0x19, 0xfb, 0x13, 0x40, 0x7e, 0x62, 0x51, 0xc5, 0x66, 0xa4, 0x8d,
	0x3e, 0x77, 0x72, 0x2e, 0xfa, 0x13, 0xcd, 0xf8, 0x7f, 0xb4, 0xcb, 0xac, 0x65, 0x54, 0x04, 0xfe,
	0x68, 0xc0, 0xe5, 0xa4, 0x31, 0x91, 0x5b, 0x9b, 0x30, 0x97, 0xb4, 0x45, 0x3b, 0xf4, 0xf2, 0x59,
	0x1c, 0xd2, 0xbe, 0x1c, 0xd1, 0x47, 0xef, 0xc4, 0x85, 0x1b, 0xbc, 0xa8, 0xdd, 0x38, 0x33, 0x37,
	0xa1, 0x4d, 0xe3, 0x05, 0x9c, 0x09, 0xcf, 0x61, 0x99, 0x2d, 0xcf, 0x73, 0xd1, 0x2f, 0x60, 0x91,
	0x79, 0xc2, 0x92, 0x59, 0x4e, 0x1c, 0x4b, 0x5f, 0xef, 0x83, 0xee, 0xf7, 0xce, 0xf9, 0x28, 0xfb,
	0xe7, 0x61, 0x79, 0x12, 0x6a, 0x8c, 0xc7, 0x3c, 0xf3, 0x44, 0x5d, 0xad, 0x77, 0x82, 0xcb, 0xbf,
	0x0f, 0xf3, 0x47, 0x3f, 0x1d, 0x74, 0xcb, 0xbb, 0xe7, 0xfe, 0xf4, 0xfc, 0x69, 0x9f, 0x9d, 0xeb,
	0x26, 0xbe, 0xb9, 0x36, 0x23, 0x63, 0xf8, 0x2f, 0x19, 0xc7, 0x0e, 0x14, 0xa2, 0x76, 0xb2, 0xad,
	0x9e, 0xa8, 0x38, 0xfa, 0x2e, 0x4c, 0x07, 0xaf, 0x55, 0xe1, 0x39, 0xbf, 0x92, 0x7c, 0xfc, 0xc4,
	0x5d, 0x9b, 0xd6, 0xc6, 0x74, 0x42, 0x86, 0xb5, 0xda, 0xeb, 0xbf, 0x35, 0x00, 0xe2, 0xd7, 0x13,
	0xf4, 0x06, 0x5c, 0xad, 0xdf, 0xdb, 0x6c, 0x58, 0xed, 0xce, 0xcd, 0xce, 0x76, 0xdb, 0xda, 0xde,
	0x6c, 0x6f, 0x35, 0xd7, 0x5b, 0xb7, 0x5a, 0xcd, 0x46, 0x21, 0x55, 0xca, 0x3f, 0x78, 0x58, 0xc9,
	0x6d, 0x33, 0x3e, 0x20, 0x36, 0xdd, 0xa5, 0xc4, 0x41, 0xaf, 0xc0, 0xe5, 0xa3, 0xd2, 0x72, 0xd4,
	0x6c, 0x14, 0x8c, 0xd2, 0xdc, 0x83, 0x87, 0x95, 0x99, 0xe0, 0xd4, 0x48, 0x1c, 0xb4, 0x0c, 0xcf,
	0x4f, 0xca, 0xb5, 0x36, 0xdf, 0x2e, 0xa4, 0x4b, 0xf3, 0x0f, 0x1e, 0x56, 0x66, 0xa3, 0xe3, 0x25,
	0xaa, 0x02, 0x4a, 0x4a, 0x6a, 0xbc, 0xa9, 0x12, 0x3c, 0x78, 0x58, 0xc9, 0x06, 0xc1, 0x28, 0x65,
	0xde, 0xfb, 0x70, 0x29, 0xf5, 0xfa, 0x8f, 0x01, 0x5a, 0x6c, 0xd7, 0xc7, 0xb6, 0xca, 0xbd, 0x12,
	0x5c, 0x69, 0x6d, 0xde, 0x32, 0x6f, 0xae, 0x77, 0x5a, 0xf7, 0x36, 0x8f, 0x9a, 0x3d, 0xb6, 0xd6,
	0xb8, 0xb7, 0x5d, 0xbf, 0xd3, 0xb4, 0xda, 0xad, 0xb7, 0x37, 0x0b, 0x06, 0xba, 0x0a, 0x97, 0x8e,
	0xac, 0xbd, 0xbb, 0xd9, 0x69, 0xdd, 0x6d, 0x16, 0xd2, 0xf5, 0x5b, 0x9f, 0x3c, 0x59, 0x32, 0x1e,
	0x3f, 0x59, 0x32, 0xfe, 0xfe, 0x64, 0xc9, 0x78, 0xff, 0xe9, 0x52, 0xea, 0xf1, 0xd3, 0xa5, 0xd4,
	0x9f, 0x9e, 0x2e, 0xa5, 0x7e, 0xf0, 0xc6, 0xa9, 0x61, 0x3e, 0x88, 0x1e, 0xf0, 0x55, 0xc0, 0xbb,
	0x59, 0xb5, 0x93, 0x7c, 0xeb, 0xbf, 0x01, 0x00, 0x00, 0xff, 0xff, 0x65, 0x79, 0x74, 0xab, 0xdf,
	0x17, 0x00, 0x00,
}

func (this *Pool) Description() (desc *github_com_cosmos_gogoproto_protoc_gen_gogo_descriptor.FileDescriptorSet) {
	return StakingDescription()
}
func StakingDescription() (desc *github_com_cosmos_gogoproto_protoc_gen_gogo_descriptor.FileDescriptorSet) {
	d := &github_com_cosmos_gogoproto_protoc_gen_gogo_descriptor.FileDescriptorSet{}
	var gzipped = []byte{
		// 10422 bytes of a gzipped FileDescriptorSet
		0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xe4, 0x7d, 0x6b, 0x74, 0x1c, 0xd7,
		0x79, 0x18, 0xf6, 0xbd, 0xfb, 0xed, 0x62, 0x77, 0x70, 0x01, 0x91, 0xe0, 0x52, 0x02, 0xa0, 0x91,
		0x25, 0x91, 0x94, 0x04, 0x4a, 0x94, 0x48, 0x8a, 0xa0, 0x65, 0x79, 0xb1, 0x58, 0x92, 0x4b, 0xe2,
		0xa5, 0x59, 0x80, 0x7a, 0x24, 0xf6, 0x78, 0x30, 0x7b, 0x01, 0x8c, 0xb8, 0x3b, 0x33, 0x9e, 0x99,
		0x25, 0x01, 0x9d, 0xb4, 0x47, 0xa9, 0x9a, 0xd6, 0x66, 0xdb, 0xd4, 0x49, 0x7a, 0x1a, 0xc7, 0x31,
		0x5d, 0x3b, 0x4e, 0x6a, 0xc7, 0x75, 0x1f, 0x89, 0x5d, 0xd7, 0x49, 0xda, 0xd4, 0xed, 0xe9, 0xc3,
		0xf5, 0xe9, 0xe9, 0x71, 0x72, 0xda, 0x26, 0xed, 0x49, 0x95, 0x54, 0xf6, 0x69, 0x5d, 0xd7, 0x69,
		0x52, 0xc7, 0x3d, 0x6d, 0x8f, 0x8f, 0xdb, 0x9e, 0xfb, 0x9a, 0xc7, 0x3e, 0xb0, 0x0b, 0x5a, 0x52,
		0xd2, 0xe3, 0x5f, 0xd8, 0x7b, 0xef, 0xf7, 0x7d, 0x73, 0xef, 0x77, 0xbf, 0xfb, 0xbd, 0xee, 0x03,
		0xf0, 0x47, 0x17, 0x61, 0x6e, 0xc7, 0xb2, 0x76, 0x5a, 0xf8, 0xb4, 0xed, 0x58, 0x9e, 0xb5, 0xd5,
		0xd9, 0x3e, 0xdd, 0xc4, 0xae, 0xee, 0x18, 0xb6, 0x67, 0x39, 0xf3, 0xb4, 0x0e, 0x95, 0x18, 0xc4,
		0xbc, 0x80, 0x90, 0x57, 0x60, 0xe2, 0x92, 0xd1, 0xc2, 0x4b, 0x3e, 0x60, 0x03, 0x7b, 0xe8, 0x69,
		0x48, 0x6e, 0x1b, 0x2d, 0x3c, 0x1d, 0x9b, 0x4b, 0x9c, 0xc8, 0x9f, 0x79, 0xc7, 0x7c, 0x17, 0xd2,
		0x7c, 0x14, 0x63, 0x9d, 0x54, 0x2b, 0x14, 0x43, 0xfe, 0x7a, 0x12, 0x26, 0xfb, 0xb4, 0x22, 0x04,
		0x49, 0x53, 0x6b, 0x13, 0x8a, 0xb1, 0x13, 0x39, 0x85, 0xfe, 0x46, 0xd3, 0x90, 0xb1, 0x35, 0xfd,
		0x86, 0xb6, 0x83, 0xa7, 0xe3, 0xb4, 0x5a, 0x14, 0xd1, 0x0c, 0x40, 0x13, 0xdb, 0xd8, 0x6c, 0x62,
		0x53, 0xdf, 0x9f, 0x4e, 0xcc, 0x25, 0x4e, 0xe4, 0x94, 0x50, 0x0d, 0x7a, 0x04, 0x26, 0xec, 0xce,
		0x56, 0xcb, 0xd0, 0xd5, 0x10, 0x18, 0xcc, 0x25, 0x4e, 0xa4, 0x14, 0x89, 0x35, 0x2c, 0x05, 0xc0,
		0x0f, 0x43, 0xe9, 0x16, 0xd6, 0x6e, 0x84, 0x41, 0xf3, 0x14, 0xb4, 0x48, 0xaa, 0x43, 0x80, 0x55,
		0x28, 0xb4, 0xb1, 0xeb, 0x6a, 0x3b, 0x58, 0xf5, 0xf6, 0x6d, 0x3c, 0x9d, 0xa4, 0xa3, 0x9f, 0xeb,
		0x19, 0x7d, 0xf7, 0xc8, 0xf3, 0x1c, 0x6b, 0x63, 0xdf, 0xc6, 0xa8, 0x02, 0x39, 0x6c, 0x76, 0xda,
		0x8c, 0x42, 0x6a, 0x00, 0xff, 0x6a, 0x66, 0xa7, 0xdd, 0x4d, 0x25, 0x4b, 0xd0, 0x38, 0x89, 0x8c,
		0x8b, 0x9d, 0x9b, 0x86, 0x8e, 0xa7, 0xd3, 0x94, 0xc0, 0xc3, 0x3d, 0x04, 0x1a, 0xac, 0xbd, 0x9b,
		0x86, 0xc0, 0x43, 0x55, 0xc8, 0xe1, 0x3d, 0x0f, 0x9b, 0xae, 0x61, 0x99, 0xd3, 0x19, 0x4a, 0xe4,
		0xc1, 0x3e, 0xb3, 0x88, 0x5b, 0xcd, 0x6e, 0x12, 0x01, 0x1e, 0x3a, 0x07, 0x19, 0xcb, 0xf6, 0x0c,
		0xcb, 0x74, 0xa7, 0xb3, 0x73, 0xb1, 0x13, 0xf9, 0x33, 0xf7, 0xf6, 0x15, 0x84, 0x35, 0x06, 0xa3,
		0x08, 0x60, 0x54, 0x07, 0xc9, 0xb5, 0x3a, 0x8e, 0x8e, 0x55, 0xdd, 0x6a, 0x62, 0xd5, 0x30, 0xb7,
		0xad, 0xe9, 0x1c, 0x25, 0x30, 0xdb, 0x3b, 0x10, 0x0a, 0x58, 0xb5, 0x9a, 0xb8, 0x6e, 0x6e, 0x5b,
		0x4a, 0xd1, 0x8d, 0x94, 0xd1, 0x11, 0x48, 0xbb, 0xfb, 0xa6, 0xa7, 0xed, 0x4d, 0x17, 0xa8, 0x84,
		0xf0, 0x92, 0xfc, 0x2b, 0x69, 0x28, 0x8d, 0x22, 0x62, 0x17, 0x21, 0xb5, 0x4d, 0x46, 0x39, 0x1d,
		0x3f, 0x0c, 0x0f, 0x18, 0x4e, 0x94, 0x89, 0xe9, 0xbb, 0x64, 0x62, 0x05, 0xf2, 0x26, 0x76, 0x3d,
		0xdc, 0x64, 0x12, 0x91, 0x18, 0x51, 0xa6, 0x80, 0x21, 0xf5, 0x8a, 0x54, 0xf2, 0xae, 0x44, 0xea,
		0x05, 0x28, 0xf9, 0x5d, 0x52, 0x1d, 0xcd, 0xdc, 0x11, 0xb2, 0x79, 0x7a, 0x58, 0x4f, 0xe6, 0x6b,
		0x02, 0x4f, 0x21, 0x68, 0x4a, 0x11, 0x47, 0xca, 0x68, 0x09, 0xc0, 0x32, 0xb1, 0xb5, 0xad, 0x36,
		0xb1, 0xde, 0x9a, 0xce, 0x0e, 0xe0, 0xd2, 0x1a, 0x01, 0xe9, 0xe1, 0x92, 0xc5, 0x6a, 0xf5, 0x16,
		0xba, 0x10, 0x88, 0x5a, 0x66, 0x80, 0xa4, 0xac, 0xb0, 0x45, 0xd6, 0x23, 0x6d, 0x9b, 0x50, 0x74,
		0x30, 0x91, 0x7b, 0xdc, 0xe4, 0x23, 0xcb, 0xd1, 0x4e, 0xcc, 0x0f, 0x1d, 0x99, 0xc2, 0xd1, 0xd8,
		0xc0, 0xc6, 0x9d, 0x70, 0x11, 0x3d, 0x00, 0x7e, 0x85, 0x4a, 0xc5, 0x0a, 0xa8, 0x16, 0x2a, 0x88,
		0xca, 0x55, 0xad, 0x8d, 0xcb, 0xaf, 0x40, 0x31, 0xca, 0x1e, 0x34, 0x05, 0x29, 0xd7, 0xd3, 0x1c,
		0x8f, 0x4a, 0x61, 0x4a, 0x61, 0x05, 0x24, 0x41, 0x02, 0x9b, 0x4d, 0xaa, 0xe5, 0x52, 0x0a, 0xf9,
		0x89, 0xde, 0x1d, 0x0c, 0x38, 0x41, 0x07, 0xfc, 0x50, 0xef, 0x8c, 0x46, 0x28, 0x77, 0x8f, 0xbb,
		0x7c, 0x1e, 0xc6, 0x23, 0x03, 0x18, 0xf5, 0xd3, 0xf2, 0x8f, 0xc0, 0x3d, 0x7d, 0x49, 0xa3, 0x17,
		0x60, 0xaa, 0x63, 0x1a, 0xa6, 0x87, 0x1d, 0xdb, 0xc1, 0x44, 0x62, 0xd9, 0xa7, 0xa6, 0xff, 0x73,
		0x66, 0x80, 0xcc, 0x6d, 0x86, 0xa1, 0x19, 0x15, 0x65, 0xb2, 0xd3, 0x5b, 0x79, 0x2a, 0x97, 0xfd,
		0x46, 0x46, 0x7a, 0xf5, 0xd5, 0x57, 0x5f, 0x8d, 0xcb, 0xff, 0x28, 0x0d, 0x53, 0xfd, 0xd6, 0x4c,
		0xdf, 0xe5, 0x7b, 0x04, 0xd2, 0x66, 0xa7, 0xbd, 0x85, 0x1d, 0xca, 0xa4, 0x94, 0xc2, 0x4b, 0xa8,
		0x02, 0xa9, 0x96, 0xb6, 0x85, 0x5b, 0xd3, 0xc9, 0xb9, 0xd8, 0x89, 0xe2, 0x99, 0x47, 0x46, 0x5a,
		0x95, 0xf3, 0xcb, 0x04, 0x45, 0x61, 0x98, 0xe8, 0x5d, 0x90, 0xe4, 0x2a, 0x9a, 0x50, 0x38, 0x35,
		0x1a, 0x05, 0xb2, 0x96, 0x14, 0x8a, 0x87, 0x8e, 0x43, 0x8e, 0xfc, 0x65, 0xb2, 0x91, 0xa6, 0x7d,
		0xce, 0x92, 0x0a, 0x22, 0x17, 0xa8, 0x0c, 0x59, 0xba, 0x4c, 0x9a, 0x58, 0x98, 0x36, 0xbf, 0x4c,
		0x04, 0xab, 0x89, 0xb7, 0xb5, 0x4e, 0xcb, 0x53, 0x6f, 0x6a, 0xad, 0x0e, 0xa6, 0x02, 0x9f, 0x53,
		0x0a, 0xbc, 0xf2, 0x3a, 0xa9, 0x43, 0xb3, 0x90, 0x67, 0xab, 0xca, 0x30, 0x9b, 0x78, 0x8f, 0x6a,
		0xcf, 0x94, 0xc2, 0x16, 0x5a, 0x9d, 0xd4, 0x90, 0xcf, 0xbf, 0xec, 0x5a, 0xa6, 0x10, 0x4d, 0xfa,
		0x09, 0x52, 0x41, 0x3f, 0x7f, 0xbe, 0x5b, 0x71, 0xdf, 0xd7, 0x7f, 0x78, 0x3d, 0x6b, 0xe9, 0x61,
		0x28, 0x51, 0x88, 0x27, 0xf9, 0xd4, 0x6b, 0xad, 0xe9, 0x89, 0xb9, 0xd8, 0x89, 0xac, 0x52, 0x64,
		0xd5, 0x6b, 0xbc, 0x56, 0xfe, 0x42, 0x1c, 0x92, 0x54, 0xb1, 0x94, 0x20, 0xbf, 0xf1, 0xe2, 0x7a,
		0x4d, 0x5d, 0x5a, 0xdb, 0x5c, 0x5c, 0xae, 0x49, 0x31, 0x54, 0x04, 0xa0, 0x15, 0x97, 0x96, 0xd7,
		0x2a, 0x1b, 0x52, 0xdc, 0x2f, 0xd7, 0x57, 0x37, 0xce, 0x3d, 0x25, 0x25, 0x7c, 0x84, 0x4d, 0x56,
		0x91, 0x0c, 0x03, 0x3c, 0x79, 0x46, 0x4a, 0x21, 0x09, 0x0a, 0x8c, 0x40, 0xfd, 0x85, 0xda, 0xd2,
		0xb9, 0xa7, 0xa4, 0x74, 0xb4, 0xe6, 0xc9, 0x33, 0x52, 0x06, 0x8d, 0x43, 0x8e, 0xd6, 0x2c, 0xae,
		0xad, 0x2d, 0x4b, 0x59, 0x9f, 0x66, 0x63, 0x43, 0xa9, 0xaf, 0x5e, 0x96, 0x72, 0x3e, 0xcd, 0xcb,
		0xca, 0xda, 0xe6, 0xba, 0x04, 0x3e, 0x85, 0x95, 0x5a, 0xa3, 0x51, 0xb9, 0x5c, 0x93, 0xf2, 0x3e,
		0xc4, 0xe2, 0x8b, 0x1b, 0xb5, 0x86, 0x54, 0x88, 0x74, 0xeb, 0xc9, 0x33, 0xd2, 0xb8, 0xff, 0x89,
		0xda, 0xea, 0xe6, 0x8a, 0x54, 0x44, 0x13, 0x30, 0xce, 0x3e, 0x21, 0x3a, 0x51, 0xea, 0xaa, 0x3a,
		0xf7, 0x94, 0x24, 0x05, 0x1d, 0x61, 0x54, 0x26, 0x22, 0x15, 0xe7, 0x9e, 0x92, 0x90, 0x5c, 0x85,
		0x14, 0x15, 0x43, 0x84, 0xa0, 0xb8, 0x5c, 0x59, 0xac, 0x2d, 0xab, 0x6b, 0xeb, 0x1b, 0xf5, 0xb5,
		0xd5, 0xca, 0xb2, 0x14, 0x0b, 0xea, 0x94, 0xda, 0x73, 0x9b, 0x75, 0xa5, 0xb6, 0x24, 0xc5, 0xc3,
		0x75, 0xeb, 0xb5, 0xca, 0x46, 0x6d, 0x49, 0x4a, 0xc8, 0x3a, 0x4c, 0xf5, 0x53, 0xa8, 0x7d, 0x97,
		0x50, 0x48, 0x16, 0xe2, 0x03, 0x64, 0x81, 0xd2, 0xea, 0x96, 0x05, 0xf9, 0x6b, 0x71, 0x98, 0xec,
		0x63, 0x54, 0xfa, 0x7e, 0xe4, 0x59, 0x48, 0x31, 0x59, 0x66, 0x66, 0xf6, 0x64, 0x5f, 0xeb, 0x44,
		0x25, 0xbb, 0xc7, 0xd4, 0x52, 0xbc, 0xb0, 0xab, 0x91, 0x18, 0xe0, 0x6a, 0x10, 0x12, 0x3d, 0x02,
		0xfb, 0x9e, 0x1e, 0xe5, 0xcf, 0xec, 0xe3, 0xb9, 0x51, 0xec, 0x23, 0xad, 0x3b, 0x9c, 0x11, 0x48,
		0xf5, 0x31, 0x02, 0x17, 0x61, 0xa2, 0x87, 0xd0, 0xc8, 0xca, 0xf8, 0xb5, 0x18, 0x4c, 0x0f, 0x62,
		0xce, 0x10, 0x95, 0x18, 0x8f, 0xa8, 0xc4, 0x8b, 0xdd, 0x1c, 0xbc, 0x7f, 0xf0, 0x24, 0xf4, 0xcc,
		0xf5, 0xa7, 0x62, 0x70, 0xa4, 0xbf, 0x4b, 0xd9, 0xb7, 0x0f, 0xef, 0x82, 0x74, 0x1b, 0x7b, 0xbb,
		0x96, 0x70, 0xab, 0x1e, 0xea, 0x63, 0xac, 0x49, 0x73, 0xf7, 0x64, 0x73, 0xac, 0xb0, 0xb5, 0x4f,
		0x0c, 0xf2, 0x0b, 0x59, 0x6f, 0x7a, 0x7a, 0xfa, 0xc1, 0x38, 0xdc, 0xd3, 0x97, 0x78, 0xdf, 0x8e,
		0xde, 0x07, 0x60, 0x98, 0x76, 0xc7, 0x63, 0xae, 0x13, 0xd3, 0xc4, 0x39, 0x5a, 0x43, 0x95, 0x17,
		0xd1, 0xb2, 0x1d, 0xcf, 0x6f, 0x4f, 0xd0, 0x76, 0x60, 0x55, 0x14, 0xe0, 0xe9, 0xa0, 0xa3, 0x49,
		0xda, 0xd1, 0x99, 0x01, 0x23, 0xed, 0x11, 0xcc, 0xc7, 0x41, 0xd2, 0x5b, 0x06, 0x36, 0x3d, 0xd5,
		0xf5, 0x1c, 0xac, 0xb5, 0x0d, 0x73, 0x87, 0x9a, 0x9a, 0xec, 0x42, 0x6a, 0x5b, 0x6b, 0xb9, 0x58,
		0x29, 0xb1, 0xe6, 0x86, 0x68, 0x25, 0x18, 0x54, 0x80, 0x9c, 0x10, 0x46, 0x3a, 0x82, 0xc1, 0x9a,
		0x7d, 0x0c, 0xf9, 0x27, 0x72, 0x90, 0x0f, 0x39, 0xe0, 0xe8, 0x7e, 0x28, 0xbc, 0xac, 0xdd, 0xd4,
		0x54, 0x11, 0x54, 0x31, 0x4e, 0xe4, 0x49, 0xdd, 0x3a, 0x0f, 0xac, 0x1e, 0x87, 0x29, 0x0a, 0x62,
		0x75, 0x3c, 0xec, 0xa8, 0x7a, 0x4b, 0x73, 0x5d, 0xca, 0xb4, 0x2c, 0x05, 0x45, 0xa4, 0x6d, 0x8d,
		0x34, 0x55, 0x45, 0x0b, 0x3a, 0x0b, 0x93, 0x14, 0xa3, 0xdd, 0x69, 0x79, 0x86, 0xdd, 0xc2, 0x2a,
		0x09, 0xf3, 0x5c, 0x6a, 0x72, 0xfc, 0x9e, 0x4d, 0x10, 0x88, 0x15, 0x0e, 0x40, 0x7a, 0xe4, 0xa2,
		0x25, 0xb8, 0x8f, 0xa2, 0xed, 0x60, 0x13, 0x3b, 0x9a, 0x87, 0x55, 0xfc, 0xfe, 0x8e, 0xd6, 0x72,
		0x55, 0xcd, 0x6c, 0xaa, 0xbb, 0x9a, 0xbb, 0x3b, 0x3d, 0x45, 0x08, 0x2c, 0xc6, 0xa7, 0x63, 0xca,
		0x31, 0x02, 0x78, 0x99, 0xc3, 0xd5, 0x28, 0x58, 0xc5, 0x6c, 0x5e, 0xd1, 0xdc, 0x5d, 0xb4, 0x00,
		0x47, 0x28, 0x15, 0xd7, 0x73, 0x0c, 0x73, 0x47, 0xd5, 0x77, 0xb1, 0x7e, 0x43, 0xed, 0x78, 0xdb,
		0x4f, 0x4f, 0x1f, 0x0f, 0x7f, 0x9f, 0xf6, 0xb0, 0x41, 0x61, 0xaa, 0x04, 0x64, 0xd3, 0xdb, 0x7e,
		0x1a, 0x35, 0xa0, 0x40, 0x26, 0xa3, 0x6d, 0xbc, 0x82, 0xd5, 0x6d, 0xcb, 0xa1, 0x36, 0xb4, 0xd8,
		0x47, 0x35, 0x85, 0x38, 0x38, 0xbf, 0xc6, 0x11, 0x56, 0xac, 0x26, 0x5e, 0x48, 0x35, 0xd6, 0x6b,
		0xb5, 0x25, 0x25, 0x2f, 0xa8, 0x5c, 0xb2, 0x1c, 0x22, 0x50, 0x3b, 0x96, 0xcf, 0xe0, 0x3c, 0x13,
		0xa8, 0x1d, 0x4b, 0xb0, 0xf7, 0x2c, 0x4c, 0xea, 0x3a, 0x1b, 0xb3, 0xa1, 0xab, 0x3c, 0x18, 0x73,
		0xa7, 0xa5, 0x08, 0xb3, 0x74, 0xfd, 0x32, 0x03, 0xe0, 0x32, 0xee, 0xa2, 0x0b, 0x70, 0x4f, 0xc0,
		0xac, 0x30, 0xe2, 0x44, 0xcf, 0x28, 0xbb, 0x51, 0xcf, 0xc2, 0xa4, 0xbd, 0xdf, 0x8b, 0x88, 0x22,
		0x5f, 0xb4, 0xf7, 0xbb, 0xd1, 0xce, 0xc3, 0x94, 0xbd, 0x6b, 0xf7, 0xe2, 0x9d, 0x0a, 0xe3, 0x21,
		0x7b, 0xd7, 0xee, 0x46, 0x7c, 0x90, 0x46, 0xe6, 0x0e, 0xd6, 0x35, 0x0f, 0x37, 0xa7, 0x8f, 0x86,
		0xc1, 0x43, 0x0d, 0x68, 0x1e, 0x24, 0x5d, 0x57, 0xb1, 0xa9, 0x6d, 0xb5, 0xb0, 0xaa, 0x39, 0xd8,
		0xd4, 0xdc, 0xe9, 0x59, 0x0a, 0x9c, 0xf4, 0x9c, 0x0e, 0x56, 0x8a, 0xba, 0x5e, 0xa3, 0x8d, 0x15,
		0xda, 0x86, 0x4e, 0xc1, 0x84, 0xb5, 0xf5, 0xb2, 0xce, 0x24, 0x52, 0xb5, 0x1d, 0xbc, 0x6d, 0xec,
		0x4d, 0xbf, 0x83, 0xb2, 0xb7, 0x44, 0x1a, 0xa8, 0x3c, 0xae, 0xd3, 0x6a, 0x74, 0x12, 0x24, 0xdd,
		0xdd, 0xd5, 0x1c, 0x9b, 0xaa, 0x64, 0xd7, 0xd6, 0x74, 0x3c, 0xfd, 0x20, 0x03, 0x65, 0xf5, 0xab,
		0xa2, 0x9a, 0xac, 0x08, 0xf7, 0x96, 0xb1, 0xed, 0x09, 0x8a, 0x0f, 0xb3, 0x15, 0x41, 0xeb, 0x38,
		0xb5, 0x13, 0x20, 0x11, 0x4e, 0x44, 0x3e, 0x7c, 0x82, 0x82, 0x15, 0xed, 0x5d, 0x3b, 0xfc, 0xdd,
		0x07, 0x60, 0x9c, 0x40, 0x06, 0x1f, 0x3d, 0xc9, 0x1c, 0x37, 0x7b, 0x37, 0xf4, 0xc5, 0xa7, 0xe0,
		0x08, 0x01, 0x6a, 0x63, 0x4f, 0x6b, 0x6a, 0x9e, 0x16, 0x82, 0x7e, 0x94, 0x42, 0x13, 0xb6, 0xaf,
		0xf0, 0xc6, 0x48, 0x3f, 0x9d, 0xce, 0xd6, 0xbe, 0x2f, 0x58, 0x8f, 0xb1, 0x7e, 0x92, 0x3a, 0x21,
		0x5a, 0x6f, 0x99, 0x73, 0x2e, 0x2f, 0x40, 0x21, 0x2c, 0xf7, 0x28, 0x07, 0x4c, 0xf2, 0xa5, 0x18,
		0x71, 0x82, 0xaa, 0x6b, 0x4b, 0xc4, 0x7d, 0x79, 0xa9, 0x26, 0xc5, 0x89, 0x1b, 0xb5, 0x5c, 0xdf,
		0xa8, 0xa9, 0xca, 0xe6, 0xea, 0x46, 0x7d, 0xa5, 0x26, 0x25, 0x42, 0x8e, 0xfd, 0xd5, 0x64, 0xf6,
		0x21, 0xe9, 0x61, 0xe2, 0x35, 0x14, 0xa3, 0x91, 0x1a, 0x7a, 0x27, 0x1c, 0x15, 0x69, 0x15, 0x17,
		0x7b, 0xea, 0x2d, 0xc3, 0xa1, 0x0b, 0xb2, 0xad, 0x31, 0xe3, 0xe8, 0xcb, 0xcf, 0x14, 0x87, 0x6a,
		0x60, 0xef, 0x79, 0xc3, 0x21, 0xcb, 0xad, 0xad, 0x79, 0x68, 0x19, 0x66, 0x4d, 0x4b, 0x75, 0x3d,
		0xcd, 0x6c, 0x6a, 0x4e, 0x53, 0x0d, 0x12, 0x5a, 0xaa, 0xa6, 0xeb, 0xd8, 0x75, 0x2d, 0x66, 0x08,
		0x7d, 0x2a, 0xf7, 0x9a, 0x56, 0x83, 0x03, 0x07, 0x16, 0xa2, 0xc2, 0x41, 0xbb, 0xc4, 0x37, 0x31,
		0x48, 0x7c, 0x8f, 0x43, 0xae, 0xad, 0xd9, 0x2a, 0x36, 0x3d, 0x67, 0x9f, 0xfa, 0xe7, 0x59, 0x25,
		0xdb, 0xd6, 0xec, 0x1a, 0x29, 0xbf, 0x2d, 0x61, 0xd2, 0xd5, 0x64, 0x36, 0x29, 0xa5, 0xae, 0x26,
		0xb3, 0x29, 0x29, 0x7d, 0x35, 0x99, 0x4d, 0x4b, 0x99, 0xab, 0xc9, 0x6c, 0x56, 0xca, 0x5d, 0x4d,
		0x66, 0x73, 0x12, 0xc8, 0x3f, 0x99, 0x84, 0x42, 0xd8, 0x83, 0x27, 0x01, 0x91, 0x4e, 0x6d, 0x58,
		0x8c, 0x6a, 0xb9, 0x07, 0x0e, 0xf4, 0xf7, 0xe7, 0xab, 0xc4, 0xb8, 0x2d, 0xa4, 0x99, 0xbb, 0xac,
		0x30, 0x4c, 0xe2, 0x58, 0x10, 0xf1, 0xc3, 0xcc, 0x3d, 0xc9, 0x2a, 0xbc, 0x84, 0x2e, 0x43, 0xfa,
		0x65, 0x97, 0xd2, 0x4e, 0x53, 0xda, 0xef, 0x38, 0x98, 0xf6, 0xd5, 0x06, 0x25, 0x9e, 0xbb, 0xda,
		0x50, 0x57, 0xd7, 0x94, 0x95, 0xca, 0xb2, 0xc2, 0xd1, 0xd1, 0x31, 0x48, 0xb6, 0xb4, 0x57, 0xf6,
		0xa3, 0x66, 0x90, 0x56, 0xa1, 0x79, 0x28, 0x75, 0xcc, 0x9b, 0xd8, 0x31, 0xb6, 0x0d, 0xdc, 0x54,
		0x29, 0x54, 0x29, 0x0c, 0x55, 0x0c, 0x5a, 0x97, 0x09, 0xfc, 0x88, 0xd3, 0x78, 0x0c, 0x92, 0xb7,
		0xb0, 0x76, 0x23, 0x6a, 0xac, 0x68, 0xd5, 0x5b, 0xb8, 0x9c, 0x4e, 0x43, 0x8a, 0xf2, 0x17, 0x01,
		0x70, 0x0e, 0x4b, 0x63, 0x28, 0x0b, 0xc9, 0xea, 0x9a, 0x42, 0x96, 0x94, 0x04, 0x05, 0x56, 0xab,
		0xae, 0xd7, 0x6b, 0xd5, 0x9a, 0x14, 0x97, 0xcf, 0x42, 0x9a, 0x31, 0x8d, 0x2c, 0x37, 0x9f, 0x6d,
		0xd2, 0x18, 0x2f, 0x72, 0x1a, 0x31, 0xd1, 0xba, 0xb9, 0xb2, 0x58, 0x53, 0xa4, 0x78, 0x8f, 0xb0,
		0xc8, 0x2e, 0x14, 0xc2, 0x9e, 0xfc, 0xdb, 0x13, 0xce, 0x7f, 0x29, 0x06, 0xf9, 0x90, 0x67, 0x4e,
		0x5c, 0x2a, 0xad, 0xd5, 0xb2, 0x6e, 0xa9, 0x5a, 0xcb, 0xd0, 0x5c, 0x2e, 0x4a, 0x40, 0xab, 0x2a,
		0xa4, 0x66, 0xd4, 0xa9, 0x7b, 0x9b, 0x16, 0x59, 0x4a, 0x4a, 0xcb, 0x1f, 0x8b, 0x81, 0xd4, 0xed,
		0x1a, 0x77, 0x75, 0x33, 0xf6, 0xc7, 0xd9, 0x4d, 0xf9, 0xa3, 0x31, 0x28, 0x46, 0xfd, 0xe1, 0xae,
		0xee, 0xdd, 0xff, 0xc7, 0xda, 0xbd, 0xdf, 0x8b, 0xc3, 0x78, 0xc4, 0x0b, 0x1e, 0xb5, 0x77, 0xef,
		0x87, 0x09, 0xa3, 0x89, 0xdb, 0xb6, 0xe5, 0x61, 0x53, 0xdf, 0x57, 0x5b, 0xf8, 0x26, 0x6e, 0x4d,
		0xcb, 0x54, 0xc9, 0x9c, 0x3e, 0xd8, 0xcf, 0x9e, 0xaf, 0x07, 0x78, 0xcb, 0x04, 0x6d, 0x61, 0xb2,
		0xbe, 0x54, 0x5b, 0x59, 0x5f, 0xdb, 0xa8, 0xad, 0x56, 0x5f, 0x54, 0x37, 0x57, 0xaf, 0xad, 0xae,
		0x3d, 0xbf, 0xaa, 0x48, 0x46, 0x17, 0xd8, 0x5b, 0xb8, 0xec, 0xd7, 0x41, 0xea, 0xee, 0x14, 0x3a,
		0x0a, 0xfd, 0xba, 0x25, 0x8d, 0xa1, 0x49, 0x28, 0xad, 0xae, 0xa9, 0x8d, 0xfa, 0x52, 0x4d, 0xad,
		0x5d, 0xba, 0x54, 0xab, 0x6e, 0x34, 0x58, 0xe6, 0xc4, 0x87, 0xde, 0x88, 0x2c, 0x70, 0xf9, 0x23,
		0x09, 0x98, 0xec, 0xd3, 0x13, 0x54, 0xe1, 0x31, 0x0f, 0x0b, 0xc3, 0x1e, 0x1b, 0xa5, 0xf7, 0xf3,
		0xc4, 0xeb, 0x58, 0xd7, 0x1c, 0x8f, 0x87, 0x48, 0x27, 0x81, 0x70, 0xc9, 0xf4, 0x88, 0x72, 0x75,
		0x78, 0x46, 0x8a, 0x05, 0x42, 0xa5, 0xa0, 0x9e, 0x25, 0xa5, 0x1e, 0x05, 0x64, 0x5b, 0xae, 0xe1,
		0x19, 0x37, 0xb1, 0x6a, 0x98, 0x22, 0x7d, 0x45, 0x02, 0xa3, 0xa4, 0x22, 0x89, 0x96, 0xba, 0xe9,
		0xf9, 0xd0, 0x26, 0xde, 0xd1, 0xba, 0xa0, 0x89, 0xf2, 0x4f, 0x28, 0x92, 0x68, 0xf1, 0xa1, 0xef,
		0x87, 0x42, 0xd3, 0xea, 0x10, 0x6f, 0x91, 0xc1, 0x11, 0x5b, 0x13, 0x53, 0xf2, 0xac, 0xce, 0x07,
		0xe1, 0x71, 0x40, 0x90, 0x37, 0x2b, 0x28, 0x79, 0x56, 0xc7, 0x40, 0x1e, 0x86, 0x92, 0xb6, 0xb3,
		0xe3, 0x10, 0xe2, 0x82, 0x10, 0x8b, 0x6c, 0x8a, 0x7e, 0x35, 0x05, 0x2c, 0x5f, 0x85, 0xac, 0xe0,
		0x03, 0x31, 0xf6, 0x84, 0x13, 0xaa, 0xcd, 0xc2, 0xf5, 0xf8, 0x89, 0x9c, 0x92, 0x35, 0x45, 0xe3,
		0xfd, 0x50, 0x30, 0x5c, 0x35, 0xd8, 0x06, 0x88, 0xcf, 0xc5, 0x4f, 0x64, 0x95, 0xbc, 0xe1, 0xfa,
		0x29, 0x54, 0xf9, 0x53, 0x71, 0x28, 0x46, 0xb7, 0x31, 0xd0, 0x12, 0x64, 0x5b, 0x96, 0xae, 0x51,
		0xd1, 0x62, 0x7b, 0x68, 0x27, 0x86, 0xec, 0x7c, 0xcc, 0x2f, 0x73, 0x78, 0xc5, 0xc7, 0x2c, 0xff,
		0xab, 0x18, 0x64, 0x45, 0x35, 0x3a, 0x02, 0x49, 0x5b, 0xf3, 0x76, 0x29, 0xb9, 0xd4, 0x62, 0x5c,
		0x8a, 0x29, 0xb4, 0x4c, 0xea, 0x5d, 0x5b, 0x33, 0xa9, 0x08, 0xf0, 0x7a, 0x52, 0x26, 0xf3, 0xda,
		0xc2, 0x5a, 0x93, 0x86, 0x4d, 0x56, 0xbb, 0x8d, 0x4d, 0xcf, 0x15, 0xf3, 0xca, 0xeb, 0xab, 0xbc,
		0x1a, 0x3d, 0x02, 0x13, 0x9e, 0xa3, 0x19, 0xad, 0x08, 0x6c, 0x92, 0xc2, 0x4a, 0xa2, 0xc1, 0x07,
		0x5e, 0x80, 0x63, 0x82, 0x6e, 0x13, 0x7b, 0x9a, 0xbe, 0x8b, 0x9b, 0x01, 0x52, 0x9a, 0xa6, 0x47,
		0x8e, 0x72, 0x80, 0x25, 0xde, 0x2e, 0x70, 0xe5, 0xdf, 0x88, 0xc1, 0x84, 0x08, 0xf4, 0x9a, 0x3e,
		0xb3, 0x56, 0x00, 0x34, 0xd3, 0xb4, 0xbc, 0x30, 0xbb, 0x7a, 0x45, 0xb9, 0x07, 0x6f, 0xbe, 0xe2,
		0x23, 0x29, 0x21, 0x02, 0xe5, 0x36, 0x40, 0xd0, 0x32, 0x90, 0x6d, 0xb3, 0x90, 0xe7, 0x7b, 0x54,
		0x74, 0xa3, 0x93, 0xa5, 0x06, 0x80, 0x55, 0x91, 0x88, 0x10, 0x4d, 0x41, 0x6a, 0x0b, 0xef, 0x18,
		0x26, 0xcf, 0x3c, 0xb3, 0x82, 0x48, 0xe0, 0x24, 0xfd, 0x04, 0xce, 0xe2, 0x9f, 0x86, 0x49, 0xdd,
		0x6a, 0x77, 0x77, 0x77, 0x51, 0xea, 0x4a, 0x4f, 0xb8, 0x57, 0x62, 0x2f, 0x3d, 0xc6, 0x81, 0x76,
		0xac, 0x96, 0x66, 0xee, 0xcc, 0x5b, 0xce, 0x4e, 0xb0, 0x51, 0x4b, 0x3c, 0x24, 0x37, 0xb4, 0x5d,
		0x6b, 0x6f, 0xfd, 0xaf, 0x58, 0xec, 0xe7, 0xe2, 0x89, 0xcb, 0xeb, 0x8b, 0x9f, 0x89, 0x97, 0x2f,
		0x33, 0xc4, 0x75, 0xc1, 0x0c, 0x05, 0x6f, 0xb7, 0xb0, 0x4e, 0x06, 0x08, 0xbf, 0xff, 0x08, 0x4c,
		0xed, 0x58, 0x3b, 0x16, 0xa5, 0x74, 0x9a, 0xfc, 0xe2, 0x3b, 0xbd, 0x39, 0xbf, 0xb6, 0x3c, 0x74,
		0x5b, 0x78, 0x61, 0x15, 0x26, 0x39, 0xb0, 0x4a, 0xb7, 0x9a, 0x58, 0x20, 0x84, 0x0e, 0xcc, 0xc2,
		0x4d, 0xff, 0xd2, 0xd7, 0xa9, 0xf9, 0x56, 0x26, 0x38, 0x2a, 0x69, 0x63, 0xb1, 0xd2, 0x82, 0x02,
		0xf7, 0x44, 0xe8, 0xb1, 0x45, 0x8a, 0x9d, 0x21, 0x14, 0xff, 0x29, 0xa7, 0x38, 0x19, 0xa2, 0xd8,
		0xe0, 0xa8, 0x0b, 0x55, 0x18, 0x3f, 0x0c, 0xad, 0x7f, 0xc6, 0x69, 0x15, 0x70, 0x98, 0xc8, 0x65,
		0x28, 0x51, 0x22, 0x7a, 0xc7, 0xf5, 0xac, 0x36, 0xd5, 0x80, 0x07, 0x93, 0xf9, 0xe7, 0x5f, 0x67,
		0xab, 0xa6, 0x48, 0xd0, 0xaa, 0x3e, 0xd6, 0xc2, 0x02, 0xd0, 0xdd, 0xb5, 0x26, 0xd6, 0x5b, 0x43,
		0x28, 0x7c, 0x99, 0x77, 0xc4, 0x87, 0x5f, 0xb8, 0x0e, 0x53, 0xe4, 0x37, 0x55, 0x50, 0xe1, 0x9e,
		0x0c, 0x4f, 0xd9, 0x4d, 0xff, 0xc6, 0x6b, 0x6c, 0x61, 0x4e, 0xfa, 0x04, 0x42, 0x7d, 0x0a, 0xcd,
		0xe2, 0x0e, 0xf6, 0x3c, 0xec, 0xb8, 0xaa, 0xd6, 0xea, 0xd7, 0xbd, 0x50, 0xce, 0x63, 0xfa, 0x67,
		0xbe, 0x15, 0x9d, 0xc5, 0xcb, 0x0c, 0xb3, 0xd2, 0x6a, 0x2d, 0x6c, 0xc2, 0xd1, 0x3e, 0x52, 0x31,
		0x02, 0xcd, 0x8f, 0x70, 0x9a, 0x53, 0x3d, 0x92, 0x41, 0xc8, 0xae, 0x83, 0xa8, 0xf7, 0xe7, 0x72,
		0x04, 0x9a, 0x3f, 0xcb, 0x69, 0x22, 0x8e, 0x2b, 0xa6, 0x94, 0x50, 0xbc, 0x0a, 0x13, 0x37, 0xb1,
		0xb3, 0x65, 0xb9, 0x3c, 0xcf, 0x34, 0x02, 0xb9, 0x8f, 0x72, 0x72, 0x25, 0x8e, 0x48, 0x13, 0x4f,
		0x84, 0xd6, 0x05, 0xc8, 0x6e, 0x6b, 0x3a, 0x1e, 0x81, 0xc4, 0x1d, 0x4e, 0x22, 0x43, 0xe0, 0x09,
		0x6a, 0x05, 0x0a, 0x3b, 0x16, 0xb7, 0x51, 0xc3, 0xd1, 0x3f, 0xc6, 0xd1, 0xf3, 0x02, 0x87, 0x93,
		0xb0, 0x2d, 0xbb, 0xd3, 0x22, 0x06, 0x6c, 0x38, 0x89, 0xbf, 0x26, 0x48, 0x08, 0x1c, 0x4e, 0xe2,
		0x10, 0x6c, 0xfd, 0xb8, 0x20, 0xe1, 0x86, 0xf8, 0xf9, 0x2c, 0xe4, 0x2d, 0xb3, 0xb5, 0x6f, 0x99,
		0xa3, 0x74, 0xe2, 0x13, 0x9c, 0x02, 0x70, 0x14, 0x42, 0xe0, 0x22, 0xe4, 0x46, 0x9d, 0x88, 0x5f,
		0xf8, 0x96, 0x58, 0x1e, 0x62, 0x06, 0x2e, 0x43, 0x49, 0x28, 0x28, 0xc3, 0x32, 0x47, 0x20, 0xf1,
		0xd7, 0x39, 0x89, 0x62, 0x08, 0x8d, 0x0f, 0xc3, 0xc3, 0xae, 0xb7, 0x83, 0x47, 0x21, 0xf2, 0x29,
		0x31, 0x0c, 0x8e, 0xc2, 0x59, 0xb9, 0x85, 0x4d, 0x7d, 0x77, 0x34, 0x0a, 0x9f, 0x16, 0xac, 0x14,
		0x38, 0x84, 0x44, 0x15, 0xc6, 0xdb, 0x9a, 0xe3, 0xee, 0x6a, 0xad, 0x91, 0xa6, 0xe3, 0x17, 0x39,
		0x8d, 0x82, 0x8f, 0xc4, 0x39, 0xd2, 0x31, 0x0f, 0x43, 0xe6, 0x33, 0x82, 0x23, 0x21, 0x34, 0xbe,
		0xf4, 0x5c, 0x8f, 0x26, 0xe5, 0x0e, 0x43, 0xed, 0x6f, 0x88, 0xa5, 0xc7, 0x70, 0x57, 0xc2, 0x14,
		0x2f, 0x42, 0xce, 0x35, 0x5e, 0x19, 0x89, 0xcc, 0x67, 0xc5, 0x4c, 0x53, 0x04, 0x82, 0xfc, 0x22,
		0x1c, 0xeb, 0x6b, 0x26, 0x46, 0x20, 0xf6, 0x37, 0x39, 0xb1, 0x23, 0x7d, 0x4c, 0x05, 0x57, 0x09,
		0x87, 0x25, 0xf9, 0xb7, 0x84, 0x4a, 0xc0, 0x5d, 0xb4, 0xd6, 0x49, 0xd4, 0xe0, 0x6a, 0xdb, 0x87,
		0xe3, 0xda, 0xdf, 0x16, 0x5c, 0x63, 0xb8, 0x11, 0xae, 0x6d, 0xc0, 0x11, 0x4e, 0xf1, 0x70, 0xf3,
		0xfa, 0x77, 0x84, 0x62, 0x65, 0xd8, 0x9b, 0xd1, 0xd9, 0xfd, 0x21, 0x28, 0xfb, 0xec, 0x14, 0xee,
		0xa9, 0xab, 0xb6, 0x35, 0x7b, 0x04, 0xca, 0xbf, 0xc4, 0x29, 0x0b, 0x8d, 0xef, 0xfb, 0xb7, 0xee,
		0x8a, 0x66, 0x13, 0xe2, 0x2f, 0xc0, 0xb4, 0x20, 0xde, 0x31, 0x1d, 0xac, 0x5b, 0x3b, 0xa6, 0xf1,
		0x0a, 0x6e, 0x8e, 0x40, 0xfa, 0x97, 0xbb, 0xa6, 0x6a, 0x33, 0x84, 0x4e, 0x28, 0xd7, 0x41, 0xf2,
		0x7d, 0x15, 0xd5, 0x68, 0xdb, 0x96, 0xe3, 0x0d, 0xa1, 0xf8, 0x39, 0x31, 0x53, 0x3e, 0x5e, 0x9d,
		0xa2, 0x2d, 0xd4, 0x80, 0xed, 0x54, 0x8f, 0x2a, 0x92, 0x9f, 0xe7, 0x84, 0xc6, 0x03, 0x2c, 0xae,
		0x38, 0x74, 0xab, 0x6d, 0x6b, 0xce, 0x28, 0xfa, 0xef, 0xef, 0x0a, 0xc5, 0xc1, 0x51, 0xb8, 0xe2,
		0x20, 0x1e, 0x1d, 0xb1, 0xf6, 0x23, 0x50, 0xf8, 0x82, 0x50, 0x1c, 0x02, 0x87, 0x93, 0x10, 0x0e,
		0xc3, 0x08, 0x24, 0xfe, 0x9e, 0x20, 0x21, 0x70, 0x08, 0x89, 0xe7, 0x02, 0x43, 0xeb, 0xe0, 0x1d,
		0xc3, 0xf5, 0x1c, 0xe6, 0x14, 0x1f, 0x4c, 0xea, 0x8b, 0xdf, 0x8a, 0x3a, 0x61, 0x4a, 0x08, 0x95,
		0x68, 0x22, 0x9e, 0xa6, 0xa5, 0x31, 0xd3, 0xf0, 0x8e, 0xfd, 0x8a, 0xd0, 0x44, 0x21, 0x34, 0xd2,
		0xb7, 0x90, 0x87, 0x48, 0xd8, 0xae, 0x93, 0x48, 0x61, 0x04, 0x72, 0xbf, 0xda, 0xd5, 0xb9, 0x86,
		0xc0, 0x25, 0x34, 0x43, 0xfe, 0x4f, 0xc7, 0xbc, 0x81, 0xf7, 0x47, 0x92, 0xce, 0x5f, 0xeb, 0xf2,
		0x7f, 0x36, 0x19, 0x26, 0xd3, 0x21, 0xa5, 0x2e, 0x7f, 0x0a, 0x0d, 0x3b, 0x97, 0x34, 0xfd, 0xa3,
		0xdf, 0xe1, 0xe3, 0x8d, 0xba, 0x53, 0x0b, 0xcb, 0x44, 0xc8, 0xa3, 0x4e, 0xcf, 0x70, 0x62, 0xaf,
		0x7d, 0xc7, 0x97, 0xf3, 0x88, 0xcf, 0xb3, 0x70, 0x09, 0xc6, 0x23, 0x0e, 0xcf, 0x70, 0x52, 0x7f,
		0x96, 0x93, 0x2a, 0x84, 0xfd, 0x9d, 0x85, 0xb3, 0x90, 0x24, 0xce, 0xcb, 0x70, 0xf4, 0x1f, 0xe3,
		0xe8, 0x14, 0x7c, 0xe1, 0x19, 0xc8, 0x0a, 0xa7, 0x65, 0x38, 0xea, 0x9f, 0xe3, 0xa8, 0x3e, 0x0a,
		0x41, 0x17, 0x0e, 0xcb, 0x70, 0xf4, 0x3f, 0x2f, 0xd0, 0x05, 0x0a, 0x41, 0x1f, 0x9d, 0x85, 0x5f,
		0xfa, 0x0b, 0x49, 0x6e, 0x74, 0x04, 0xef, 0x2e, 0x42, 0x86, 0x7b, 0x2a, 0xc3, 0xb1, 0x3f, 0xc8,
		0x3f, 0x2e, 0x30, 0x16, 0xce, 0x43, 0x6a, 0x44, 0x86, 0xff, 0x25, 0x8e, 0xca, 0xe0, 0x17, 0xaa,
		0x90, 0x0f, 0x79, 0x27, 0xc3, 0xd1, 0x7f, 0x9c, 0xa3, 0x87, 0xb1, 0x48, 0xd7, 0xb9, 0x77, 0x32,
		0x9c, 0xc0, 0x5f, 0x16, 0x5d, 0xe7, 0x18, 0x84, 0x6d, 0xc2, 0x31, 0x19, 0x8e, 0xfd, 0x21, 0xc1,
		0x75, 0x81, 0xb2, 0xf0, 0x2c, 0xe4, 0x7c, 0x63, 0x33, 0x1c, 0xff, 0x27, 0x38, 0x7e, 0x80, 0x43,
		0x38, 0x10, 0x32, 0x76, 0xc3, 0x49, 0xfc, 0xa4, 0xe0, 0x40, 0x08, 0x8b, 0x2c, 0xa3, 0x6e, 0x07,
		0x66, 0x38, 0xa5, 0x9f, 0x12, 0xcb, 0xa8, 0xcb, 0x7f, 0x21, 0xb3, 0x49, 0x75, 0xfe, 0x70, 0x12,
		0x7f, 0x45, 0xcc, 0x26, 0x85, 0x27, 0xdd, 0xe8, 0xf6, 0x08, 0x86, 0xd3, 0xf8, 0x69, 0xd1, 0x8d,
		0x2e, 0x87, 0x60, 0x61, 0x1d, 0x50, 0xaf, 0x37, 0x30, 0x9c, 0xde, 0x87, 0x39, 0xbd, 0x89, 0x1e,
		0x67, 0x60, 0xe1, 0x79, 0x38, 0xd2, 0xdf, 0x13, 0x18, 0x4e, 0xf5, 0x67, 0xbe, 0xd3, 0x15, 0xbb,
		0x85, 0x1d, 0x81, 0x85, 0x8d, 0xc0, 0xa4, 0x84, 0xbd, 0x80, 0xe1, 0x64, 0x3f, 0xf2, 0x9d, 0xa8,
		0xe2, 0x0e, 0x3b, 0x01, 0x0b, 0x15, 0x80, 0xc0, 0x00, 0x0f, 0xa7, 0xf5, 0x51, 0x4e, 0x2b, 0x84,
		0x44, 0x96, 0x06, 0xb7, 0xbf, 0xc3, 0xf1, 0xef, 0x88, 0xa5, 0xc1, 0x31, 0xc8, 0xd2, 0x10, 0xa6,
		0x77, 0x38, 0xf6, 0xc7, 0xc4, 0xd2, 0x10, 0x28, 0x44, 0xb2, 0x43, 0xd6, 0x6d, 0x38, 0x85, 0x4f,
		0x08, 0xc9, 0x0e, 0x61, 0x2d, 0xac, 0xc2, 0x44, 0x8f, 0x41, 0x1c, 0x4e, 0xea, 0xe7, 0x38, 0x29,
		0xa9, 0xdb, 0x1e, 0x86, 0x8d, 0x17, 0x37, 0x86, 0xc3, 0xa9, 0x7d, 0xb2, 0xcb, 0x78, 0x71, 0x5b,
		0xb8, 0x70, 0x11, 0xb2, 0x66, 0xa7, 0xd5, 0x22, 0x8b, 0x07, 0x1d, 0x7c, 0x96, 0x70, 0xfa, 0xbf,
		0x7c, 0x97, 0x73, 0x47, 0x20, 0x2c, 0x9c, 0x85, 0x14, 0x6e, 0x6f, 0xe1, 0xe6, 0x30, 0xcc, 0x6f,
		0x7e, 0x57, 0x28, 0x4c, 0x02, 0xbd, 0xf0, 0x2c, 0x00, 0x4b, 0x8d, 0xd0, 0xcd, 0xc3, 0x21, 0xb8,
		0xff, 0xf5, 0xbb, 0xfc, 0xf0, 0x4e, 0x80, 0x12, 0x10, 0x60, 0x47, 0x81, 0x0e, 0x26, 0xf0, 0xad,
		0x28, 0x01, 0x3a, 0x23, 0x17, 0x20, 0xf3, 0xb2, 0x6b, 0x99, 0x9e, 0xb6, 0x33, 0x0c, 0xfb, 0xf7,
		0x39, 0xb6, 0x80, 0x27, 0x0c, 0x6b, 0x5b, 0x0e, 0xf6, 0xb4, 0x1d, 0x77, 0x18, 0xee, 0x7f, 0xe3,
		0xb8, 0x3e, 0x02, 0x41, 0xd6, 0x35, 0xd7, 0x1b, 0x65, 0xdc, 0x7f, 0x20, 0x90, 0x05, 0x02, 0xe9,
		0x34, 0xf9, 0x7d, 0x03, 0xef, 0x0f, 0xc3, 0xfd, 0x43, 0xd1, 0x69, 0x0e, 0xbf, 0xf0, 0x0c, 0xe4,
		0xc8, 0x4f, 0x76, 0x22, 0x6f, 0x08, 0xf2, 0x7f, 0xe7, 0xc8, 0x01, 0x06, 0xf9, 0xb2, 0xeb, 0x35,
		0x3d, 0x63, 0x38, 0xb3, 0xbf, 0xcd, 0x67, 0x5a, 0xc0, 0x2f, 0x54, 0x20, 0xef, 0x7a, 0xcd, 0x66,
		0x87, 0xfb, 0xa7, 0x43, 0xd0, 0xff, 0xe8, 0xbb, 0x7e, 0xca, 0xc2, 0xc7, 0x21, 0xb3, 0x7d, 0xeb,
		0x86, 0x67, 0x5b, 0x74, 0xc3, 0x63, 0x18, 0x85, 0xef, 0x70, 0x0a, 0x21, 0x94, 0x85, 0x2a, 0x14,
		0xc8, 0x58, 0x1c, 0x6c, 0x63, 0xba, 0x3b, 0x35, 0x84, 0xc4, 0xff, 0xe0, 0x0c, 0x88, 0x20, 0x2d,
		0xbe, 0xef, 0xcb, 0x6f, 0xcc, 0xc4, 0xbe, 0xfa, 0xc6, 0x4c, 0xec, 0xf7, 0xde, 0x98, 0x89, 0x7d,
		0xe8, 0x6b, 0x33, 0x63, 0x5f, 0xfd, 0xda, 0xcc, 0xd8, 0x6f, 0x7f, 0x6d, 0x66, 0xac, 0x7f, 0x96,
		0x18, 0x2e, 0x5b, 0x97, 0x2d, 0x96, 0x1f, 0x7e, 0xe9, 0xc1, 0x1d, 0xc3, 0xdb, 0xed, 0x6c, 0xcd,
		0xeb, 0x56, 0xfb, 0xb4, 0x6e, 0xb9, 0x6d, 0xcb, 0x3d, 0x1d, 0xcd, 0xeb, 0xd2, 0x5f, 0xf0, 0xbd,
		0x18, 0x89, 0x99, 0xa3, 0xe9, 0x5c, 0xcd, 0xdc, 0x1f, 0x74, 0xbd, 0xe7, 0x1c, 0x24, 0x2a, 0xe6,
		0x3e, 0x3a, 0xc6, 0x14, 0x9c, 0xda, 0x71, 0x5a, 0xfc, 0x58, 0x58, 0x86, 0x94, 0x37, 0x9d, 0x16,
		0x9a, 0x0a, 0xce, 0x6e, 0xc6, 0x4e, 0x14, 0xf8, 0x81, 0xcc, 0xc5, 0x1f, 0x8f, 0x1d, 0x6e, 0x24,
		0xd9, 0x8a, 0xb9, 0x4f, 0x07, 0xb2, 0x1e, 0x7b, 0xe9, 0xd1, 0xa1, 0x79, 0xee, 0x1b, 0xa6, 0x75,
		0xcb, 0x24, 0xdd, 0xb6, 0xb7, 0x44, 0x8e, 0x7b, 0xa6, 0x3b, 0xc7, 0xfd, 0x3c, 0x6e, 0xb5, 0xae,
		0x11, 0xb8, 0x0d, 0x82, 0xb2, 0x95, 0x66, 0x27, 0x90, 0xe1, 0xa7, 0xe2, 0x30, 0xd3, 0x93, 0xce,
		0xe6, 0x42, 0x30, 0x88, 0x09, 0x0b, 0x90, 0x5d, 0x12, 0xb2, 0x35, 0x0d, 0x19, 0x17, 0xeb, 0x96,
		0xd9, 0x74, 0x29, 0x23, 0x12, 0x8a, 0x28, 0x12, 0x46, 0x98, 0x9a, 0x69, 0xb9, 0xfc, 0x60, 0x25,
		0x2b, 0x2c, 0xfe, 0xec, 0x21, 0x19, 0x31, 0x2e, 0xbe, 0x24, 0xb8, 0xf1, 0xc4, 0x88, 0xdc, 0x10,
		0x83, 0x88, 0x64, 0xfe, 0x47, 0xe5, 0xca, 0x4f, 0xc7, 0x61, 0xb6, 0x9b, 0x2b, 0x64, 0x65, 0xb9,
		0x9e, 0xd6, 0xb6, 0x07, 0xb1, 0xe5, 0x22, 0xe4, 0x36, 0x04, 0xcc, 0xa1, 0xf9, 0x72, 0xe7, 0x90,
		0x7c, 0x29, 0xfa, 0x9f, 0x12, 0x8c, 0x39, 0x33, 0x22, 0x63, 0xfc, 0x71, 0xdc, 0x15, 0x67, 0xfe,
		0x77, 0x1a, 0x8e, 0xb1, 0xe5, 0xa4, 0xb2, 0xa5, 0xc4, 0x0a, 0x9c, 0x27, 0x85, 0x70, 0xd3, 0xf0,
		0x7d, 0x12, 0xf9, 0x1a, 0x4c, 0xd6, 0x89, 0xb6, 0x20, 0x51, 0x50, 0xb0, 0xc3, 0xd3, 0xf7, 0xec,
		0xe9, 0x5c, 0xc4, 0xe1, 0xe7, 0x3b, 0x4c, 0xe1, 0x2a, 0xf9, 0x47, 0x63, 0x20, 0x35, 0x74, 0xad,
		0xa5, 0x39, 0xdf, 0x2f, 0x29, 0x74, 0x1e, 0x80, 0xde, 0x59, 0x0a, 0x2e, 0x19, 0x15, 0xcf, 0x4c,
		0xcf, 0x87, 0x07, 0x37, 0xcf, 0xbe, 0x44, 0x6f, 0x30, 0xe4, 0x28, 0x2c, 0xf9, 0x79, 0xea, 0x05,
		0x80, 0xa0, 0x01, 0x1d, 0x87, 0xa3, 0x8d, 0x6a, 0x65, 0xb9, 0xa2, 0xa8, 0xec, 0x30, 0xfc, 0x6a,
		0x63, 0xbd, 0x56, 0xad, 0x5f, 0xaa, 0xd7, 0x96, 0xa4, 0x31, 0x74, 0x04, 0x50, 0xb8, 0xd1, 0x3f,
		0x97, 0x72, 0x0f, 0x4c, 0x84, 0xeb, 0xd9, 0x89, 0xfa, 0x38, 0xf1, 0x14, 0x8d, 0xb6, 0xdd, 0xc2,
		0x74, 0xeb, 0x4f, 0x35, 0x04, 0xd7, 0x86, 0x3b, 0x21, 0xff, 0xe2, 0xdf, 0xb2, 0x53, 0xd6, 0x93,
		0x01, 0xba, 0xcf, 0xf3, 0x85, 0x65, 0x98, 0xd0, 0x74, 0x1d, 0xdb, 0x11, 0x92, 0x43, 0x54, 0x35,
		0x21, 0x48, 0x37, 0x33, 0x39, 0x66, 0x40, 0xed, 0x3c, 0xa4, 0x5d, 0x3a, 0xfa, 0x61, 0x24, 0xbe,
		0xc2, 0x49, 0x70, 0xf0, 0x05, 0x13, 0x26, 0x88, 0xe7, 0xa7, 0x39, 0x38, 0xd4, 0x8d, 0x83, 0xf3,
		0x0c, 0xff, 0xe0, 0x73, 0x8f, 0xd3, 0xad, 0xcd, 0xfb, 0xa3, 0xd3, 0xd2, 0x47, 0x9c, 0x14, 0x89,
		0xd3, 0x0e, 0x3a, 0x8a, 0xa1, 0x28, 0xbe, 0xc7, 0x3b, 0x7c, 0xf0, 0xc7, 0x7e, 0x9d, 0x7f, 0x6c,
		0xa6, 0x9f, 0x0c, 0x84, 0xbe, 0x34, 0xce, 0xa9, 0xb2, 0x86, 0xc5, 0xda, 0xa0, 0x35, 0xfd, 0xd2,
		0x23, 0xbd, 0xd6, 0x89, 0xfd, 0x79, 0x8c, 0x52, 0xbe, 0x18, 0xfe, 0x8c, 0xbf, 0xf6, 0x7e, 0x2b,
		0x01, 0x33, 0x1c, 0x78, 0x4b, 0x73, 0xf1, 0xe9, 0x9b, 0x4f, 0x6c, 0x61, 0x4f, 0x7b, 0xe2, 0xb4,
		0x6e, 0x19, 0x42, 0x57, 0x4f, 0xf2, 0xe5, 0x48, 0xda, 0xe7, 0x79, 0x7b, 0xb9, 0xef, 0x86, 0x66,
		0x79, 0xf0, 0x32, 0x96, 0x37, 0x21, 0x59, 0xb5, 0x0c, 0x93, 0xa8, 0xaa, 0x26, 0x36, 0xad, 0x36,
		0x5f, 0x3d, 0xac, 0x80, 0x9e, 0x80, 0xb4, 0xd6, 0xb6, 0x3a, 0xa6, 0xc7, 0x56, 0xce, 0xe2, 0xb1,
		0x2f, 0xbf, 0x3e, 0x3b, 0xf6, 0xef, 0x5f, 0x9f, 0x4d, 0xd4, 0x4d, 0xef, 0x37, 0x3f, 0xff, 0x18,
		0x70, 0x52, 0x75, 0xd3, 0x53, 0x38, 0xe0, 0x42, 0xf2, 0x1b, 0x1f, 0x9f, 0x8d, 0xc9, 0x2f, 0x40,
		0x66, 0x09, 0xeb, 0x77, 0x43, 0x79, 0x09, 0xeb, 0x21, 0xca, 0x4b, 0x58, 0xef, 0xa2, 0x7c, 0x1e,
		0xb2, 0x75, 0xd3, 0x63, 0x07, 0xd7, 0x1f, 0x81, 0x84, 0x61, 0xb2, 0xb3, 0x90, 0x07, 0xf6, 0x8d,
		0x40, 0x11, 0xc4, 0x25, 0xac, 0xfb, 0x88, 0x4d, 0xac, 0x77, 0x23, 0xf6, 0x7e, 0x9a, 0x40, 0x2d,
		0x2e, 0xfd, 0xf6, 0x7f, 0x9c, 0x19, 0x7b, 0xf5, 0x8d, 0x99, 0xb1, 0x81, 0x53, 0x2c, 0x0f, 0x9c,
		0x62, 0xb7, 0x79, 0x83, 0x69, 0x64, 0x7f, 0x66, 0x3f, 0x93, 0x84, 0xfb, 0xe8, 0x7d, 0x26, 0xa7,
		0x6d, 0x98, 0xde, 0x69, 0xdd, 0xd9, 0xb7, 0x3d, 0x8b, 0xe8, 0x4d, 0x6b, 0x9b, 0x4f, 0xec, 0x44,
		0xd0, 0x3c, 0xcf, 0x9a, 0xfb, 0x4f, 0xab, 0xbc, 0x0d, 0xa9, 0x75, 0x82, 0x47, 0x58, 0xec, 0x59,
		0x9e, 0xd6, 0xe2, 0xf6, 0x87, 0x15, 0x48, 0x2d, 0xbb, 0x03, 0x15, 0x67, 0xb5, 0x86, 0xb8, 0xfe,
		0xd4, 0xc2, 0xda, 0x36, 0x3b, 0x4a, 0x9e, 0xa0, 0x8e, 0x4b, 0x96, 0x54, 0xd0, 0x53, 0xe3, 0x53,
		0x90, 0xd2, 0x3a, 0xec, 0x0c, 0x43, 0x82, 0x78, 0x34, 0xb4, 0x20, 0x5f, 0x83, 0x0c, 0xdf, 0x49,
		0x45, 0x12, 0x24, 0x6e, 0xe0, 0x7d, 0xfa, 0x9d, 0x82, 0x42, 0x7e, 0xa2, 0x79, 0x48, 0xd1, 0xce,
		0xf3, 0x3b, 0x32, 0xd3, 0xf3, 0x3d, 0xbd, 0x9f, 0xa7, 0x9d, 0x54, 0x18, 0x98, 0x7c, 0x15, 0xb2,
		0x4b, 0x56, 0xdb, 0x30, 0xad, 0x28, 0xb5, 0x1c, 0xa3, 0x46, 0xfb, 0x6c, 0x77, 0xb8, 0x54, 0x28,
		0xac, 0x80, 0x8e, 0x40, 0x9a, 0x5d, 0x2d, 0xe0, 0xe7, 0x30, 0x78, 0x49, 0xae, 0x42, 0x86, 0xd2,
		0x5e, 0xb3, 0x89, 0xf2, 0xf7, 0x4f, 0x71, 0xe6, 0xf8, 0x45, 0x33, 0x4e, 0x3e, 0x1e, 0x74, 0x16,
		0x41, 0xb2, 0xa9, 0x79, 0x1a, 0x1f, 0x37, 0xfd, 0x2d, 0xbf, 0x0b, 0xb2, 0x9c, 0x88, 0x8b, 0xce,
		0x40, 0xc2, 0xb2, 0x5d, 0x7e, 0x92, 0xa2, 0x3c, 0x68, 0x28, 0x6b, 0xf6, 0x62, 0x92, 0xc8, 0x8c,
		0x42, 0x80, 0x17, 0x95, 0x81, 0x62, 0xf1, 0x74, 0x48, 0x2c, 0x42, 0x53, 0x1e, 0xfa, 0xc9, 0xa6,
		0xb4, 0x47, 0x1c, 0x7c, 0x61, 0xf9, 0x44, 0x1c, 0x66, 0x42, 0xad, 0x37, 0xb1, 0xe3, 0x1a, 0x96,
		0xc9, 0x24, 0x8a, 0x4b, 0x0b, 0x0a, 0x75, 0x92, 0xb7, 0x0f, 0x10, 0x97, 0x67, 0x20, 0x51, 0xb1,
		0x6d, 0x54, 0x86, 0x2c, 0x2d, 0xeb, 0x16, 0x93, 0x97, 0xa4, 0xe2, 0x97, 0x49, 0x9b, 0x6b, 0x6d,
		0x7b, 0xb7, 0x34, 0xc7, 0xbf, 0x7d, 0x27, 0xca, 0xf2, 0x05, 0xc8, 0x55, 0x2d, 0xd3, 0xc5, 0xa6,
		0xdb, 0xa1, 0x9e, 0xcd, 0x56, 0xcb, 0xd2, 0x6f, 0x70, 0x0a, 0xac, 0x40, 0x18, 0xae, 0xd9, 0x36,
		0xc5, 0x4c, 0x2a, 0xe4, 0x27, 0x5b, 0xb3, 0x8b, 0x8d, 0x81, 0x2c, 0xba, 0x70, 0x78, 0x16, 0xf1,
		0x41, 0xfa, 0x3c, 0xfa, 0x5e, 0x0c, 0xee, 0xed, 0x5d, 0x50, 0x37, 0xf0, 0xbe, 0x7b, 0xd8, 0xf5,
		0xf4, 0x02, 0xe4, 0xd6, 0xe9, 0x15, 0xf8, 0x6b, 0x78, 0x1f, 0x95, 0x21, 0x83, 0x9b, 0x67, 0xce,
		0x9e, 0x7d, 0xe2, 0x02, 0x93, 0xf6, 0x2b, 0x63, 0x8a, 0xa8, 0x40, 0x33, 0x90, 0x73, 0xb1, 0x6e,
		0x9f, 0x39, 0x7b, 0xee, 0xc6, 0x13, 0x4c, 0xbc, 0xae, 0x8c, 0x29, 0x41, 0xd5, 0x42, 0x96, 0x8c,
		0xfa, 0x1b, 0x9f, 0x98, 0x8d, 0x2d, 0xa6, 0x20, 0xe1, 0x76, 0xda, 0x6f, 0xa9, 0x8c, 0x7c, 0x24,
		0x05, 0x73, 0x61, 0x4c, 0xea, 0xff, 0xdd, 0xd4, 0x5a, 0x46, 0x53, 0x0b, 0x1e, 0x2f, 0x90, 0x42,
		0x3c, 0xa0, 0x10, 0x03, 0x2c, 0xc5, 0x81, 0x9c, 0x94, 0x7f, 0x39, 0x06, 0x85, 0xeb, 0x82, 0x72,
		0x03, 0x7b, 0xe8, 0x22, 0x80, 0xff, 0x25, 0xb1, 0x6c, 0x8e, 0xcf, 0x77, 0x7f, 0x6b, 0xde, 0xc7,
		0x51, 0x42, 0xe0, 0xe8, 0x3c, 0x15, 0x44, 0xdb, 0x72, 0xf9, 0x8d, 0xac, 0x21, 0xa8, 0x3e, 0x30,
		0x7a, 0x14, 0x10, 0xd5, 0x70, 0xea, 0x4d, 0xcb, 0x33, 0xcc, 0x1d, 0xd5, 0xb6, 0x6e, 0xf1, 0x7b,
		0xae, 0x09, 0x45, 0xa2, 0x2d, 0xd7, 0x69, 0xc3, 0x3a, 0xa9, 0x27, 0x9d, 0xce, 0xf9, 0x54, 0x88,
		0xb3, 0xae, 0x35, 0x9b, 0x0e, 0x76, 0x5d, 0xae, 0xc4, 0x44, 0x11, 0x5d, 0x84, 0x8c, 0xdd, 0xd9,
		0x52, 0x85, 0xc6, 0xc8, 0x9f, 0xb9, 0xb7, 0xdf, 0xfa, 0x17, 0xf2, 0xc1, 0x35, 0x40, 0xda, 0xee,
		0x6c, 0x11, 0x69, 0xb9, 0x1f, 0x0a, 0x7d, 0x3a, 0x93, 0xbf, 0x19, 0xf4, 0x83, 0xbe, 0xbc, 0xc0,
		0x47, 0xa0, 0xda, 0x8e, 0x61, 0x39, 0x86, 0xb7, 0x4f, 0x8f, 0x43, 0x25, 0x14, 0x49, 0x34, 0xac,
		0xf3, 0x7a, 0xf9, 0x06, 0x94, 0x1a, 0xd4, 0x89, 0x0b, 0x7a, 0x7e, 0x36, 0xe8, 0x5f, 0x6c, 0x78,
		0xff, 0x06, 0xf6, 0x2c, 0xde, 0xd3, 0xb3, 0xc5, 0xe7, 0x06, 0x4a, 0xe7, 0xf9, 0xc3, 0x4b, 0x67,
		0xd4, 0xda, 0xfd, 0xc1, 0xb1, 0xc8, 0xe2, 0x64, 0xc2, 0x19, 0x56, 0x5f, 0xa3, 0x0a, 0xe6, 0xb0,
		0x18, 0xad, 0x7c, 0xb0, 0x51, 0x2d, 0x0f, 0x51, 0xa3, 0xe5, 0xa1, 0x4b, 0x48, 0xbe, 0x00, 0xe3,
		0xeb, 0x9a, 0xe3, 0x35, 0xb0, 0x77, 0x05, 0x6b, 0x4d, 0xec, 0x44, 0xad, 0xee, 0xb8, 0xb0, 0xba,
		0x08, 0x92, 0xd4, 0xb4, 0x32, 0xab, 0x43, 0x7f, 0xcb, 0xbb, 0x90, 0xa4, 0x47, 0x22, 0x7d, 0x8b,
		0xcc, 0x31, 0x98, 0x45, 0x26, 0xba, 0x74, 0xdf, 0xc3, 0xae, 0x48, 0x23, 0xd0, 0x02, 0x7a, 0x4a,
		0xd8, 0xd5, 0xc4, 0xc1, 0x76, 0x95, 0x0b, 0x22, 0xb7, 0xae, 0x2d, 0xc8, 0x2c, 0x12, 0x55, 0x5c,
		0x5f, 0xf2, 0x3b, 0x12, 0x0b, 0x3a, 0x82, 0x56, 0xa0, 0x64, 0x6b, 0x8e, 0x47, 0x6f, 0x93, 0xec,
		0xd2, 0x51, 0x70, 0x59, 0x9f, 0xed, 0x5d, 0x79, 0x91, 0xc1, 0xf2, 0xaf, 0x8c, 0xdb, 0xe1, 0x4a,
		0xf9, 0x3f, 0x25, 0x21, 0xcd, 0x99, 0xf1, 0x0c, 0x64, 0x38, 0x5b, 0xb9, 0x74, 0xde, 0x37, 0xdf,
		0x6b, 0x98, 0xe6, 0x7d, 0x03, 0xc2, 0xe9, 0x09, 0x1c, 0xf4, 0x10, 0x64, 0xf5, 0x5d, 0xcd, 0x30,
		0x55, 0xa3, 0xc9, 0x1d, 0xc2, 0xfc, 0x1b, 0xaf, 0xcf, 0x66, 0xaa, 0xa4, 0xae, 0xbe, 0xa4, 0x64,
		0x68, 0x63, 0xbd, 0x49, 0x3c, 0x81, 0x5d, 0x6c, 0xec, 0xec, 0x7a, 0x7c, 0x85, 0xf1, 0x12, 0x7a,
		0x1a, 0x92, 0x44, 0x20, 0xf8, 0x5d, 0xc3, 0x72, 0x8f, 0x87, 0xef, 0x87, 0xd0, 0x8b, 0x59, 0xf2,
		0xe1, 0x0f, 0xfd, 0xee, 0x6c, 0x4c, 0xa1, 0x18, 0xa8, 0x0a, 0xe3, 0x2d, 0xcd, 0xf5, 0x54, 0x6a,
		0xc1, 0xc8, 0xe7, 0x53, 0x94, 0xc4, 0xb1, 0x5e, 0x86, 0x70, 0xc6, 0xf2, 0xae, 0xe7, 0x09, 0x16,
		0xab, 0x6a, 0xa2, 0x13, 0x20, 0x51, 0x22, 0xba, 0xd5, 0x6e, 0x1b, 0x1e, 0xf3, 0xad, 0xd2, 0x94,
		0xef, 0x45, 0x52, 0x5f, 0xa5, 0xd5, 0xd4, 0xc3, 0x3a, 0x0e, 0x39, 0x7a, 0xbb, 0x89, 0x82, 0xb0,
		0x73, 0xb8, 0x59, 0x52, 0x41, 0x1b, 0x1f, 0x86, 0x52, 0xa0, 0x1f, 0x19, 0x48, 0x96, 0x51, 0x09,
		0xaa, 0x29, 0xe0, 0xe3, 0x30, 0x65, 0xe2, 0x3d, 0x7a, 0x32, 0x38, 0x02, 0x9d, 0xa3, 0xd0, 0x88,
		0xb4, 0x5d, 0x8f, 0x62, 0x3c, 0x08, 0x45, 0x5d, 0x30, 0x9f, 0xc1, 0x02, 0x85, 0x1d, 0xf7, 0x6b,
		0x29, 0xd8, 0x31, 0xc8, 0x6a, 0xb6, 0xcd, 0x00, 0xf2, 0x5c, 0x3f, 0xda, 0x36, 0x6d, 0x3a, 0x05,
		0x13, 0x74, 0x8c, 0x0e, 0x76, 0x3b, 0x2d, 0x8f, 0x13, 0x29, 0x50, 0x98, 0x12, 0x69, 0x50, 0x58,
		0x3d, 0x85, 0x7d, 0x00, 0xc6, 0xf1, 0x4d, 0xa3, 0x89, 0x4d, 0x1d, 0x33, 0xb8, 0x71, 0x0a, 0x57,
		0x10, 0x95, 0x14, 0xe8, 0x24, 0xf8, 0x7a, 0x4f, 0x15, 0x3a, 0xb9, 0xc8, 0xe8, 0x89, 0xfa, 0x0a,
		0xab, 0x96, 0xa7, 0x21, 0xb9, 0xa4, 0x79, 0x1a, 0x71, 0x30, 0xbc, 0x3d, 0x66, 0x68, 0x0a, 0x0a,
		0xf9, 0x29, 0x7f, 0x23, 0x0e, 0xc9, 0xeb, 0x96, 0x87, 0xd1, 0x93, 0x21, 0x07, 0xb0, 0xd8, 0x4f,
		0x9e, 0x1b, 0xc6, 0x8e, 0x89, 0x9b, 0x2b, 0xee, 0x4e, 0xe8, 0x29, 0x82, 0x40, 0x9c, 0xe2, 0x11,
		0x71, 0x9a, 0x82, 0x94, 0x63, 0x75, 0xcc, 0xa6, 0x38, 0xc2, 0x4a, 0x0b, 0xa8, 0x06, 0x59, 0x5f,
		0x4a, 0x92, 0xc3, 0xa4, 0xa4, 0x44, 0xa4, 0x84, 0xc8, 0x30, 0xaf, 0x50, 0x32, 0x5b, 0x5c, 0x58,
		0x16, 0x21, 0xe7, 0x2b, 0x2f, 0x2e, 0x6d, 0xa3, 0x09, 0x6c, 0x80, 0x46, 0x8c, 0x89, 0x3f, 0xf7,
		0x3e, 0xf3, 0x98, 0xc4, 0x49, 0x7e, 0x03, 0xe7, 0x5e, 0x44, 0xac, 0xf8, 0xb3, 0x08, 0x19, 0x3a,
		0xae, 0x40, 0xac, 0xd8, 0xd3, 0x08, 0xf7, 0x42, 0xce, 0x35, 0x76, 0x4c, 0xcd, 0xeb, 0x38, 0x98,
		0x4b, 0x5e, 0x50, 0x21, 0x7f, 0x29, 0x06, 0x69, 0x26, 0xc9, 0x21, 0xbe, 0xc5, 0xfa, 0xf3, 0x2d,
		0x3e, 0x88, 0x6f, 0x89, 0xbb, 0xe7, 0x5b, 0x05, 0xc0, 0xef, 0x8c, 0xcb, 0x6f, 0xab, 0xf7, 0xf1,
		0x18, 0x58, 0x17, 0x1b, 0xc6, 0x0e, 0x5f, 0xa8, 0x21, 0x24, 0xf9, 0x3f, 0xc4, 0x88, 0x13, 0xcb,
		0xdb, 0x51, 0x05, 0xc6, 0x45, 0xbf, 0xd4, 0xed, 0x96, 0xb6, 0xc3, 0x65, 0xe7, 0xbe, 0x81, 0x9d,
		0xbb, 0xd4, 0xd2, 0x76, 0x94, 0x3c, 0xef, 0x0f, 0x29, 0xf4, 0x9f, 0x87, 0xf8, 0x80, 0x79, 0x88,
		0x4c, 0x7c, 0xe2, 0xee, 0x26, 0x3e, 0x32, 0x45, 0xc9, 0xee, 0x29, 0xfa, 0x5c, 0x9c, 0x06, 0x33,
		0xb6, 0xe5, 0x6a, 0xad, 0xb7, 0x63, 0x45, 0x1c, 0x87, 0x9c, 0x6d, 0xb5, 0x54, 0xd6, 0xc2, 0x8e,
		0x76, 0x67, 0x6d, 0xab, 0xa5, 0xf4, 0x4c, 0x7b, 0xea, 0x4d, 0x5a, 0x2e, 0xe9, 0x37, 0x81, 0x6b,
		0x99, 0x6e, 0xae, 0x39, 0x50, 0x60, 0xac, 0xe0, 0xb6, 0xec, 0x71, 0xc2, 0x03, 0x6a, 0x1c, 0x63,
		0xbd, 0xb6, 0x97, 0x75, 0x9b, 0x41, 0x2a, 0x1c, 0x8e, 0x60, 0x30, 0xd5, 0xdf, 0x2f, 0x0a, 0x0e,
		0x8b, 0xa5, 0xc2, 0xe1, 0xe4, 0xbf, 0x1a, 0x03, 0x58, 0x26, 0x9c, 0xa5, 0xe3, 0x25, 0x56, 0xc8,
		0xa5, 0x5d, 0x50, 0x23, 0x5f, 0x9e, 0x19, 0x34, 0x69, 0xfc, 0xfb, 0x05, 0x37, 0xdc, 0xef, 0x2a,
		0x8c, 0x07, 0xc2, 0xe8, 0x62, 0xd1, 0x99, 0x99, 0x03, 0xbc, 0xea, 0x06, 0xf6, 0x94, 0xc2, 0xcd,
		0x50, 0x49, 0xfe, 0xc7, 0x31, 0xc8, 0xd1, 0x3e, 0xad, 0x60, 0x4f, 0x8b, 0xcc, 0x61, 0xec, 0xee,
		0xe7, 0xf0, 0x3e, 0x00, 0x46, 0xc6, 0x35, 0x5e, 0xc1, 0x5c, 0xb2, 0x72, 0xb4, 0xa6, 0x61, 0xbc,
		0x82, 0xd1, 0x39, 0x9f, 0xe1, 0x89, 0x83, 0x19, 0x2e, 0xbc, 0x6e, 0xce, 0xf6, 0xa3, 0x90, 0xa1,
		0xaf, 0x3b, 0xed, 0xb9, 0xdc, 0x91, 0x4e, 0x9b, 0x9d, 0xf6, 0xc6, 0x9e, 0x2b, 0xbf, 0x0c, 0x99,
		0x8d, 0x3d, 0x96, 0x1b, 0x39, 0x0e, 0x39, 0xc7, 0xb2, 0xb8, 0x4d, 0x66, 0xbe, 0x50, 0x96, 0x54,
		0x50, 0x13, 0x24, 0xf2, 0x01, 0xf1, 0x20, 0x1f, 0x10, 0x24, 0x34, 0x12, 0x23, 0x25, 0x34, 0x4e,
		0xfd, 0x56, 0x0c, 0xf2, 0x21, 0xfd, 0x80, 0x9e, 0x80, 0x7b, 0x16, 0x97, 0xd7, 0xaa, 0xd7, 0xd4,
		0xfa, 0x92, 0x7a, 0x69, 0xb9, 0x72, 0x39, 0xb8, 0xbc, 0x54, 0x3e, 0x72, 0xfb, 0xce, 0x1c, 0x0a,
		0xc1, 0x6e, 0x9a, 0x34, 0x4f, 0x8f, 0x4e, 0xc3, 0x54, 0x14, 0xa5, 0xb2, 0xd8, 0xa8, 0xad, 0x6e,
		0x48, 0xb1, 0xf2, 0x3d, 0xb7, 0xef, 0xcc, 0x4d, 0x84, 0x30, 0x2a, 0x5b, 0x2e, 0x36, 0xbd, 0x5e,
		0x84, 0xea, 0xda, 0xca, 0x4a, 0x7d, 0x43, 0x8a, 0xf7, 0x20, 0x70, 0x85, 0x7d, 0x12, 0x26, 0xa2,
		0x08, 0xab, 0xf5, 0x65, 0x29, 0x51, 0x46, 0xb7, 0xef, 0xcc, 0x15, 0x43, 0xd0, 0xab, 0x46, 0xab,
		0x9c, 0xfd, 0xc0, 0x27, 0x67, 0xc6, 0x3e, 0xfd, 0xf3, 0x33, 0x31, 0x32, 0xb2, 0xf1, 0x88, 0x8e,
		0x40, 0x8f, 0xc2, 0xd1, 0x46, 0xfd, 0xf2, 0x6a, 0x6d, 0x49, 0x5d, 0x69, 0x5c, 0x16, 0x99, 0x6e,
		0x31, 0xba, 0xd2, 0xed, 0x3b, 0x73, 0x79, 0x3e, 0xa4, 0x41, 0xd0, 0xeb, 0x4a, 0xed, 0xfa, 0xda,
		0x46, 0x4d, 0x8a, 0x31, 0xe8, 0x75, 0x07, 0xdf, 0xb4, 0x3c, 0xf6, 0xfc, 0xdb, 0xe3, 0x70, 0xac,
		0x0f, 0xb4, 0x3f, 0xb0, 0x89, 0xdb, 0x77, 0xe6, 0xc6, 0xd7, 0x1d, 0xcc, 0xd6, 0x0f, 0xc5, 0x98,
		0x87, 0xe9, 0x5e, 0x8c, 0xb5, 0xf5, 0xb5, 0x46, 0x65, 0x59, 0x9a, 0x2b, 0x4b, 0xb7, 0xef, 0xcc,
		0x15, 0x84, 0x32, 0x24, 0xf0, 0xc1, 0xc8, 0xde, 0xca, 0x88, 0xe7, 0x76, 0x26, 0x92, 0xdf, 0x63,
		0xb1, 0x84, 0xad, 0x39, 0x5a, 0xfb, 0xb0, 0x21, 0xcf, 0x90, 0xcd, 0x3a, 0xf9, 0xd5, 0x38, 0x94,
		0x7c, 0x87, 0x7a, 0x9d, 0x7e, 0x01, 0x3d, 0x19, 0xce, 0xcb, 0xe4, 0x07, 0x9a, 0x32, 0x06, 0x2d,
		0xd2, 0x36, 0xef, 0x84, 0xac, 0x70, 0xcc, 0xb8, 0xca, 0x98, 0xeb, 0xc5, 0xab, 0x71, 0x08, 0x8e,
		0xea, 0x63, 0xa0, 0x67, 0x21, 0xe7, 0x2b, 0x10, 0xff, 0x01, 0x95, 0xc1, 0x1a, 0x87, 0xe3, 0x07,
		0x38, 0xe8, 0x42, 0x10, 0x3a, 0x24, 0x07, 0x05, 0x23, 0xd7, 0x19, 0x00, 0x47, 0x16, 0xf0, 0x72,
		0x9d, 0x2f, 0x3d, 0x3e, 0x7a, 0x7a, 0xf9, 0x7c, 0x4f, 0x65, 0xd1, 0x14, 0xf3, 0x4c, 0xb2, 0x6d,
		0x6d, 0x6f, 0x91, 0x06, 0x54, 0x47, 0x21, 0x43, 0x1a, 0x77, 0xf8, 0xdd, 0xda, 0x84, 0x92, 0x6e,
		0x6b, 0x7b, 0x97, 0x35, 0xf7, 0x6a, 0x32, 0x9b, 0x90, 0x92, 0xf2, 0x2f, 0xc6, 0xa0, 0x18, 0x1d,
		0x23, 0x7a, 0x04, 0x10, 0xc1, 0xd0, 0x76, 0xb0, 0x4a, 0xd4, 0x0c, 0x65, 0x96, 0xa0, 0x5b, 0x6a,
		0x6b, 0x7b, 0x95, 0x1d, 0xbc, 0xda, 0x69, 0xd3, 0x0e, 0xb8, 0x68, 0x05, 0x24, 0x01, 0x2c, 0xe6,
		0x89, 0x33, 0xf3, 0x58, 0xef, 0x73, 0x6a, 0x1c, 0x80, 0x19, 0xab, 0x0f, 0x13, 0x63, 0x55, 0x64,
		0xf4, 0xfc, 0xcd, 0xd6, 0xc8, 0x50, 0x12, 0xd1, 0xa1, 0xc8, 0xcf, 0x42, 0xa9, 0x8b, 0x9f, 0x48,
		0x86, 0x71, 0x9e, 0x1d, 0xa0, 0x1b, 0x59, 0xcc, 0x47, 0xce, 0x29, 0x79, 0x96, 0x05, 0xa0, 0x1b,
		0x7b, 0x0b, 0xd9, 0x2f, 0x7e, 0x7c, 0x36, 0x46, 0x93, 0xe8, 0x8f, 0xc0, 0x78, 0x84, 0xa3, 0x22,
		0x73, 0x17, 0x0b, 0x32, 0x77, 0x01, 0xf0, 0x4b, 0x50, 0x20, 0xca, 0x12, 0x37, 0x39, 0xec, 0x43,
		0x50, 0x62, 0xca, 0xbc, 0x9b, 0xd7, 0xcc, 0x9b, 0x5a, 0x11, 0x0c, 0x97, 0x85, 0x7b, 0x15, 0x65,
		0x7b, 0x5e, 0x40, 0x5d, 0xd6, 0xdc, 0xc5, 0xcd, 0x4f, 0xbf, 0x31, 0x13, 0x7b, 0xeb, 0x16, 0xe3,
		0xbf, 0x79, 0x0e, 0x8e, 0x87, 0x1a, 0xb5, 0x2d, 0xdd, 0x88, 0x64, 0x1f, 0x4a, 0x21, 0x41, 0x23,
		0x8d, 0xc3, 0xb2, 0x08, 0x07, 0xe6, 0x32, 0x0e, 0x4e, 0x9e, 0x95, 0x0f, 0xd6, 0x0a, 0xc3, 0x13,
		0x1c, 0xfd, 0x73, 0x96, 0xff, 0x37, 0x0b, 0x19, 0x05, 0xbf, 0xbf, 0x83, 0x5d, 0x0f, 0x9d, 0x81,
		0x24, 0xd6, 0x77, 0xad, 0x7e, 0xe9, 0x21, 0x32, 0xb8, 0x79, 0x0e, 0x57, 0xd3, 0x77, 0xad, 0x2b,
		0x63, 0x0a, 0x85, 0x45, 0x67, 0x21, 0xb5, 0xdd, 0xea, 0xf0, 0x7c, 0x45, 0x97, 0xc2, 0x08, 0x23,
		0x5d, 0x22, 0x40, 0x57, 0xc6, 0x14, 0x06, 0x4d, 0x3e, 0x45, 0x1f, 0xa7, 0x4c, 0x1c, 0xfc, 0xa9,
		0xba, 0xb9, 0x4d, 0x3f, 0x45, 0x60, 0xd1, 0x22, 0x80, 0x61, 0x1a, 0x9e, 0x4a, 0x63, 0x79, 0xee,
		0x11, 0xde, 0x3f, 0x18, 0xd3, 0xf0, 0x68, 0xf4, 0x7f, 0x65, 0x4c, 0xc9, 0x19, 0xa2, 0x40, 0xba,
		0xfb, 0xfe, 0x0e, 0x76, 0xf6, 0xb9, 0x23, 0x38, 0xb0, 0xbb, 0xcf, 0x11, 0x20, 0xd2, 0x5d, 0x0a,
		0x8d, 0x6a, 0x90, 0xa7, 0xb7, 0x10, 0xd9, 0x1a, 0xe6, 0x0f, 0x25, 0xca, 0x83, 0x90, 0x17, 0x09,
		0x28, 0x5d, 0xd6, 0x57, 0xc6, 0x14, 0xd8, 0xf2, 0x4b, 0x44, 0x51, 0xb2, 0x87, 0x74, 0xbc, 0x3d,
		0xfe, 0x3c, 0xdc, 0xec, 0x20, 0x1a, 0xf4, 0x35, 0x9d, 0x8d, 0xbd, 0x2b, 0x63, 0x4a, 0x46, 0x67,
		0x3f, 0xc9, 0xf8, 0x9b, 0xb8, 0x65, 0xdc, 0xc4, 0x0e, 0xc1, 0xcf, 0x1d, 0x3c, 0xfe, 0x25, 0x06,
		0x49, 0x29, 0xe4, 0x9a, 0xa2, 0x40, 0x94, 0x2d, 0x36, 0x9b, 0x7c, 0x18, 0xd0, 0xab, 0xab, 0x23,
		0xf3, 0x6c, 0x36, 0xc5, 0x20, 0xb2, 0x98, 0xff, 0x46, 0x4f, 0xfb, 0x9e, 0x6a, 0xbe, 0xd7, 0x39,
		0x8c, 0x0c, 0x80, 0xe5, 0x2c, 0xc6, 0x84, 0xc7, 0x8a, 0x56, 0xa1, 0xd8, 0x32, 0x5c, 0x4f, 0x75,
		0x4d, 0xcd, 0x76, 0x77, 0x2d, 0xcf, 0xa5, 0xc1, 0x7f, 0xfe, 0xcc, 0x83, 0x83, 0x28, 0x2c, 0x1b,
		0xae, 0xd7, 0x10, 0xc0, 0x57, 0xc6, 0x94, 0xf1, 0x56, 0xb8, 0x82, 0xd0, 0xb3, 0xb6, 0xb7, 0xb1,
		0xe3, 0x13, 0xa4, 0x49, 0x82, 0x03, 0xe8, 0xad, 0x11, 0x68, 0x81, 0x4f, 0xe8, 0x59, 0xe1, 0x0a,
		0xf4, 0x43, 0x30, 0xd9, 0xb2, 0xb4, 0xa6, 0x4f, 0x4e, 0xd5, 0x77, 0x3b, 0xe6, 0x0d, 0x9a, 0x51,
		0xc8, 0x9f, 0x39, 0x39, 0xb0, 0x93, 0x96, 0xd6, 0x14, 0x24, 0xaa, 0x04, 0xe1, 0xca, 0x98, 0x32,
		0xd1, 0xea, 0xae, 0x44, 0xef, 0x85, 0x29, 0xcd, 0xb6, 0x5b, 0xfb, 0xdd, 0xd4, 0x4b, 0x94, 0xfa,
		0xa9, 0x41, 0xd4, 0x2b, 0x04, 0xa7, 0x9b, 0x3c, 0xd2, 0x7a, 0x6a, 0xd1, 0x06, 0x48, 0xb6, 0x83,
		0xe9, 0xb5, 0x09, 0x9b, 0xbb, 0x2c, 0xf4, 0xed, 0xa3, 0xfc, 0x99, 0x87, 0x07, 0xd1, 0x5e, 0x67,
		0xf0, 0xc2, 0xc3, 0xb9, 0x32, 0xa6, 0x94, 0xec, 0x68, 0x15, 0xa3, 0x6a, 0xe9, 0x98, 0xbe, 0xcf,
		0xc3, 0xa9, 0x4e, 0x0c, 0xa3, 0x4a, 0xe1, 0xa3, 0x54, 0x23, 0x55, 0x8b, 0x19, 0x7e, 0xec, 0x89,
		0x3f, 0x9e, 0xf1, 0x30, 0xe4, 0x43, 0x8a, 0x05, 0x4d, 0x43, 0x86, 0x9f, 0xcd, 0x14, 0xc7, 0xa5,
		0x78, 0x51, 0x2e, 0x42, 0x21, 0xac, 0x4c, 0xe4, 0x0f, 0xc5, 0x7c, 0x4c, 0x7a, 0x9b, 0x79, 0x3a,
		0x9a, 0x42, 0xcc, 0x05, 0xd9, 0xc1, 0x07, 0x84, 0x25, 0x11, 0xed, 0x6c, 0x87, 0xa9, 0x40, 0x2b,
		0xb9, 0x21, 0x43, 0xb3, 0x90, 0xb7, 0xcf, 0xd8, 0x3e, 0x48, 0x82, 0x82, 0x80, 0x7d, 0xc6, 0x16,
		0x00, 0xf7, 0x43, 0x81, 0x8c, 0x54, 0x0d, 0x3b, 0x1b, 0x39, 0x25, 0x4f, 0xea, 0x38, 0x88, 0xfc,
		0x2f, 0xe3, 0x20, 0x75, 0x2b, 0x20, 0x3f, 0xb7, 0x18, 0x3b, 0x74, 0x6e, 0xf1, 0x58, 0x77, 0x56,
		0x33, 0x48, 0x64, 0x2e, 0x83, 0x14, 0xe4, 0xe3, 0x98, 0x21, 0x18, 0xec, 0x3c, 0x75, 0x79, 0x79,
		0x4a, 0x49, 0xef, 0x72, 0xfb, 0x2e, 0x45, 0xf6, 0x61, 0xc4, 0xeb, 0xcb, 0xdd, 0x53, 0xec, 0xfb,
		0x0c, 0x9b, 0x76, 0x53, 0xf3, 0xb0, 0xc8, 0x8f, 0x84, 0xb6, 0x64, 0x1e, 0x82, 0x92, 0x66, 0xdb,
		0xaa, 0xeb, 0x69, 0x1e, 0xe6, 0xa6, 0x3d, 0xc5, 0xd2, 0x84, 0x9a, 0x6d, 0x37, 0x48, 0x2d, 0x33,
		0xed, 0x0f, 0x42, 0x91, 0xe8, 0x64, 0x43, 0x6b, 0xa9, 0x3c, 0x5b, 0x90, 0x66, 0x1e, 0x00, 0xaf,
		0xbd, 0x42, 0x2b, 0xe5, 0xa6, 0x3f, 0xe3, 0x54, 0x1f, 0xfb, 0xe1, 0x56, 0x2c, 0x14, 0x6e, 0x21,
		0x7e, 0xcd, 0x9c, 0xf1, 0x47, 0xdc, 0xcc, 0xef, 0x9f, 0xe5, 0x9d, 0xa2, 0xa1, 0xd9, 0x4d, 0x96,
		0xf8, 0xc8, 0x2a, 0xac, 0x20, 0xbf, 0x16, 0x87, 0x89, 0x1e, 0xcd, 0xdd, 0x37, 0xfd, 0x1d, 0xc4,
		0x99, 0xf1, 0x43, 0xc5, 0x99, 0xd7, 0xa2, 0xe9, 0xdd, 0x90, 0xe5, 0x3b, 0xde, 0xc3, 0x64, 0xa6,
		0x37, 0x89, 0x40, 0x73, 0x22, 0xa1, 0x0c, 0x30, 0x15, 0xf3, 0x4d, 0x98, 0xda, 0xda, 0x7f, 0x45,
		0x33, 0x3d, 0xc3, 0xc4, 0x6a, 0xcf, 0xac, 0xf5, 0x9a, 0xd2, 0x15, 0xc3, 0xdd, 0xc2, 0xbb, 0xda,
		0x4d, 0xc3, 0x12, 0xdd, 0x9a, 0xf4, 0xf1, 0x83, 0x24, 0xaf, 0xac, 0x40, 0x31, 0x6a, 0x7a, 0x50,
		0x11, 0xe2, 0xde, 0x1e, 0x1f, 0x7f, 0xdc, 0xdb, 0x43, 0x8f, 0xf3, 0x7c, 0x50, 0x9c, 0xe6, 0x83,
		0x7a, 0x3f, 0xc4, 0xf1, 0x82, 0x64, 0x90, 0x2c, 0xfb, 0xab, 0xc1, 0x37, 0x47, 0xdd, 0x54, 0xe5,
		0x93, 0x50, 0xea, 0xb2, 0x37, 0x83, 0xb2, 0x83, 0x72, 0x09, 0xc6, 0x23, 0xc6, 0x45, 0x3e, 0x02,
		0x53, 0xfd, 0x6c, 0x85, 0xbc, 0xeb, 0xd7, 0x47, 0x74, 0x3e, 0x3a, 0x0b, 0x59, 0xdf, 0x58, 0xf4,
		0xc9, 0x46, 0xd0, 0x51, 0x08, 0x60, 0xc5, 0x07, 0x8d, 0x24, 0xb5, 0xe3, 0x91, 0xa4, 0xb6, 0xfc,
		0x3e, 0x98, 0x1e, 0x64, 0x08, 0xba, 0x86, 0x91, 0xf4, 0xa5, 0xf0, 0x08, 0xa4, 0xf9, 0x23, 0x5c,
		0x71, 0xba, 0x8d, 0xc3, 0x4b, 0x44, 0x3a, 0x99, 0x51, 0x48, 0xb0, 0xdd, 0x1d, 0x5a, 0x90, 0x55,
		0x38, 0x36, 0xd0, 0x18, 0x0c, 0xde, 0x10, 0x62, 0x84, 0xf8, 0x86, 0x90, 0x2e, 0xba, 0xe3, 0xd2,
		0xb1, 0x8a, 0x43, 0x10, 0xac, 0x24, 0x7f, 0x38, 0x01, 0x47, 0xfa, 0x9b, 0x04, 0x34, 0x07, 0x05,
		0xe2, 0x7b, 0x7b, 0x51, 0x37, 0x1d, 0xda, 0xda, 0xde, 0x06, 0xf7, 0xd1, 0x79, 0x42, 0x3d, 0xee,
		0x27, 0xd4, 0xd1, 0x26, 0x4c, 0xb4, 0x2c, 0x5d, 0x6b, 0xa9, 0x21, 0x89, 0xe7, 0xc2, 0xfe, 0x40,
		0x0f, 0xb3, 0x6b, 0xec, 0x69, 0xde, 0x66, 0x8f, 0xd0, 0x97, 0x28, 0x8d, 0x65, 0x5f, 0xf2, 0xd1,
		0x12, 0xe4, 0xdb, 0x81, 0x20, 0x1f, 0x42, 0xd8, 0xc3, 0x68, 0xa1, 0x29, 0x49, 0xf5, 0xdd, 0xfe,
		0x49, 0x1f, 0x5a, 0x45, 0x0f, 0xda, 0x49, 0xc9, 0x0c, 0xdc, 0x49, 0xe9, 0xb7, 0x6d, 0x91, 0xed,
		0xbf, 0x6d, 0xf1, 0x81, 0xf0, 0xd4, 0x44, 0x8c, 0x68, 0xef, 0x4e, 0x06, 0x6a, 0xc0, 0x14, 0xc7,
		0x6f, 0x46, 0x78, 0x1f, 0x1f, 0x55, 0xd1, 0x20, 0x81, 0x3e, 0x98, 0xed, 0x89, 0xbb, 0x63, 0xbb,
		0xd0, 0xa5, 0xc9, 0x90, 0x2e, 0xfd, 0xff, 0x6c, 0x2a, 0xfe, 0x75, 0x0e, 0xb2, 0x0a, 0x76, 0x6d,
		0x62, 0x38, 0xd1, 0x22, 0xe4, 0xf0, 0x9e, 0x8e, 0x6d, 0x2f, 0xd8, 0xae, 0xec, 0x17, 0x0c, 0x30,
		0xe8, 0x9a, 0x80, 0x24, 0x9e, 0xb8, 0x8f, 0x86, 0x9e, 0xe4, 0xc1, 0xd6, 0xe0, 0xb8, 0x89, 0xa3,
		0x87, 0xa3, 0xad, 0x73, 0x22, 0xda, 0x4a, 0x0c, 0x74, 0xbe, 0x19, 0x56, 0x57, 0xb8, 0xf5, 0x24,
		0x0f, 0xb7, 0x92, 0x43, 0x3e, 0x16, 0x89, 0xb7, 0xaa, 0x91, 0x78, 0x2b, 0x3d, 0x64, 0x98, 0x03,
		0x02, 0xae, 0x73, 0x22, 0xe0, 0xca, 0x0c, 0xe9, 0x71, 0x57, 0xc4, 0x75, 0x29, 0x1a, 0x71, 0x65,
		0x07, 0x28, 0x10, 0x81, 0x3d, 0x30, 0xe4, 0x7a, 0x26, 0x14, 0x72, 0xe5, 0x06, 0xc6, 0x3b, 0x8c,
		0x48, 0x9f, 0x98, 0xab, 0x1a, 0x89, 0xb9, 0x60, 0x08, 0x0f, 0x06, 0x04, 0x5d, 0xef, 0x0e, 0x07,
		0x5d, 0xf9, 0x81, 0x71, 0x1b, 0x9f, 0xef, 0x7e, 0x51, 0xd7, 0x05, 0x3f, 0xea, 0x2a, 0x0c, 0x0c,
		0x1b, 0xf9, 0x18, 0xba, 0xc3, 0xae, 0xb5, 0x9e, 0xb0, 0x6b, 0x9c, 0xbf, 0x7a, 0x3f, 0x88, 0xc4,
		0x90, 0xb8, 0x6b, 0xad, 0x27, 0xee, 0x2a, 0x0e, 0x21, 0x38, 0x24, 0xf0, 0xfa, 0xe1, 0xfe, 0x81,
		0xd7, 0xe0, 0xd0, 0x88, 0x77, 0x73, 0xb4, 0xc8, 0x4b, 0x1d, 0x10, 0x79, 0xb1, 0xe8, 0xe8, 0x91,
		0x81, 0xe4, 0x47, 0x0e, 0xbd, 0x36, 0xfb, 0x84, 0x5e, 0x2c, 0x48, 0x3a, 0x31, 0x90, 0xf8, 0x08,
		0xb1, 0xd7, 0x66, 0x9f, 0xd8, 0x0b, 0x0d, 0x25, 0x7b, 0x98, 0xe0, 0x2b, 0x25, 0xa5, 0xe5, 0x93,
		0xc4, 0xf5, 0xed, 0xd2, 0x53, 0xc4, 0x7f, 0xc0, 0x8e, 0x63, 0x39, 0xe2, 0xc4, 0x2d, 0x2d, 0xc8,
		0x27, 0x88, 0x33, 0x1e, 0xe8, 0xa4, 0x03, 0x02, 0x35, 0xea, 0xa7, 0x85, 0xf4, 0x90, 0xfc, 0xc5,
		0x58, 0x80, 0x4b, 0x7d, 0xd8, 0xb0, 0x23, 0x9f, 0xe3, 0x8e, 0x7c, 0x28, 0x7c, 0x8b, 0x47, 0xc3,
		0xb7, 0x59, 0xc8, 0x13, 0xff, 0xab, 0x2b, 0x32, 0xd3, 0x6c, 0x3f, 0x32, 0x13, 0x47, 0x0b, 0x58,
		0x90, 0xc7, 0xcd, 0x0a, 0xdb, 0xd1, 0x29, 0xf9, 0xc7, 0x2c, 0x58, 0x4c, 0x81, 0x1e, 0x83, 0xc9,
		0x10, 0xac, 0xef, 0xd7, 0xb1, 0x30, 0x45, 0xf2, 0xa1, 0x2b, 0xdc, 0xc1, 0xfb, 0x27, 0xb1, 0x80,
		0x43, 0x41, 0x48, 0xd7, 0x2f, 0xfa, 0x8a, 0xbd, 0x49, 0xd1, 0x57, 0xfc, 0xae, 0xa3, 0xaf, 0xb0,
		0x9f, 0x9a, 0x88, 0xfa, 0xa9, 0xff, 0x33, 0x16, 0xcc, 0x89, 0x1f, 0x4b, 0xe9, 0x56, 0x13, 0x73,
		0xcf, 0x91, 0xfe, 0x26, 0x4e, 0x45, 0xcb, 0xda, 0xe1, 0xfe, 0x21, 0xf9, 0x49, 0xa0, 0x7c, 0xc3,
		0x91, 0xe3, 0x76, 0xc1, 0x77, 0x3a, 0x53, 0xe1, 0x73, 0xc1, 0xfc, 0xb0, 0x6c, 0x3a, 0x38, 0x2c,
		0xeb, 0x5f, 0x6f, 0xca, 0x84, 0xae, 0x37, 0xa1, 0xa7, 0x21, 0x47, 0x33, 0xa2, 0xaa, 0x65, 0x8b,
		0xff, 0x91, 0x70, 0x7c, 0xf0, 0x41, 0x59, 0x97, 0x1e, 0xdb, 0x63, 0x87, 0x6b, 0x03, 0x8f, 0x21,
		0x17, 0xf1, 0x18, 0xee, 0x85, 0x1c, 0xe9, 0x3d, 0x7b, 0xeb, 0x17, 0xf8, 0xdd, 0x38, 0x51, 0x21,
		0xbf, 0x17, 0x50, 0xaf, 0x91, 0x40, 0x57, 0x20, 0x8d, 0x6f, 0xd2, 0x87, 0xd3, 0xd8, 0xa1, 0xc3,
		0x23, 0xbd, 0xae, 0x29, 0x69, 0x5e, 0x9c, 0x26, 0x4c, 0xfe, 0xe6, 0xeb, 0xb3, 0x12, 0x83, 0x7e,
		0xd4, 0x6a, 0x1b, 0x1e, 0x6e, 0xdb, 0xde, 0xbe, 0xc2, 0xf1, 0xe5, 0xdf, 0x89, 0x93, 0x00, 0x26,
		0x62, 0x40, 0xfa, 0xf2, 0xb6, 0xdf, 0x56, 0xe1, 0x68, 0xfc, 0x9e, 0x01, 0xd8, 0xd1, 0x5c, 0xf5,
		0x96, 0x66, 0x7a, 0xb8, 0xc9, 0x99, 0x1e, 0xaa, 0x41, 0x65, 0xc8, 0x92, 0x52, 0xc7, 0xc5, 0x4d,
		0x1e, 0x46, 0xfb, 0xe5, 0xd0, 0x38, 0x33, 0xdf, 0xdf, 0x38, 0xa3, 0x5c, 0xce, 0x76, 0x71, 0x39,
		0x14, 0x5c, 0xe4, 0xc2, 0xc1, 0x05, 0x3b, 0x2c, 0xcc, 0xcf, 0x2a, 0x02, 0xeb, 0x9b, 0x28, 0xa3,
		0x07, 0x60, 0xbc, 0x8d, 0xdb, 0xb6, 0x65, 0xb5, 0x54, 0xa6, 0x6e, 0xd8, 0xa3, 0xde, 0x05, 0x5e,
		0x59, 0xa3, 0x5a, 0xe7, 0xc7, 0xe2, 0xc1, 0xfa, 0x0b, 0x82, 0xc8, 0x1f, 0x38, 0x06, 0xcb, 0x7f,
		0x91, 0x66, 0x96, 0xa2, 0x2e, 0x02, 0x6a, 0x84, 0x4f, 0x8f, 0x74, 0xa8, 0x5a, 0x10, 0x02, 0x3d,
		0xaa, 0xfe, 0x08, 0x4e, 0x99, 0xb0, 0x6a, 0x17, 0xbd, 0x08, 0x47, 0xbb, 0x74, 0x9b, 0x4f, 0x3a,
		0x3e, 0xaa, 0x8a, 0xbb, 0x27, 0xaa, 0xe2, 0x04, 0xe9, 0x80, 0x59, 0x89, 0xef, 0x73, 0xd5, 0xd5,
		0xa1, 0x18, 0xf5, 0x78, 0xfa, 0x4e, 0x3f, 0xfd, 0x27, 0x12, 0x9e, 0x66, 0x98, 0x6a, 0x24, 0x1d,
		0x54, 0x60, 0x95, 0x3c, 0xc9, 0xb4, 0x0e, 0xf7, 0xf4, 0xf5, 0x7c, 0xd0, 0x79, 0xc8, 0x05, 0x4e,
		0x13, 0xe3, 0xea, 0x01, 0xe9, 0x82, 0x00, 0x56, 0xfe, 0xf5, 0x58, 0x40, 0x32, 0x9a, 0x80, 0xa8,
		0x41, 0x9a, 0x1d, 0x7f, 0xe3, 0x87, 0x6a, 0x1e, 0x1b, 0xcd, 0x67, 0x9a, 0x67, 0x67, 0xe3, 0x14,
		0x8e, 0x2c, 0xbf, 0x17, 0xd2, 0xac, 0x06, 0xe5, 0x21, 0x13, 0xbc, 0x6d, 0x0a, 0x90, 0xae, 0x54,
		0xab, 0xb5, 0xf5, 0x0d, 0x29, 0x86, 0x72, 0x90, 0xaa, 0x2c, 0xae, 0x29, 0x1b, 0x52, 0x9c, 0x54,
		0x2b, 0xb5, 0xab, 0xb5, 0xea, 0x86, 0x94, 0x40, 0x13, 0x30, 0xce, 0x7e, 0xab, 0x97, 0xd6, 0x94,
		0x95, 0xca, 0x86, 0x94, 0x0c, 0x55, 0x35, 0x6a, 0xab, 0x4b, 0x35, 0x45, 0x4a, 0xc9, 0x4f, 0xc0,
		0xb1, 0x81, 0x5e, 0x56, 0x90, 0x5d, 0x88, 0x85, 0xb2, 0x0b, 0xf2, 0x87, 0xe3, 0x50, 0x1e, 0xec,
		0x3a, 0xa1, 0xab, 0x5d, 0x03, 0x3f, 0x73, 0x08, 0xbf, 0xab, 0x6b, 0xf4, 0xe8, 0x41, 0x28, 0x3a,
		0x78, 0x1b, 0x7b, 0xfa, 0x2e, 0x73, 0xe5, 0x98, 0xc9, 0x1c, 0x57, 0xc6, 0x79, 0x2d, 0x45, 0x72,
		0x19, 0xd8, 0xcb, 0x58, 0xf7, 0x54, 0xa6, 0x8b, 0x5c, 0xfe, 0xdf, 0xec, 0xc6, 0x59, 0x6d, 0x83,
		0x55, 0xca, 0xef, 0x3b, 0x14, 0x2f, 0x73, 0x90, 0x52, 0x6a, 0x1b, 0xca, 0x8b, 0x52, 0x02, 0x21,
		0x28, 0xd2, 0x9f, 0x6a, 0x63, 0xb5, 0xb2, 0xde, 0xb8, 0xb2, 0x46, 0x78, 0x39, 0x09, 0x25, 0xc1,
		0x4b, 0x51, 0x99, 0x92, 0x1f, 0x81, 0xa3, 0x03, 0xfc, 0xbe, 0x3e, 0xe7, 0x11, 0x3f, 0x11, 0x0b,
		0x43, 0x47, 0x63, 0xfe, 0x35, 0x48, 0xbb, 0x9e, 0xe6, 0x75, 0x5c, 0xce, 0xc4, 0xf3, 0xa3, 0x3a,
		0x82, 0xf3, 0xe2, 0x47, 0x83, 0xa2, 0x2b, 0x9c, 0x8c, 0x7c, 0x16, 0x8a, 0xd1, 0x96, 0xc1, 0x3c,
		0x08, 0x84, 0x28, 0x2e, 0xbf, 0x08, 0x10, 0xca, 0x47, 0xfa, 0x27, 0xbb, 0x62, 0xe1, 0x93, 0x5d,
		0x67, 0x21, 0x75, 0xd3, 0x62, 0x3a, 0xa3, 0xff, 0xc2, 0xb9, 0x6e, 0x79, 0x38, 0x94, 0x7c, 0x60,
		0xd0, 0xb2, 0x01, 0xa8, 0x37, 0x27, 0x34, 0xe0, 0x13, 0xcf, 0x44, 0x3f, 0x71, 0xff, 0xc0, 0xec,
		0x52, 0xff, 0x4f, 0xbd, 0x02, 0x29, 0xaa, 0x6d, 0xfa, 0x5e, 0xfd, 0x79, 0x0f, 0x80, 0xe6, 0x79,
		0x8e, 0xb1, 0xd5, 0x09, 0x3e, 0x30, 0xdb, 0x5f, 0x5b, 0x55, 0x04, 0xdc, 0xe2, 0xbd, 0x5c, 0x6d,
		0x4d, 0x05, 0xa8, 0x21, 0xd5, 0x15, 0x22, 0x28, 0xaf, 0x42, 0x31, 0x8a, 0xdb, 0xff, 0x2a, 0x53,
		0x70, 0x3b, 0x3c, 0x27, 0xdc, 0x27, 0xdf, 0xf9, 0xe2, 0x2f, 0x36, 0xd0, 0x82, 0x7c, 0x3b, 0x06,
		0xd9, 0x8d, 0x3d, 0x2e, 0xc7, 0x07, 0x1c, 0xae, 0x0c, 0xee, 0x73, 0xf9, 0xc9, 0x42, 0x96, 0x8f,
		0x4d, 0xf8, 0x59, 0xde, 0x77, 0xfb, 0x2b, 0x35, 0x39, 0x6a, 0xb4, 0x2b, 0xb2, 0xdd, 0x5c, 0x3b,
		0x5d, 0x1c, 0xed, 0xbe, 0xc4, 0x14, 0xa4, 0xc2, 0x77, 0x1d, 0x58, 0x41, 0x6e, 0x86, 0x8e, 0x26,
		0x30, 0xb3, 0x11, 0xbe, 0x58, 0x11, 0x3b, 0xf4, 0xc5, 0x0a, 0xff, 0x2b, 0xf1, 0xf0, 0x57, 0x6e,
		0x42, 0x56, 0x08, 0x05, 0x7a, 0x57, 0xf8, 0xfc, 0x89, 0xd8, 0xa3, 0x19, 0x68, 0x3c, 0x39, 0xf9,
		0xd0, 0xf1, 0x93, 0x53, 0x30, 0xc1, 0x8f, 0xde, 0x05, 0x71, 0x05, 0x7f, 0x7d, 0xbd, 0xc4, 0x1a,
		0x96, 0x45, 0x50, 0x21, 0xff, 0x42, 0x0c, 0xa4, 0x6e, 0xa9, 0x7c, 0x3b, 0x3b, 0x40, 0x94, 0x22,
		0x91, 0xfe, 0xd0, 0xb3, 0xca, 0x6c, 0xe6, 0xc7, 0x49, 0x6d, 0xf0, 0xb0, 0xf2, 0x6b, 0x71, 0xc8,
		0x87, 0x72, 0x7a, 0xe8, 0xa9, 0xc8, 0x51, 0xd0, 0xb9, 0x83, 0xf2, 0x7f, 0xa1, 0xb3, 0xa0, 0x91,
		0x81, 0xc5, 0x0f, 0x3f, 0xb0, 0x37, 0xff, 0xb0, 0x7e, 0xff, 0x9b, 0x3f, 0xa9, 0x01, 0x37, 0x7f,
		0xfe, 0x4c, 0x0c, 0xb2, 0xbe, 0xe9, 0x3e, 0x6c, 0x36, 0xff, 0x08, 0xa4, 0xb9, 0x75, 0x62, 0xe9,
		0x7c, 0x5e, 0xea, 0x9b, 0x0b, 0x2d, 0x43, 0x56, 0xfc, 0xdb, 0x12, 0x1e, 0x88, 0xfa, 0xe5, 0x53,
		0x17, 0x20, 0x1f, 0xda, 0x58, 0x21, 0x7a, 0x62, 0xb5, 0xf6, 0xbc, 0x34, 0x56, 0xce, 0xdc, 0xbe,
		0x33, 0x97, 0x58, 0xc5, 0xb7, 0xc8, 0x0a, 0x53, 0x6a, 0xd5, 0x2b, 0xb5, 0xea, 0x35, 0x29, 0x56,
		0xce, 0xdf, 0xbe, 0x33, 0x97, 0x51, 0x30, 0x4d, 0x5f, 0x9d, 0xba, 0x06, 0xa5, 0xae, 0x89, 0x89,
		0xea, 0x77, 0x04, 0xc5, 0xa5, 0xcd, 0xf5, 0xe5, 0x7a, 0xb5, 0xb2, 0x51, 0x53, 0xd9, 0xb1, 0x3a,
		0x74, 0x14, 0x26, 0x97, 0xeb, 0x97, 0xaf, 0x6c, 0xa8, 0xd5, 0xe5, 0x7a, 0x6d, 0x75, 0x43, 0xad,
		0x6c, 0x6c, 0x54, 0xaa, 0xd7, 0xa4, 0xf8, 0x99, 0xef, 0x02, 0x94, 0x2a, 0x8b, 0xd5, 0x3a, 0xb1,
		0xcf, 0x06, 0x7f, 0x19, 0xbb, 0x0a, 0x49, 0x9a, 0x0a, 0x38, 0xf0, 0xa8, 0x48, 0xf9, 0xe0, 0xdc,
		0x26, 0xba, 0x04, 0x29, 0x9a, 0x25, 0x40, 0x07, 0x9f, 0x1d, 0x29, 0x0f, 0x49, 0x76, 0x92, 0xce,
		0xd0, 0xe5, 0x74, 0xe0, 0x61, 0x92, 0xf2, 0xc1, 0xb9, 0x4f, 0xa4, 0x40, 0x2e, 0x88, 0x32, 0x86,
		0x1f, 0xae, 0x28, 0x8f, 0xa0, 0x1d, 0xd1, 0x32, 0x64, 0x44, 0x60, 0x38, 0xec, 0xb8, 0x47, 0x79,
		0x68, 0x72, 0x92, 0xb0, 0x8b, 0x05, 0xf0, 0x07, 0x9f, 0x5d, 0x29, 0x0f, 0xc9, 0xb4, 0xa2, 0xba,
		0x7f, 0x18, 0x7f, 0xc8, 0x11, 0x8e, 0xf2, 0xb0, 0x64, 0x23, 0x61, 0x5a, 0x90, 0x1a, 0x19, 0x7e,
		0x22, 0xa7, 0x3c, 0x42, 0x12, 0x19, 0x6d, 0x02, 0x84, 0xc2, 0xf5, 0x11, 0x8e, 0xda, 0x94, 0x47,
		0x49, 0x0e, 0xa3, 0x35, 0xc8, 0xfa, 0xd1, 0xd3, 0xd0, 0x83, 0x2f, 0xe5, 0xe1, 0x59, 0x5a, 0xf4,
		0x5e, 0x18, 0x8f, 0x46, 0x0d, 0xa3, 0x1d, 0x67, 0x29, 0x8f, 0x98, 0x7e, 0x25, 0xf4, 0xa3, 0x21,
		0xc4, 0x68, 0xc7, 0x5b, 0xca, 0x23, 0x66, 0x63, 0xd1, 0xcb, 0x30, 0xd1, 0xeb, 0xe2, 0x8f, 0x7e,
		0xda, 0xa5, 0x7c, 0x88, 0xfc, 0x2c, 0x6a, 0x03, 0xea, 0x13, 0x1a, 0x1c, 0xe2, 0xf0, 0x4b, 0xf9,
		0x30, 0xe9, 0x5a, 0xd4, 0x84, 0x52, 0xb7, 0xbf, 0x3d, 0xea, 0x61, 0x98, 0xf2, 0xc8, 0xa9, 0x5b,
		0xf6, 0x95, 0xa8, 0x9f, 0x3e, 0xea, 0xe1, 0x98, 0xf2, 0xc8, 0x99, 0xdc, 0x11, 0x9f, 0x87, 0xe8,
		0x7f, 0xc6, 0x31, 0x38, 0xb5, 0xe8, 0x9f, 0x6b, 0xfc, 0xdd, 0xd3, 0xf0, 0x0e, 0xfe, 0xd0, 0x80,
		0xeb, 0x69, 0x37, 0x0c, 0x73, 0xc7, 0x7f, 0x21, 0x82, 0x97, 0xf9, 0x01, 0xc7, 0x23, 0xfc, 0x31,
		0x03, 0x51, 0x3b, 0xe4, 0x9d, 0x88, 0x81, 0xcf, 0x23, 0x0d, 0x3b, 0x8c, 0x3c, 0xfc, 0xf8, 0xe2,
		0xe0, 0x37, 0x28, 0xca, 0x43, 0x5e, 0xba, 0x18, 0x72, 0xea, 0xf2, 0xa0, 0x03, 0x9e, 0xf2, 0x07,
		0x63, 0x50, 0xbc, 0x62, 0xb8, 0x9e, 0xe5, 0x18, 0xba, 0xd6, 0xa2, 0x26, 0xe2, 0xdc, 0xa8, 0xb7,
		0x3b, 0xba, 0x0e, 0x81, 0x3c, 0x0b, 0xe9, 0x9b, 0x5a, 0x8b, 0x5d, 0xab, 0x08, 0xbf, 0x46, 0xd2,
		0xcd, 0xdb, 0x1e, 0x8f, 0x88, 0xa3, 0xc9, 0x9f, 0xa5, 0xe7, 0xb5, 0xdb, 0x6d, 0xc3, 0x65, 0xff,
		0x3f, 0xd8, 0xc3, 0x2e, 0x5a, 0x87, 0xa4, 0xa3, 0x79, 0x3c, 0x76, 0x59, 0x7c, 0x27, 0x7f, 0x89,
		0xe2, 0xa1, 0xe1, 0xef, 0x49, 0xcc, 0xf7, 0x3e, 0x56, 0x41, 0x29, 0xa1, 0xe7, 0x21, 0xdb, 0xd6,
		0xf6, 0x54, 0x4a, 0x35, 0xfe, 0x26, 0x50, 0xcd, 0xb4, 0xb5, 0x3d, 0xd2, 0x57, 0xb2, 0x50, 0x08,
		0x61, 0x7d, 0x57, 0x33, 0x77, 0x30, 0xa3, 0x9f, 0x78, 0x13, 0xe8, 0x8f, 0xb7, 0xb5, 0xbd, 0x2a,
		0xa5, 0x49, 0xbe, 0xb2, 0x90, 0xfd, 0xf0, 0xc7, 0x67, 0xc7, 0xe8, 0xb1, 0xe3, 0x5f, 0x8b, 0xf1,
		0x30, 0x95, 0xb2, 0x0b, 0xfd, 0x30, 0x48, 0xba, 0x5f, 0xa2, 0x9f, 0x17, 0x29, 0xfb, 0x87, 0x07,
		0x4d, 0x44, 0x17, 0xb3, 0x99, 0x37, 0xf9, 0xd5, 0xd7, 0x67, 0x63, 0x4a, 0x49, 0xef, 0x9a, 0x87,
		0x1a, 0xe4, 0x59, 0x92, 0x4c, 0xa5, 0x9e, 0x69, 0xfc, 0x10, 0x9e, 0x29, 0x30, 0x44, 0xd2, 0x14,
		0xea, 0xfd, 0x67, 0x63, 0x90, 0x5f, 0x0a, 0x3d, 0x33, 0x34, 0x0d, 0x99, 0xb6, 0x65, 0x1a, 0x37,
		0xb0, 0xe3, 0xef, 0xb6, 0xb0, 0x22, 0x71, 0x1e, 0xd9, 0xbf, 0x8b, 0xf1, 0xf6, 0xc5, 0x9b, 0x0b,
		0xa2, 0x4c, 0xb0, 0x6e, 0xe1, 0x2d, 0xd7, 0x10, 0xbc, 0x56, 0x44, 0x11, 0x9d, 0x04, 0xc9, 0xc5,
		0x7a, 0xc7, 0x31, 0xbc, 0x7d, 0x55, 0xb7, 0x4c, 0x4f, 0xd3, 0x3d, 0x9e, 0x13, 0x2d, 0x89, 0xfa,
		0x2a, 0xab, 0x26, 0x44, 0x9a, 0xd8, 0xd3, 0x8c, 0x16, 0x3b, 0xcc, 0x95, 0x53, 0x44, 0x31, 0xdc,
		0xdd, 0x4c, 0x38, 0xe8, 0xab, 0x82, 0x64, 0xd9, 0xd8, 0x89, 0x5c, 0x6a, 0x63, 0x12, 0x3a, 0xfd,
		0x9b, 0x9f, 0x7f, 0x6c, 0x8a, 0xb3, 0x9b, 0x6f, 0xad, 0xb3, 0x97, 0x75, 0x95, 0x92, 0xc0, 0x10,
		0xb7, 0xdd, 0x5e, 0x8c, 0xec, 0xb1, 0x74, 0xb6, 0x82, 0x8b, 0xf5, 0x53, 0x3d, 0x7c, 0xad, 0x98,
		0xfb, 0x8b, 0xd3, 0x5f, 0x09, 0x48, 0x07, 0x41, 0xe1, 0x35, 0xbc, 0x1f, 0xde, 0x70, 0xa1, 0x64,
		0x88, 0x6f, 0xfe, 0xb2, 0x66, 0xb4, 0xc4, 0x7f, 0xc1, 0x52, 0x78, 0x09, 0x2d, 0xf8, 0x09, 0x16,
		0xf6, 0xdf, 0xad, 0xe5, 0x41, 0x92, 0xb1, 0x68, 0x99, 0xcd, 0x68, 0x2e, 0x05, 0x6d, 0x40, 0xda,
		0xb3, 0x6e, 0x60, 0x93, 0x33, 0xe9, 0x50, 0x52, 0xdd, 0xe7, 0x35, 0x1c, 0x46, 0x0b, 0xed, 0x80,
		0xd4, 0xc4, 0x2d, 0xbc, 0xc3, 0xae, 0x64, 0xed, 0x6a, 0x0e, 0x66, 0xd7, 0x34, 0xbf, 0xdf, 0x55,
		0x53, 0xf2, 0xa9, 0x36, 0x28, 0x51, 0x74, 0x2d, 0xfa, 0xd0, 0x55, 0x86, 0xef, 0xb7, 0x0f, 0x18,
		0x7f, 0x48, 0x32, 0xc5, 0x79, 0x8f, 0xf0, 0x9b, 0x58, 0x27, 0x41, 0xea, 0x98, 0x5b, 0x96, 0x49,
		0xff, 0x57, 0x0d, 0x8f, 0x9a, 0xb2, 0x6c, 0x3b, 0xce, 0xaf, 0xe7, 0xdb, 0x71, 0xd7, 0xa0, 0x18,
		0x80, 0xd2, 0xb5, 0x93, 0x3b, 0xc4, 0xda, 0x19, 0xf7, 0x71, 0x49, 0x2b, 0xba, 0x02, 0x10, 0x2c,
		0x4c, 0x7f, 0xb7, 0x7e, 0xe8, 0xea, 0x16, 0x5b, 0x69, 0x01, 0x2e, 0x6a, 0xc1, 0x64, 0xdb, 0x30,
		0x55, 0x17, 0xb7, 0xb6, 0x55, 0xce, 0x2a, 0x42, 0x32, 0xff, 0x26, 0x4c, 0xed, 0x44, 0xdb, 0x30,
		0x1b, 0xb8, 0xb5, 0xbd, 0xe4, 0x93, 0x45, 0xef, 0x84, 0xe3, 0x01, 0x13, 0x2c, 0x53, 0xdd, 0xb5,
		0x5a, 0x4d, 0xd5, 0xc1, 0xdb, 0xaa, 0x4e, 0x5f, 0x38, 0x2a, 0x50, 0xd6, 0x1d, 0xf5, 0x41, 0xd6,
		0xcc, 0x2b, 0x56, 0xab, 0xa9, 0xe0, 0xed, 0x2a, 0x69, 0x46, 0x0f, 0x40, 0xc0, 0x06, 0xd5, 0x68,
		0xba, 0xd3, 0xe3, 0x73, 0x89, 0x13, 0x49, 0xa5, 0xe0, 0x57, 0xd6, 0x9b, 0xee, 0x42, 0xe1, 0x03,
		0x1f, 0x9f, 0x1d, 0xe3, 0xcb, 0x75, 0x4c, 0x5e, 0xa7, 0xef, 0x70, 0xf0, 0x95, 0x86, 0x5d, 0x74,
		0x0e, 0x72, 0x9a, 0x28, 0xb0, 0x9b, 0x1f, 0x07, 0xac, 0xd4, 0x00, 0x94, 0x29, 0x80, 0x57, 0x7f,
		0x67, 0x2e, 0x26, 0xff, 0x7c, 0x0c, 0xd2, 0x4b, 0xd7, 0xd7, 0x35, 0xc3, 0x41, 0x35, 0x98, 0x08,
		0x64, 0x76, 0xd4, 0xe5, 0x1f, 0x88, 0xb9, 0x58, 0xff, 0xb5, 0x41, 0x57, 0x63, 0x0f, 0x24, 0xd3,
		0x7d, 0x69, 0xb6, 0x6b, 0xe0, 0x35, 0xc8, 0xb0, 0x5e, 0xba, 0x68, 0x01, 0x52, 0x36, 0xf9, 0xc1,
		0x53, 0xfb, 0x33, 0x03, 0x65, 0x9d, 0xc2, 0xfb, 0xcf, 0x24, 0x10, 0x14, 0xf9, 0x7b, 0x31, 0x80,
		0xa5, 0xeb, 0xd7, 0x37, 0x1c, 0xc3, 0x6e, 0x61, 0xef, 0xcd, 0x1a, 0xf1, 0x32, 0xdc, 0x13, 0xba,
		0x7f, 0xe9, 0xe8, 0x23, 0x8f, 0x7a, 0x32, 0xb8, 0x81, 0xe9, 0xe8, 0x7d, 0xa9, 0x35, 0x5d, 0xcf,
		0xa7, 0x96, 0x18, 0x99, 0xda, 0x92, 0xeb, 0xf5, 0x67, 0x63, 0x03, 0xf2, 0xc1, 0xf0, 0x5d, 0xb4,
		0x04, 0x59, 0x8f, 0xff, 0xe6, 0xdc, 0x94, 0x07, 0x73, 0x53, 0xa0, 0x71, 0x8e, 0xfa, 0x98, 0xf2,
		0xff, 0x21, 0x4c, 0x0d, 0x16, 0xc5, 0x9f, 0x28, 0x31, 0x22, 0xea, 0x9d, 0xab, 0xdf, 0x37, 0xc3,
		0x69, 0xe1, 0xb4, 0xba, 0xb8, 0xfa, 0x5a, 0x1c, 0x26, 0x37, 0xc5, 0xa2, 0xfd, 0x13, 0xcb, 0x89,
		0x75, 0xc8, 0x60, 0xd3, 0x73, 0x0c, 0x2c, 0x76, 0xf1, 0x1e, 0x1f, 0x34, 0xd7, 0x7d, 0xc6, 0x42,
		0xff, 0x8f, 0xab, 0x78, 0xbc, 0x83, 0x93, 0xe9, 0xe2, 0xc2, 0xdf, 0x4f, 0xc0, 0xf4, 0x20, 0x4c,
		0xf4, 0x30, 0x94, 0x74, 0x07, 0xd3, 0x0a, 0x35, 0x92, 0xe4, 0x2e, 0x8a, 0x6a, 0x6e, 0x57, 0x56,
		0x80, 0xf8, 0x68, 0x44, 0xb0, 0x08, 0xe8, 0xa1, 0x9d, 0xb2, 0x62, 0x80, 0x4c, 0x2d, 0x0b, 0x86,
		0x92, 0x38, 0xb0, 0xbe, 0xa5, 0xb5, 0x34, 0x53, 0xbf, 0x1b, 0xe7, 0xb5, 0xd7, 0x16, 0x88, 0x53,
		0xf0, 0x8b, 0x8c, 0x26, 0xba, 0x0e, 0x19, 0x41, 0x3e, 0xf9, 0x26, 0x90, 0x17, 0xc4, 0xd0, 0xfd,
		0x50, 0x08, 0x9b, 0x08, 0xea, 0xa2, 0x24, 0x95, 0x7c, 0xc8, 0x42, 0x0c, 0xb3, 0x41, 0xe9, 0x03,
		0x6d, 0x50, 0xc8, 0x13, 0xfc, 0xd5, 0x04, 0x4c, 0x28, 0xb8, 0xf9, 0x83, 0x35, 0x6f, 0x3f, 0x04,
		0xc0, 0x56, 0x34, 0x51, 0xb4, 0x77, 0x31, 0x75, 0xbd, 0x1a, 0x22, 0xc7, 0xe8, 0x2d, 0xb9, 0xde,
		0xdb, 0x39, 0x79, 0x5f, 0x89, 0x43, 0x21, 0x3c, 0x79, 0x3f, 0x00, 0x96, 0x0d, 0xd5, 0x03, 0x7d,
		0xc6, 0x4e, 0x95, 0x9f, 0x1c, 0xa4, 0xcf, 0x7a, 0xc4, 0xfa, 0x60, 0x45, 0xf6, 0xed, 0x38, 0xa4,
		0xf9, 0x09, 0xaf, 0xab, 0x3d, 0x5e, 0x6e, 0x6c, 0xf4, 0xab, 0xbd, 0x5d, 0x4e, 0xee, 0x83, 0x50,
		0x24, 0x71, 0x74, 0xe4, 0xc4, 0x58, 0xec, 0xc4, 0x38, 0x0d, 0x84, 0x83, 0xf3, 0xcd, 0x68, 0x16,
		0xf2, 0x04, 0x2c, 0x50, 0xd5, 0x04, 0x06, 0xda, 0xda, 0x5e, 0x8d, 0xd5, 0xa0, 0xc7, 0x00, 0xed,
		0xfa, 0x99, 0x0d, 0x35, 0x60, 0x01, 0x81, 0x9b, 0x08, 0x5a, 0x04, 0xf8, 0x7d, 0x00, 0xa4, 0x17,
		0x2a, 0x7b, 0x8b, 0x93, 0x05, 0x82, 0x39, 0x52, 0xb3, 0x44, 0xdf, 0xe3, 0xfc, 0x11, 0xe6, 0x30,
		0x77, 0x85, 0xd8, 0x3c, 0x56, 0x59, 0x3e, 0xdc, 0x52, 0xf8, 0xf6, 0xeb, 0xb3, 0xe5, 0x7d, 0xad,
		0xdd, 0x5a, 0x90, 0xfb, 0x90, 0x94, 0xa9, 0x03, 0x1d, 0x0d, 0xcd, 0x43, 0x12, 0xfc, 0xc9, 0x18,
		0xa0, 0xc0, 0x68, 0xf8, 0x27, 0xb6, 0xaf, 0xd0, 0x73, 0xbc, 0xc2, 0x8d, 0x8f, 0x1d, 0x1c, 0x19,
		0x04, 0xf8, 0x22, 0x32, 0x08, 0xad, 0x88, 0x0b, 0x81, 0x8a, 0x16, 0xd7, 0xb3, 0xfb, 0x3c, 0xa4,
		0x3a, 0x5f, 0xb5, 0x0c, 0x81, 0x2d, 0xe0, 0xfd, 0x5e, 0x8e, 0xc9, 0xff, 0x2e, 0x06, 0xc7, 0x7a,
		0xa4, 0xc9, 0xef, 0xec, 0x7b, 0x01, 0x39, 0xa1, 0x46, 0xfe, 0xcf, 0xd0, 0x63, 0xfc, 0x22, 0xe2,
		0x21, 0x85, 0x73, 0xc2, 0xe9, 0x51, 0xc6, 0x6f, 0x91, 0x95, 0xe1, 0x0f, 0xac, 0xfe, 0xc3, 0x18,
		0x4c, 0x85, 0x3b, 0xe3, 0x0f, 0x6b, 0x15, 0x0a, 0xe1, 0xbe, 0xf0, 0x01, 0xbd, 0x63, 0x94, 0x01,
		0xf1, 0xb1, 0x44, 0xf0, 0xd1, 0x73, 0xc1, 0xc2, 0x65, 0x19, 0xb5, 0x27, 0x46, 0xe6, 0x8d, 0xbf,
		0x33, 0xd0, 0xb5, 0x80, 0x93, 0xc2, 0x0f, 0x4b, 0xae, 0x5b, 0x56, 0x0b, 0xfd, 0x29, 0x98, 0x30,
		0x2d, 0x4f, 0x25, 0x52, 0x8e, 0x9b, 0x2a, 0x0f, 0xef, 0x99, 0xf6, 0x7b, 0xee, 0x70, 0x2c, 0xfb,
		0xe6, 0xeb, 0xb3, 0xbd, 0xa4, 0xba, 0xf8, 0x58, 0x32, 0x2d, 0x6f, 0x91, 0xb6, 0x6f, 0xb0, 0xe0,
		0xdf, 0x81, 0xf1, 0xe8, 0xa7, 0x99, 0xb6, 0x5c, 0x39, 0xf4, 0xa7, 0xc7, 0x0f, 0xfa, 0x6c, 0x61,
		0x2b, 0xf4, 0x4d, 0xf6, 0xf4, 0xe4, 0x1f, 0x92, 0x79, 0xdc, 0x00, 0xe9, 0x7a, 0xf7, 0xd9, 0xb0,
		0x77, 0x43, 0xe6, 0xee, 0x8e, 0x99, 0x09, 0xb4, 0x53, 0x5f, 0x88, 0x01, 0x04, 0xd9, 0x13, 0xf4,
		0x28, 0x1c, 0x5d, 0x5c, 0x5b, 0x5d, 0x52, 0x1b, 0x1b, 0x95, 0x8d, 0xcd, 0x46, 0xf4, 0xd9, 0x6b,
		0xf1, 0x20, 0x88, 0x6b, 0x63, 0x9d, 0xfe, 0x03, 0x7a, 0xf4, 0x10, 0x4c, 0x45, 0xa1, 0x49, 0xa9,
		0xb6, 0x24, 0xc5, 0xca, 0x85, 0xdb, 0x77, 0xe6, 0xb2, 0xcc, 0x6b, 0xc4, 0x4d, 0x74, 0x02, 0xee,
		0xe9, 0x85, 0xab, 0xaf, 0x5e, 0x96, 0xe2, 0xe5, 0xf1, 0xdb, 0x77, 0xe6, 0x72, 0xbe, 0x7b, 0x89,
		0x64, 0x40, 0x61, 0x48, 0x4e, 0x2f, 0x51, 0x86, 0xdb, 0x77, 0xe6, 0xd2, 0x6c, 0x32, 0xca, 0xc9,
		0x0f, 0x7c, 0x72, 0x66, 0xec, 0xd4, 0x7b, 0x00, 0xea, 0xe6, 0xb6, 0xa3, 0xd1, 0xff, 0xfd, 0x8a,
		0xca, 0x70, 0xa4, 0xbe, 0x7a, 0x49, 0xa9, 0x54, 0x37, 0xea, 0x6b, 0xab, 0x5d, 0xaf, 0x75, 0x47,
		0xdb, 0x96, 0xd6, 0x36, 0x17, 0x97, 0x6b, 0x6a, 0xa3, 0x7e, 0x79, 0x95, 0x6d, 0xaf, 0x46, 0xda,
		0x9e, 0x5f, 0xdd, 0xa8, 0xaf, 0xd4, 0xa4, 0xf8, 0xe2, 0xa5, 0x81, 0x09, 0xfe, 0x47, 0x0f, 0x9c,
		0xe6, 0x3d, 0x3f, 0x81, 0x1f, 0xc9, 0xf0, 0xff, 0xbf, 0x00, 0x00, 0x00, 0xff, 0xff, 0x60, 0x19,
		0x3a, 0xd0, 0x93, 0x94, 0x00, 0x00,
	}
	r := bytes.NewReader(gzipped)
	gzipr, err := compress_gzip.NewReader(r)
	if err != nil {
		panic(err)
	}
	ungzipped, err := io_ioutil.ReadAll(gzipr)
	if err != nil {
		panic(err)
	}
	if err := github_com_cosmos_gogoproto_proto.Unmarshal(ungzipped, d); err != nil {
		panic(err)
	}
	return d
}
func (this *CommissionRates) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*CommissionRates)
	if !ok {
		that2, ok := that.(CommissionRates)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if !this.Rate.Equal(that1.Rate) {
		return false
	}
	if !this.MaxRate.Equal(that1.MaxRate) {
		return false
	}
	if !this.MaxChangeRate.Equal(that1.MaxChangeRate) {
		return false
	}
	return true
}
func (this *Commission) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*Commission)
	if !ok {
		that2, ok := that.(Commission)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if !this.CommissionRates.Equal(&that1.CommissionRates) {
		return false
	}
	if !this.UpdateTime.Equal(that1.UpdateTime) {
		return false
	}
	return true
}
func (this *Description) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*Description)
	if !ok {
		that2, ok := that.(Description)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if this.Moniker != that1.Moniker {
		return false
	}
	if this.Identity != that1.Identity {
		return false
	}
	if this.Website != that1.Website {
		return false
	}
	if this.SecurityContact != that1.SecurityContact {
		return false
	}
	if this.Details != that1.Details {
		return false
	}
	return true
}
func (this *UnbondingDelegationEntry) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*UnbondingDelegationEntry)
	if !ok {
		that2, ok := that.(UnbondingDelegationEntry)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if this.CreationHeight != that1.CreationHeight {
		return false
	}
	if !this.CompletionTime.Equal(that1.CompletionTime) {
		return false
	}
	if !this.InitialBalance.Equal(that1.InitialBalance) {
		return false
	}
	if !this.Balance.Equal(that1.Balance) {
		return false
	}
	if this.UnbondingId != that1.UnbondingId {
		return false
	}
	if this.UnbondingOnHoldRefCount != that1.UnbondingOnHoldRefCount {
		return false
	}
	return true
}
func (this *RedelegationEntry) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*RedelegationEntry)
	if !ok {
		that2, ok := that.(RedelegationEntry)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if this.CreationHeight != that1.CreationHeight {
		return false
	}
	if !this.CompletionTime.Equal(that1.CompletionTime) {
		return false
	}
	if !this.InitialBalance.Equal(that1.InitialBalance) {
		return false
	}
	if !this.SharesDst.Equal(that1.SharesDst) {
		return false
	}
	if this.UnbondingId != that1.UnbondingId {
		return false
	}
	if this.UnbondingOnHoldRefCount != that1.UnbondingOnHoldRefCount {
		return false
	}
	return true
}
func (this *Params) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*Params)
	if !ok {
		that2, ok := that.(Params)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if this.UnbondingTime != that1.UnbondingTime {
		return false
	}
	if this.MaxValidators != that1.MaxValidators {
		return false
	}
	if this.MaxEntries != that1.MaxEntries {
		return false
	}
	if this.HistoricalEntries != that1.HistoricalEntries {
		return false
	}
	if this.BondDenom != that1.BondDenom {
		return false
	}
	if !this.MinCommissionRate.Equal(that1.MinCommissionRate) {
		return false
	}
	return true
}
func (this *RedelegationEntryResponse) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*RedelegationEntryResponse)
	if !ok {
		that2, ok := that.(RedelegationEntryResponse)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if !this.RedelegationEntry.Equal(&that1.RedelegationEntry) {
		return false
	}
	if !this.Balance.Equal(that1.Balance) {
		return false
	}
	return true
}
func (this *Pool) Equal(that interface{}) bool {
	if that == nil {
		return this == nil
	}

	that1, ok := that.(*Pool)
	if !ok {
		that2, ok := that.(Pool)
		if ok {
			that1 = &that2
		} else {
			return false
		}
	}
	if that1 == nil {
		return this == nil
	} else if this == nil {
		return false
	}
	if !this.NotBondedTokens.Equal(that1.NotBondedTokens) {
		return false
	}
	if !this.BondedTokens.Equal(that1.BondedTokens) {
		return false
	}
	return true
}
func (m *HistoricalInfo) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *HistoricalInfo) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *HistoricalInfo) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if len(m.Valset) > 0 {
		for iNdEx := len(m.Valset) - 1; iNdEx >= 0; iNdEx-- {
			{
				size, err := m.Valset[iNdEx].MarshalToSizedBuffer(dAtA[:i])
				if err != nil {
					return 0, err
				}
				i -= size
				i = encodeVarintStaking(dAtA, i, uint64(size))
			}
			i--
			dAtA[i] = 0x12
		}
	}
	{
		size, err := m.Header.MarshalToSizedBuffer(dAtA[:i])
		if err != nil {
			return 0, err
		}
		i -= size
		i = encodeVarintStaking(dAtA, i, uint64(size))
	}
	i--
	dAtA[i] = 0xa
	return len(dAtA) - i, nil
}

func (m *CommissionRates) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *CommissionRates) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *CommissionRates) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	{
		size := m.MaxChangeRate.Size()
		i -= size
		if _, err := m.MaxChangeRate.MarshalTo(dAtA[i:]); err != nil {
			return 0, err
		}
		i = encodeVarintStaking(dAtA, i, uint64(size))
	}
	i--
	dAtA[i] = 0x1a
	{
		size := m.MaxRate.Size()
		i -= size
		if _, err := m.MaxRate.MarshalTo(dAtA[i:]); err != nil {
			return 0, err
		}
		i = encodeVarintStaking(dAtA, i, uint64(size))
	}
	i--
	dAtA[i] = 0x12
	{
		size := m.Rate.Size()
		i -= size
		if _, err := m.Rate.MarshalTo(dAtA[i:]); err != nil {
			return 0, err
		}
		i = encodeVarintStaking(dAtA, i, uint64(size))
	}
	i--
	dAtA[i] = 0xa
	return len(dAtA) - i, nil
}

func (m *Commission) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *Commission) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *Commission) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	n2, err2 := github_com_cosmos_gogoproto_types.StdTimeMarshalTo(m.UpdateTime, dAtA[i-github_com_cosmos_gogoproto_types.SizeOfStdTime(m.UpdateTime):])
	if err2 != nil {
		return 0, err2
	}
	i -= n2
	i = encodeVarintStaking(dAtA, i, uint64(n2))
	i--
	dAtA[i] = 0x12
	{
		size, err := m.CommissionRates.MarshalToSizedBuffer(dAtA[:i])
		if err != nil {
			return 0, err
		}
		i -= size
		i = encodeVarintStaking(dAtA, i, uint64(size))
	}
	i--
	dAtA[i] = 0xa
	return len(dAtA) - i, nil
}

func (m *Description) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *Description) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *Description) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if len(m.Details) > 0 {
		i -= len(m.Details)
		copy(dAtA[i:], m.Details)
		i = encodeVarintStaking(dAtA, i, uint64(len(m.Details)))
		i--
		dAtA[i] = 0x2a
	}
	if len(m.SecurityContact) > 0 {
		i -= len(m.SecurityContact)
		copy(dAtA[i:], m.SecurityContact)
		i = encodeVarintStaking(dAtA, i, uint64(len(m.SecurityContact)))
		i--
		dAtA[i] = 0x22
	}
	if len(m.Website) > 0 {
		i -= len(m.Website)
		copy(dAtA[i:], m.Website)
		i = encodeVarintStaking(dAtA, i, uint64(len(m.Website)))
		i--
		dAtA[i] = 0x1a
	}
	if len(m.Identity) > 0 {
		i -= len(m.Identity)
		copy(dAtA[i:], m.Identity)
		i = encodeVarintStaking(dAtA, i, uint64(len(m.Identity)))
		i--
		dAtA[i] = 0x12
	}
	if len(m.Moniker) > 0 {
		i -= len(m.Moniker)
		copy(dAtA[i:], m.Moniker)
		i = encodeVarintStaking(dAtA, i, uint64(len(m.Moniker)))
		i--
		dAtA[i] = 0xa
	}
	return len(dAtA) - i, nil
}

func (m *Validator) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *Validator) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *Validator) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if len(m.UnbondingIds) > 0 {
		dAtA5 := make([]byte, len(m.UnbondingIds)*10)
		var j4 int
		for _, num := range m.UnbondingIds {
			for num >= 1<<7 {
				dAtA5[j4] = uint8(uint64(num)&0x7f | 0x80)
				num >>= 7
				j4++
			}
			dAtA5[j4] = uint8(num)
			j4++
		}
		i -= j4
		copy(dAtA[i:], dAtA5[:j4])
		i = encodeVarintStaking(dAtA, i, uint64(j4))
		i--
		dAtA[i] = 0x6a
	}
	if m.UnbondingOnHoldRefCount != 0 {
		i = encodeVarintStaking(dAtA, i, uint64(m.UnbondingOnHoldRefCount))
		i--
		dAtA[i] = 0x60
	}
	{
		size := m.MinSelfDelegation.Size()
		i -= size
		if _, err := m.MinSelfDelegation.MarshalTo(dAtA[i:]); err != nil {
			return 0, err
		}
		i = encodeVarintStaking(dAtA, i, uint64(size))
	}
	i--
	dAtA[i] = 0x5a
	{
		size, err := m.Commission.MarshalToSizedBuffer(dAtA[:i])
		if err != nil {
			return 0, err
		}
		i -= size
		i = encodeVarintStaking(dAtA, i, uint64(size))
	}
	i--
	dAtA[i] = 0x52
	n7, err7 := github_com_cosmos_gogoproto_types.StdTimeMarshalTo(m.UnbondingTime, dAtA[i-github_com_cosmos_gogoproto_types.SizeOfStdTime(m.UnbondingTime):])
	if err7 != nil {
		return 0, err7
	}
	i -= n7
	i = encodeVarintStaking(dAtA, i, uint64(n7))
	i--
	dAtA[i] = 0x4a
	if m.UnbondingHeight != 0 {
		i = encodeVarintStaking(dAtA, i, uint64(m.UnbondingHeight))
		i--
		dAtA[i] = 0x40
	}
	{
		size, err := m.Description.MarshalToSizedBuffer(dAtA[:i])
		if err != nil {
			return 0, err
		}
		i -= size
		i = encodeVarintStaking(dAtA, i, uint64(size))
	}
	i--
	dAtA[i] = 0x3a
	{
		size := m.DelegatorShares.Size()
		i -= size
		if _, err := m.DelegatorShares.MarshalTo(dAtA[i:]); err != nil {
			return 0, err
		}
		i = encodeVarintStaking(dAtA, i, uint64(size))
	}
	i--
	dAtA[i] = 0x32
	{
		size := m.Tokens.Size()
		i -= size
		if _, err := m.Tokens.MarshalTo(dAtA[i:]); err != nil {
			return 0, err
		}
		i = encodeVarintStaking(dAtA, i, uint64(size))
	}
	i--
	dAtA[i] = 0x2a
	if m.Status != 0 {
		i = encodeVarintStaking(dAtA, i, uint64(m.Status))
		i--
		dAtA[i] = 0x20
	}
	if m.Jailed {
		i--
		if m.Jailed {
			dAtA[i] = 1
		} else {
			dAtA[i] = 0
		}
		i--
		dAtA[i] = 0x18
	}
	if m.ConsensusPubkey != nil {
		{
			size, err := m.ConsensusPubkey.MarshalToSizedBuffer(dAtA[:i])
			if err != nil {
				return 0, err
			}
			i -= size
			i = encodeVarintStaking(dAtA, i, uint64(size))
		}
		i--
		dAtA[i] = 0x12
	}
	if len(m.OperatorAddress) > 0 {
		i -= len(m.OperatorAddress)
		copy(dAtA[i:], m.OperatorAddress)
		i = encodeVarintStaking(dAtA, i, uint64(len(m.OperatorAddress)))
		i--
		dAtA[i] = 0xa
	}
	return len(dAtA) - i, nil
}

func (m *ValAddresses) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *ValAddresses) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *ValAddresses) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if len(m.Addresses) > 0 {
		for iNdEx := len(m.Addresses) - 1; iNdEx >= 0; iNdEx-- {
			i -= len(m.Addresses[iNdEx])
			copy(dAtA[i:], m.Addresses[iNdEx])
			i = encodeVarintStaking(dAtA, i, uint64(len(m.Addresses[iNdEx])))
			i--
			dAtA[i] = 0xa
		}
	}
	return len(dAtA) - i, nil
}

func (m *DVPair) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *DVPair) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *DVPair) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if len(m.ValidatorAddress) > 0 {
		i -= len(m.ValidatorAddress)
		copy(dAtA[i:], m.ValidatorAddress)
		i = encodeVarintStaking(dAtA, i, uint64(len(m.ValidatorAddress)))
		i--
		dAtA[i] = 0x12
	}
	if len(m.DelegatorAddress) > 0 {
		i -= len(m.DelegatorAddress)
		copy(dAtA[i:], m.DelegatorAddress)
		i = encodeVarintStaking(dAtA, i, uint64(len(m.DelegatorAddress)))
		i--
		dAtA[i] = 0xa
	}
	return len(dAtA) - i, nil
}

func (m *DVPairs) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *DVPairs) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *DVPairs) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if len(m.Pairs) > 0 {
		for iNdEx := len(m.Pairs) - 1; iNdEx >= 0; iNdEx-- {
			{
				size, err := m.Pairs[iNdEx].MarshalToSizedBuffer(dAtA[:i])
				if err != nil {
					return 0, err
				}
				i -= size
				i = encodeVarintStaking(dAtA, i, uint64(size))
			}
			i--
			dAtA[i] = 0xa
		}
	}
	return len(dAtA) - i, nil
}

func (m *DVVTriplet) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *DVVTriplet) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *DVVTriplet) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if len(m.ValidatorDstAddress) > 0 {
		i -= len(m.ValidatorDstAddress)
		copy(dAtA[i:], m.ValidatorDstAddress)
		i = encodeVarintStaking(dAtA, i, uint64(len(m.ValidatorDstAddress)))
		i--
		dAtA[i] = 0x1a
	}
	if len(m.ValidatorSrcAddress) > 0 {
		i -= len(m.ValidatorSrcAddress)
		copy(dAtA[i:], m.ValidatorSrcAddress)
		i = encodeVarintStaking(dAtA, i, uint64(len(m.ValidatorSrcAddress)))
		i--
		dAtA[i] = 0x12
	}
	if len(m.DelegatorAddress) > 0 {
		i -= len(m.DelegatorAddress)
		copy(dAtA[i:], m.DelegatorAddress)
		i = encodeVarintStaking(dAtA, i, uint64(len(m.DelegatorAddress)))
		i--
		dAtA[i] = 0xa
	}
	return len(dAtA) - i, nil
}

func (m *DVVTriplets) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *DVVTriplets) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *DVVTriplets) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if len(m.Triplets) > 0 {
		for iNdEx := len(m.Triplets) - 1; iNdEx >= 0; iNdEx-- {
			{
				size, err := m.Triplets[iNdEx].MarshalToSizedBuffer(dAtA[:i])
				if err != nil {
					return 0, err
				}
				i -= size
				i = encodeVarintStaking(dAtA, i, uint64(size))
			}
			i--
			dAtA[i] = 0xa
		}
	}
	return len(dAtA) - i, nil
}

func (m *Delegation) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *Delegation) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *Delegation) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	{
		size := m.Shares.Size()
		i -= size
		if _, err := m.Shares.MarshalTo(dAtA[i:]); err != nil {
			return 0, err
		}
		i = encodeVarintStaking(dAtA, i, uint64(size))
	}
	i--
	dAtA[i] = 0x1a
	if len(m.ValidatorAddress) > 0 {
		i -= len(m.ValidatorAddress)
		copy(dAtA[i:], m.ValidatorAddress)
		i = encodeVarintStaking(dAtA, i, uint64(len(m.ValidatorAddress)))
		i--
		dAtA[i] = 0x12
	}
	if len(m.DelegatorAddress) > 0 {
		i -= len(m.DelegatorAddress)
		copy(dAtA[i:], m.DelegatorAddress)
		i = encodeVarintStaking(dAtA, i, uint64(len(m.DelegatorAddress)))
		i--
		dAtA[i] = 0xa
	}
	return len(dAtA) - i, nil
}

func (m *UnbondingDelegation) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *UnbondingDelegation) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *UnbondingDelegation) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if len(m.Entries) > 0 {
		for iNdEx := len(m.Entries) - 1; iNdEx >= 0; iNdEx-- {
			{
				size, err := m.Entries[iNdEx].MarshalToSizedBuffer(dAtA[:i])
				if err != nil {
					return 0, err
				}
				i -= size
				i = encodeVarintStaking(dAtA, i, uint64(size))
			}
			i--
			dAtA[i] = 0x1a
		}
	}
	if len(m.ValidatorAddress) > 0 {
		i -= len(m.ValidatorAddress)
		copy(dAtA[i:], m.ValidatorAddress)
		i = encodeVarintStaking(dAtA, i, uint64(len(m.ValidatorAddress)))
		i--
		dAtA[i] = 0x12
	}
	if len(m.DelegatorAddress) > 0 {
		i -= len(m.DelegatorAddress)
		copy(dAtA[i:], m.DelegatorAddress)
		i = encodeVarintStaking(dAtA, i, uint64(len(m.DelegatorAddress)))
		i--
		dAtA[i] = 0xa
	}
	return len(dAtA) - i, nil
}

func (m *UnbondingDelegationEntry) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *UnbondingDelegationEntry) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *UnbondingDelegationEntry) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if m.UnbondingOnHoldRefCount != 0 {
		i = encodeVarintStaking(dAtA, i, uint64(m.UnbondingOnHoldRefCount))
		i--
		dAtA[i] = 0x30
	}
	if m.UnbondingId != 0 {
		i = encodeVarintStaking(dAtA, i, uint64(m.UnbondingId))
		i--
		dAtA[i] = 0x28
	}
	{
		size := m.Balance.Size()
		i -= size
		if _, err := m.Balance.MarshalTo(dAtA[i:]); err != nil {
			return 0, err
		}
		i = encodeVarintStaking(dAtA, i, uint64(size))
	}
	i--
	dAtA[i] = 0x22
	{
		size := m.InitialBalance.Size()
		i -= size
		if _, err := m.InitialBalance.MarshalTo(dAtA[i:]); err != nil {
			return 0, err
		}
		i = encodeVarintStaking(dAtA, i, uint64(size))
	}
	i--
	dAtA[i] = 0x1a
	n10, err10 := github_com_cosmos_gogoproto_types.StdTimeMarshalTo(m.CompletionTime, dAtA[i-github_com_cosmos_gogoproto_types.SizeOfStdTime(m.CompletionTime):])
	if err10 != nil {
		return 0, err10
	}
	i -= n10
	i = encodeVarintStaking(dAtA, i, uint64(n10))
	i--
	dAtA[i] = 0x12
	if m.CreationHeight != 0 {
		i = encodeVarintStaking(dAtA, i, uint64(m.CreationHeight))
		i--
		dAtA[i] = 0x8
	}
	return len(dAtA) - i, nil
}

func (m *RedelegationEntry) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *RedelegationEntry) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *RedelegationEntry) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if m.UnbondingOnHoldRefCount != 0 {
		i = encodeVarintStaking(dAtA, i, uint64(m.UnbondingOnHoldRefCount))
		i--
		dAtA[i] = 0x30
	}
	if m.UnbondingId != 0 {
		i = encodeVarintStaking(dAtA, i, uint64(m.UnbondingId))
		i--
		dAtA[i] = 0x28
	}
	{
		size := m.SharesDst.Size()
		i -= size
		if _, err := m.SharesDst.MarshalTo(dAtA[i:]); err != nil {
			return 0, err
		}
		i = encodeVarintStaking(dAtA, i, uint64(size))
	}
	i--
	dAtA[i] = 0x22
	{
		size := m.InitialBalance.Size()
		i -= size
		if _, err := m.InitialBalance.MarshalTo(dAtA[i:]); err != nil {
			return 0, err
		}
		i = encodeVarintStaking(dAtA, i, uint64(size))
	}
	i--
	dAtA[i] = 0x1a
	n11, err11 := github_com_cosmos_gogoproto_types.StdTimeMarshalTo(m.CompletionTime, dAtA[i-github_com_cosmos_gogoproto_types.SizeOfStdTime(m.CompletionTime):])
	if err11 != nil {
		return 0, err11
	}
	i -= n11
	i = encodeVarintStaking(dAtA, i, uint64(n11))
	i--
	dAtA[i] = 0x12
	if m.CreationHeight != 0 {
		i = encodeVarintStaking(dAtA, i, uint64(m.CreationHeight))
		i--
		dAtA[i] = 0x8
	}
	return len(dAtA) - i, nil
}

func (m *Redelegation) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *Redelegation) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *Redelegation) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if len(m.Entries) > 0 {
		for iNdEx := len(m.Entries) - 1; iNdEx >= 0; iNdEx-- {
			{
				size, err := m.Entries[iNdEx].MarshalToSizedBuffer(dAtA[:i])
				if err != nil {
					return 0, err
				}
				i -= size
				i = encodeVarintStaking(dAtA, i, uint64(size))
			}
			i--
			dAtA[i] = 0x22
		}
	}
	if len(m.ValidatorDstAddress) > 0 {
		i -= len(m.ValidatorDstAddress)
		copy(dAtA[i:], m.ValidatorDstAddress)
		i = encodeVarintStaking(dAtA, i, uint64(len(m.ValidatorDstAddress)))
		i--
		dAtA[i] = 0x1a
	}
	if len(m.ValidatorSrcAddress) > 0 {
		i -= len(m.ValidatorSrcAddress)
		copy(dAtA[i:], m.ValidatorSrcAddress)
		i = encodeVarintStaking(dAtA, i, uint64(len(m.ValidatorSrcAddress)))
		i--
		dAtA[i] = 0x12
	}
	if len(m.DelegatorAddress) > 0 {
		i -= len(m.DelegatorAddress)
		copy(dAtA[i:], m.DelegatorAddress)
		i = encodeVarintStaking(dAtA, i, uint64(len(m.DelegatorAddress)))
		i--
		dAtA[i] = 0xa
	}
	return len(dAtA) - i, nil
}

func (m *Params) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *Params) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *Params) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	{
		size := m.MinCommissionRate.Size()
		i -= size
		if _, err := m.MinCommissionRate.MarshalTo(dAtA[i:]); err != nil {
			return 0, err
		}
		i = encodeVarintStaking(dAtA, i, uint64(size))
	}
	i--
	dAtA[i] = 0x32
	if len(m.BondDenom) > 0 {
		i -= len(m.BondDenom)
		copy(dAtA[i:], m.BondDenom)
		i = encodeVarintStaking(dAtA, i, uint64(len(m.BondDenom)))
		i--
		dAtA[i] = 0x2a
	}
	if m.HistoricalEntries != 0 {
		i = encodeVarintStaking(dAtA, i, uint64(m.HistoricalEntries))
		i--
		dAtA[i] = 0x20
	}
	if m.MaxEntries != 0 {
		i = encodeVarintStaking(dAtA, i, uint64(m.MaxEntries))
		i--
		dAtA[i] = 0x18
	}
	if m.MaxValidators != 0 {
		i = encodeVarintStaking(dAtA, i, uint64(m.MaxValidators))
		i--
		dAtA[i] = 0x10
	}
	n12, err12 := github_com_cosmos_gogoproto_types.StdDurationMarshalTo(m.UnbondingTime, dAtA[i-github_com_cosmos_gogoproto_types.SizeOfStdDuration(m.UnbondingTime):])
	if err12 != nil {
		return 0, err12
	}
	i -= n12
	i = encodeVarintStaking(dAtA, i, uint64(n12))
	i--
	dAtA[i] = 0xa
	return len(dAtA) - i, nil
}

func (m *DelegationResponse) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *DelegationResponse) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *DelegationResponse) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	{
		size, err := m.Balance.MarshalToSizedBuffer(dAtA[:i])
		if err != nil {
			return 0, err
		}
		i -= size
		i = encodeVarintStaking(dAtA, i, uint64(size))
	}
	i--
	dAtA[i] = 0x12
	{
		size, err := m.Delegation.MarshalToSizedBuffer(dAtA[:i])
		if err != nil {
			return 0, err
		}
		i -= size
		i = encodeVarintStaking(dAtA, i, uint64(size))
	}
	i--
	dAtA[i] = 0xa
	return len(dAtA) - i, nil
}

func (m *RedelegationEntryResponse) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *RedelegationEntryResponse) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *RedelegationEntryResponse) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	{
		size := m.Balance.Size()
		i -= size
		if _, err := m.Balance.MarshalTo(dAtA[i:]); err != nil {
			return 0, err
		}
		i = encodeVarintStaking(dAtA, i, uint64(size))
	}
	i--
	dAtA[i] = 0x22
	{
		size, err := m.RedelegationEntry.MarshalToSizedBuffer(dAtA[:i])
		if err != nil {
			return 0, err
		}
		i -= size
		i = encodeVarintStaking(dAtA, i, uint64(size))
	}
	i--
	dAtA[i] = 0xa
	return len(dAtA) - i, nil
}

func (m *RedelegationResponse) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *RedelegationResponse) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *RedelegationResponse) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if len(m.Entries) > 0 {
		for iNdEx := len(m.Entries) - 1; iNdEx >= 0; iNdEx-- {
			{
				size, err := m.Entries[iNdEx].MarshalToSizedBuffer(dAtA[:i])
				if err != nil {
					return 0, err
				}
				i -= size
				i = encodeVarintStaking(dAtA, i, uint64(size))
			}
			i--
			dAtA[i] = 0x12
		}
	}
	{
		size, err := m.Redelegation.MarshalToSizedBuffer(dAtA[:i])
		if err != nil {
			return 0, err
		}
		i -= size
		i = encodeVarintStaking(dAtA, i, uint64(size))
	}
	i--
	dAtA[i] = 0xa
	return len(dAtA) - i, nil
}

func (m *Pool) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *Pool) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *Pool) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	{
		size := m.BondedTokens.Size()
		i -= size
		if _, err := m.BondedTokens.MarshalTo(dAtA[i:]); err != nil {
			return 0, err
		}
		i = encodeVarintStaking(dAtA, i, uint64(size))
	}
	i--
	dAtA[i] = 0x12
	{
		size := m.NotBondedTokens.Size()
		i -= size
		if _, err := m.NotBondedTokens.MarshalTo(dAtA[i:]); err != nil {
			return 0, err
		}
		i = encodeVarintStaking(dAtA, i, uint64(size))
	}
	i--
	dAtA[i] = 0xa
	return len(dAtA) - i, nil
}

func (m *ValidatorUpdates) Marshal() (dAtA []byte, err error) {
	size := m.Size()
	dAtA = make([]byte, size)
	n, err := m.MarshalToSizedBuffer(dAtA[:size])
	if err != nil {
		return nil, err
	}
	return dAtA[:n], nil
}

func (m *ValidatorUpdates) MarshalTo(dAtA []byte) (int, error) {
	size := m.Size()
	return m.MarshalToSizedBuffer(dAtA[:size])
}

func (m *ValidatorUpdates) MarshalToSizedBuffer(dAtA []byte) (int, error) {
	i := len(dAtA)
	_ = i
	var l int
	_ = l
	if len(m.Updates) > 0 {
		for iNdEx := len(m.Updates) - 1; iNdEx >= 0; iNdEx-- {
			{
				size, err := m.Updates[iNdEx].MarshalToSizedBuffer(dAtA[:i])
				if err != nil {
					return 0, err
				}
				i -= size
				i = encodeVarintStaking(dAtA, i, uint64(size))
			}
			i--
			dAtA[i] = 0xa
		}
	}
	return len(dAtA) - i, nil
}

func encodeVarintStaking(dAtA []byte, offset int, v uint64) int {
	offset -= sovStaking(v)
	base := offset
	for v >= 1<<7 {
		dAtA[offset] = uint8(v&0x7f | 0x80)
		v >>= 7
		offset++
	}
	dAtA[offset] = uint8(v)
	return base
}
func (m *HistoricalInfo) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	l = m.Header.Size()
	n += 1 + l + sovStaking(uint64(l))
	if len(m.Valset) > 0 {
		for _, e := range m.Valset {
			l = e.Size()
			n += 1 + l + sovStaking(uint64(l))
		}
	}
	return n
}

func (m *CommissionRates) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	l = m.Rate.Size()
	n += 1 + l + sovStaking(uint64(l))
	l = m.MaxRate.Size()
	n += 1 + l + sovStaking(uint64(l))
	l = m.MaxChangeRate.Size()
	n += 1 + l + sovStaking(uint64(l))
	return n
}

func (m *Commission) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	l = m.CommissionRates.Size()
	n += 1 + l + sovStaking(uint64(l))
	l = github_com_cosmos_gogoproto_types.SizeOfStdTime(m.UpdateTime)
	n += 1 + l + sovStaking(uint64(l))
	return n
}

func (m *Description) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	l = len(m.Moniker)
	if l > 0 {
		n += 1 + l + sovStaking(uint64(l))
	}
	l = len(m.Identity)
	if l > 0 {
		n += 1 + l + sovStaking(uint64(l))
	}
	l = len(m.Website)
	if l > 0 {
		n += 1 + l + sovStaking(uint64(l))
	}
	l = len(m.SecurityContact)
	if l > 0 {
		n += 1 + l + sovStaking(uint64(l))
	}
	l = len(m.Details)
	if l > 0 {
		n += 1 + l + sovStaking(uint64(l))
	}
	return n
}

func (m *Validator) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	l = len(m.OperatorAddress)
	if l > 0 {
		n += 1 + l + sovStaking(uint64(l))
	}
	if m.ConsensusPubkey != nil {
		l = m.ConsensusPubkey.Size()
		n += 1 + l + sovStaking(uint64(l))
	}
	if m.Jailed {
		n += 2
	}
	if m.Status != 0 {
		n += 1 + sovStaking(uint64(m.Status))
	}
	l = m.Tokens.Size()
	n += 1 + l + sovStaking(uint64(l))
	l = m.DelegatorShares.Size()
	n += 1 + l + sovStaking(uint64(l))
	l = m.Description.Size()
	n += 1 + l + sovStaking(uint64(l))
	if m.UnbondingHeight != 0 {
		n += 1 + sovStaking(uint64(m.UnbondingHeight))
	}
	l = github_com_cosmos_gogoproto_types.SizeOfStdTime(m.UnbondingTime)
	n += 1 + l + sovStaking(uint64(l))
	l = m.Commission.Size()
	n += 1 + l + sovStaking(uint64(l))
	l = m.MinSelfDelegation.Size()
	n += 1 + l + sovStaking(uint64(l))
	if m.UnbondingOnHoldRefCount != 0 {
		n += 1 + sovStaking(uint64(m.UnbondingOnHoldRefCount))
	}
	if len(m.UnbondingIds) > 0 {
		l = 0
		for _, e := range m.UnbondingIds {
			l += sovStaking(uint64(e))
		}
		n += 1 + sovStaking(uint64(l)) + l
	}
	return n
}

func (m *ValAddresses) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	if len(m.Addresses) > 0 {
		for _, s := range m.Addresses {
			l = len(s)
			n += 1 + l + sovStaking(uint64(l))
		}
	}
	return n
}

func (m *DVPair) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	l = len(m.DelegatorAddress)
	if l > 0 {
		n += 1 + l + sovStaking(uint64(l))
	}
	l = len(m.ValidatorAddress)
	if l > 0 {
		n += 1 + l + sovStaking(uint64(l))
	}
	return n
}

func (m *DVPairs) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	if len(m.Pairs) > 0 {
		for _, e := range m.Pairs {
			l = e.Size()
			n += 1 + l + sovStaking(uint64(l))
		}
	}
	return n
}

func (m *DVVTriplet) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	l = len(m.DelegatorAddress)
	if l > 0 {
		n += 1 + l + sovStaking(uint64(l))
	}
	l = len(m.ValidatorSrcAddress)
	if l > 0 {
		n += 1 + l + sovStaking(uint64(l))
	}
	l = len(m.ValidatorDstAddress)
	if l > 0 {
		n += 1 + l + sovStaking(uint64(l))
	}
	return n
}

func (m *DVVTriplets) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	if len(m.Triplets) > 0 {
		for _, e := range m.Triplets {
			l = e.Size()
			n += 1 + l + sovStaking(uint64(l))
		}
	}
	return n
}

func (m *Delegation) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	l = len(m.DelegatorAddress)
	if l > 0 {
		n += 1 + l + sovStaking(uint64(l))
	}
	l = len(m.ValidatorAddress)
	if l > 0 {
		n += 1 + l + sovStaking(uint64(l))
	}
	l = m.Shares.Size()
	n += 1 + l + sovStaking(uint64(l))
	return n
}

func (m *UnbondingDelegation) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	l = len(m.DelegatorAddress)
	if l > 0 {
		n += 1 + l + sovStaking(uint64(l))
	}
	l = len(m.ValidatorAddress)
	if l > 0 {
		n += 1 + l + sovStaking(uint64(l))
	}
	if len(m.Entries) > 0 {
		for _, e := range m.Entries {
			l = e.Size()
			n += 1 + l + sovStaking(uint64(l))
		}
	}
	return n
}

func (m *UnbondingDelegationEntry) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	if m.CreationHeight != 0 {
		n += 1 + sovStaking(uint64(m.CreationHeight))
	}
	l = github_com_cosmos_gogoproto_types.SizeOfStdTime(m.CompletionTime)
	n += 1 + l + sovStaking(uint64(l))
	l = m.InitialBalance.Size()
	n += 1 + l + sovStaking(uint64(l))
	l = m.Balance.Size()
	n += 1 + l + sovStaking(uint64(l))
	if m.UnbondingId != 0 {
		n += 1 + sovStaking(uint64(m.UnbondingId))
	}
	if m.UnbondingOnHoldRefCount != 0 {
		n += 1 + sovStaking(uint64(m.UnbondingOnHoldRefCount))
	}
	return n
}

func (m *RedelegationEntry) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	if m.CreationHeight != 0 {
		n += 1 + sovStaking(uint64(m.CreationHeight))
	}
	l = github_com_cosmos_gogoproto_types.SizeOfStdTime(m.CompletionTime)
	n += 1 + l + sovStaking(uint64(l))
	l = m.InitialBalance.Size()
	n += 1 + l + sovStaking(uint64(l))
	l = m.SharesDst.Size()
	n += 1 + l + sovStaking(uint64(l))
	if m.UnbondingId != 0 {
		n += 1 + sovStaking(uint64(m.UnbondingId))
	}
	if m.UnbondingOnHoldRefCount != 0 {
		n += 1 + sovStaking(uint64(m.UnbondingOnHoldRefCount))
	}
	return n
}

func (m *Redelegation) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	l = len(m.DelegatorAddress)
	if l > 0 {
		n += 1 + l + sovStaking(uint64(l))
	}
	l = len(m.ValidatorSrcAddress)
	if l > 0 {
		n += 1 + l + sovStaking(uint64(l))
	}
	l = len(m.ValidatorDstAddress)
	if l > 0 {
		n += 1 + l + sovStaking(uint64(l))
	}
	if len(m.Entries) > 0 {
		for _, e := range m.Entries {
			l = e.Size()
			n += 1 + l + sovStaking(uint64(l))
		}
	}
	return n
}

func (m *Params) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	l = github_com_cosmos_gogoproto_types.SizeOfStdDuration(m.UnbondingTime)
	n += 1 + l + sovStaking(uint64(l))
	if m.MaxValidators != 0 {
		n += 1 + sovStaking(uint64(m.MaxValidators))
	}
	if m.MaxEntries != 0 {
		n += 1 + sovStaking(uint64(m.MaxEntries))
	}
	if m.HistoricalEntries != 0 {
		n += 1 + sovStaking(uint64(m.HistoricalEntries))
	}
	l = len(m.BondDenom)
	if l > 0 {
		n += 1 + l + sovStaking(uint64(l))
	}
	l = m.MinCommissionRate.Size()
	n += 1 + l + sovStaking(uint64(l))
	return n
}

func (m *DelegationResponse) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	l = m.Delegation.Size()
	n += 1 + l + sovStaking(uint64(l))
	l = m.Balance.Size()
	n += 1 + l + sovStaking(uint64(l))
	return n
}

func (m *RedelegationEntryResponse) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	l = m.RedelegationEntry.Size()
	n += 1 + l + sovStaking(uint64(l))
	l = m.Balance.Size()
	n += 1 + l + sovStaking(uint64(l))
	return n
}

func (m *RedelegationResponse) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	l = m.Redelegation.Size()
	n += 1 + l + sovStaking(uint64(l))
	if len(m.Entries) > 0 {
		for _, e := range m.Entries {
			l = e.Size()
			n += 1 + l + sovStaking(uint64(l))
		}
	}
	return n
}

func (m *Pool) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	l = m.NotBondedTokens.Size()
	n += 1 + l + sovStaking(uint64(l))
	l = m.BondedTokens.Size()
	n += 1 + l + sovStaking(uint64(l))
	return n
}

func (m *ValidatorUpdates) Size() (n int) {
	if m == nil {
		return 0
	}
	var l int
	_ = l
	if len(m.Updates) > 0 {
		for _, e := range m.Updates {
			l = e.Size()
			n += 1 + l + sovStaking(uint64(l))
		}
	}
	return n
}

func sovStaking(x uint64) (n int) {
	return (math_bits.Len64(x|1) + 6) / 7
}
func sozStaking(x uint64) (n int) {
	return sovStaking(uint64((x << 1) ^ uint64((int64(x) >> 63))))
}
func (this *ValAddresses) String() string {
	if this == nil {
		return "nil"
	}
	s := strings.Join([]string{`&ValAddresses{`,
		`Addresses:` + fmt.Sprintf("%v", this.Addresses) + `,`,
		`}`,
	}, "")
	return s
}
func valueToStringStaking(v interface{}) string {
	rv := reflect.ValueOf(v)
	if rv.IsNil() {
		return "nil"
	}
	pv := reflect.Indirect(rv).Interface()
	return fmt.Sprintf("*%v", pv)
}
func (m *HistoricalInfo) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowStaking
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: HistoricalInfo: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: HistoricalInfo: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Header", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := m.Header.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 2:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Valset", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Valset = append(m.Valset, Validator{})
			if err := m.Valset[len(m.Valset)-1].Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipStaking(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthStaking
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *CommissionRates) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowStaking
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: CommissionRates: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: CommissionRates: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Rate", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := m.Rate.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 2:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field MaxRate", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := m.MaxRate.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 3:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field MaxChangeRate", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := m.MaxChangeRate.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipStaking(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthStaking
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *Commission) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowStaking
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: Commission: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: Commission: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field CommissionRates", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := m.CommissionRates.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 2:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field UpdateTime", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := github_com_cosmos_gogoproto_types.StdTimeUnmarshal(&m.UpdateTime, dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipStaking(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthStaking
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *Description) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowStaking
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: Description: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: Description: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Moniker", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Moniker = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 2:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Identity", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Identity = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 3:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Website", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Website = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 4:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field SecurityContact", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.SecurityContact = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 5:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Details", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Details = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipStaking(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthStaking
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *Validator) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowStaking
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: Validator: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: Validator: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field OperatorAddress", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.OperatorAddress = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 2:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field ConsensusPubkey", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if m.ConsensusPubkey == nil {
				m.ConsensusPubkey = &types1.Any{}
			}
			if err := m.ConsensusPubkey.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 3:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field Jailed", wireType)
			}
			var v int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				v |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			m.Jailed = bool(v != 0)
		case 4:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field Status", wireType)
			}
			m.Status = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.Status |= BondStatus(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 5:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Tokens", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := m.Tokens.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 6:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field DelegatorShares", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := m.DelegatorShares.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 7:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Description", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := m.Description.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 8:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field UnbondingHeight", wireType)
			}
			m.UnbondingHeight = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.UnbondingHeight |= int64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 9:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field UnbondingTime", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := github_com_cosmos_gogoproto_types.StdTimeUnmarshal(&m.UnbondingTime, dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 10:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Commission", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := m.Commission.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 11:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field MinSelfDelegation", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := m.MinSelfDelegation.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 12:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field UnbondingOnHoldRefCount", wireType)
			}
			m.UnbondingOnHoldRefCount = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.UnbondingOnHoldRefCount |= int64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 13:
			if wireType == 0 {
				var v uint64
				for shift := uint(0); ; shift += 7 {
					if shift >= 64 {
						return ErrIntOverflowStaking
					}
					if iNdEx >= l {
						return io.ErrUnexpectedEOF
					}
					b := dAtA[iNdEx]
					iNdEx++
					v |= uint64(b&0x7F) << shift
					if b < 0x80 {
						break
					}
				}
				m.UnbondingIds = append(m.UnbondingIds, v)
			} else if wireType == 2 {
				var packedLen int
				for shift := uint(0); ; shift += 7 {
					if shift >= 64 {
						return ErrIntOverflowStaking
					}
					if iNdEx >= l {
						return io.ErrUnexpectedEOF
					}
					b := dAtA[iNdEx]
					iNdEx++
					packedLen |= int(b&0x7F) << shift
					if b < 0x80 {
						break
					}
				}
				if packedLen < 0 {
					return ErrInvalidLengthStaking
				}
				postIndex := iNdEx + packedLen
				if postIndex < 0 {
					return ErrInvalidLengthStaking
				}
				if postIndex > l {
					return io.ErrUnexpectedEOF
				}
				var elementCount int
				var count int
				for _, integer := range dAtA[iNdEx:postIndex] {
					if integer < 128 {
						count++
					}
				}
				elementCount = count
				if elementCount != 0 && len(m.UnbondingIds) == 0 {
					m.UnbondingIds = make([]uint64, 0, elementCount)
				}
				for iNdEx < postIndex {
					var v uint64
					for shift := uint(0); ; shift += 7 {
						if shift >= 64 {
							return ErrIntOverflowStaking
						}
						if iNdEx >= l {
							return io.ErrUnexpectedEOF
						}
						b := dAtA[iNdEx]
						iNdEx++
						v |= uint64(b&0x7F) << shift
						if b < 0x80 {
							break
						}
					}
					m.UnbondingIds = append(m.UnbondingIds, v)
				}
			} else {
				return fmt.Errorf("proto: wrong wireType = %d for field UnbondingIds", wireType)
			}
		default:
			iNdEx = preIndex
			skippy, err := skipStaking(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthStaking
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *ValAddresses) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowStaking
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: ValAddresses: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: ValAddresses: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Addresses", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Addresses = append(m.Addresses, string(dAtA[iNdEx:postIndex]))
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipStaking(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthStaking
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *DVPair) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowStaking
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: DVPair: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: DVPair: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field DelegatorAddress", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.DelegatorAddress = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 2:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field ValidatorAddress", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.ValidatorAddress = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipStaking(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthStaking
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *DVPairs) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowStaking
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: DVPairs: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: DVPairs: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Pairs", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Pairs = append(m.Pairs, DVPair{})
			if err := m.Pairs[len(m.Pairs)-1].Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipStaking(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthStaking
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *DVVTriplet) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowStaking
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: DVVTriplet: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: DVVTriplet: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field DelegatorAddress", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.DelegatorAddress = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 2:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field ValidatorSrcAddress", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.ValidatorSrcAddress = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 3:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field ValidatorDstAddress", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.ValidatorDstAddress = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipStaking(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthStaking
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *DVVTriplets) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowStaking
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: DVVTriplets: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: DVVTriplets: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Triplets", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Triplets = append(m.Triplets, DVVTriplet{})
			if err := m.Triplets[len(m.Triplets)-1].Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipStaking(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthStaking
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *Delegation) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowStaking
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: Delegation: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: Delegation: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field DelegatorAddress", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.DelegatorAddress = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 2:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field ValidatorAddress", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.ValidatorAddress = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 3:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Shares", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := m.Shares.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipStaking(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthStaking
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *UnbondingDelegation) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowStaking
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: UnbondingDelegation: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: UnbondingDelegation: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field DelegatorAddress", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.DelegatorAddress = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 2:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field ValidatorAddress", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.ValidatorAddress = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 3:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Entries", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Entries = append(m.Entries, UnbondingDelegationEntry{})
			if err := m.Entries[len(m.Entries)-1].Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipStaking(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthStaking
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *UnbondingDelegationEntry) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowStaking
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: UnbondingDelegationEntry: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: UnbondingDelegationEntry: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field CreationHeight", wireType)
			}
			m.CreationHeight = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.CreationHeight |= int64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 2:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field CompletionTime", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := github_com_cosmos_gogoproto_types.StdTimeUnmarshal(&m.CompletionTime, dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 3:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field InitialBalance", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := m.InitialBalance.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 4:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Balance", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := m.Balance.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 5:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field UnbondingId", wireType)
			}
			m.UnbondingId = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.UnbondingId |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 6:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field UnbondingOnHoldRefCount", wireType)
			}
			m.UnbondingOnHoldRefCount = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.UnbondingOnHoldRefCount |= int64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		default:
			iNdEx = preIndex
			skippy, err := skipStaking(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthStaking
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *RedelegationEntry) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowStaking
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: RedelegationEntry: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: RedelegationEntry: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field CreationHeight", wireType)
			}
			m.CreationHeight = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.CreationHeight |= int64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 2:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field CompletionTime", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := github_com_cosmos_gogoproto_types.StdTimeUnmarshal(&m.CompletionTime, dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 3:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field InitialBalance", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := m.InitialBalance.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 4:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field SharesDst", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := m.SharesDst.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 5:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field UnbondingId", wireType)
			}
			m.UnbondingId = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.UnbondingId |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 6:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field UnbondingOnHoldRefCount", wireType)
			}
			m.UnbondingOnHoldRefCount = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.UnbondingOnHoldRefCount |= int64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		default:
			iNdEx = preIndex
			skippy, err := skipStaking(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthStaking
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *Redelegation) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowStaking
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: Redelegation: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: Redelegation: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field DelegatorAddress", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.DelegatorAddress = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 2:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field ValidatorSrcAddress", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.ValidatorSrcAddress = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 3:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field ValidatorDstAddress", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.ValidatorDstAddress = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 4:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Entries", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Entries = append(m.Entries, RedelegationEntry{})
			if err := m.Entries[len(m.Entries)-1].Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipStaking(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthStaking
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *Params) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowStaking
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: Params: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: Params: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field UnbondingTime", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := github_com_cosmos_gogoproto_types.StdDurationUnmarshal(&m.UnbondingTime, dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 2:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field MaxValidators", wireType)
			}
			m.MaxValidators = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.MaxValidators |= uint32(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 3:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field MaxEntries", wireType)
			}
			m.MaxEntries = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.MaxEntries |= uint32(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 4:
			if wireType != 0 {
				return fmt.Errorf("proto: wrong wireType = %d for field HistoricalEntries", wireType)
			}
			m.HistoricalEntries = 0
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				m.HistoricalEntries |= uint32(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
		case 5:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field BondDenom", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.BondDenom = string(dAtA[iNdEx:postIndex])
			iNdEx = postIndex
		case 6:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field MinCommissionRate", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := m.MinCommissionRate.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipStaking(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthStaking
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *DelegationResponse) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowStaking
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: DelegationResponse: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: DelegationResponse: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Delegation", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := m.Delegation.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 2:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Balance", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := m.Balance.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipStaking(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthStaking
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *RedelegationEntryResponse) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowStaking
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: RedelegationEntryResponse: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: RedelegationEntryResponse: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field RedelegationEntry", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := m.RedelegationEntry.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 4:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Balance", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := m.Balance.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipStaking(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthStaking
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *RedelegationResponse) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowStaking
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: RedelegationResponse: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: RedelegationResponse: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Redelegation", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := m.Redelegation.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 2:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Entries", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Entries = append(m.Entries, RedelegationEntryResponse{})
			if err := m.Entries[len(m.Entries)-1].Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipStaking(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthStaking
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *Pool) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowStaking
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: Pool: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: Pool: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field NotBondedTokens", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := m.NotBondedTokens.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		case 2:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field BondedTokens", wireType)
			}
			var stringLen uint64
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				stringLen |= uint64(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			intStringLen := int(stringLen)
			if intStringLen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + intStringLen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			if err := m.BondedTokens.Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipStaking(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthStaking
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func (m *ValidatorUpdates) Unmarshal(dAtA []byte) error {
	l := len(dAtA)
	iNdEx := 0
	for iNdEx < l {
		preIndex := iNdEx
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return ErrIntOverflowStaking
			}
			if iNdEx >= l {
				return io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= uint64(b&0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		fieldNum := int32(wire >> 3)
		wireType := int(wire & 0x7)
		if wireType == 4 {
			return fmt.Errorf("proto: ValidatorUpdates: wiretype end group for non-group")
		}
		if fieldNum <= 0 {
			return fmt.Errorf("proto: ValidatorUpdates: illegal tag %d (wire type %d)", fieldNum, wire)
		}
		switch fieldNum {
		case 1:
			if wireType != 2 {
				return fmt.Errorf("proto: wrong wireType = %d for field Updates", wireType)
			}
			var msglen int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				msglen |= int(b&0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if msglen < 0 {
				return ErrInvalidLengthStaking
			}
			postIndex := iNdEx + msglen
			if postIndex < 0 {
				return ErrInvalidLengthStaking
			}
			if postIndex > l {
				return io.ErrUnexpectedEOF
			}
			m.Updates = append(m.Updates, types3.ValidatorUpdate{})
			if err := m.Updates[len(m.Updates)-1].Unmarshal(dAtA[iNdEx:postIndex]); err != nil {
				return err
			}
			iNdEx = postIndex
		default:
			iNdEx = preIndex
			skippy, err := skipStaking(dAtA[iNdEx:])
			if err != nil {
				return err
			}
			if (skippy < 0) || (iNdEx+skippy) < 0 {
				return ErrInvalidLengthStaking
			}
			if (iNdEx + skippy) > l {
				return io.ErrUnexpectedEOF
			}
			iNdEx += skippy
		}
	}

	if iNdEx > l {
		return io.ErrUnexpectedEOF
	}
	return nil
}
func skipStaking(dAtA []byte) (n int, err error) {
	l := len(dAtA)
	iNdEx := 0
	depth := 0
	for iNdEx < l {
		var wire uint64
		for shift := uint(0); ; shift += 7 {
			if shift >= 64 {
				return 0, ErrIntOverflowStaking
			}
			if iNdEx >= l {
				return 0, io.ErrUnexpectedEOF
			}
			b := dAtA[iNdEx]
			iNdEx++
			wire |= (uint64(b) & 0x7F) << shift
			if b < 0x80 {
				break
			}
		}
		wireType := int(wire & 0x7)
		switch wireType {
		case 0:
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return 0, ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return 0, io.ErrUnexpectedEOF
				}
				iNdEx++
				if dAtA[iNdEx-1] < 0x80 {
					break
				}
			}
		case 1:
			iNdEx += 8
		case 2:
			var length int
			for shift := uint(0); ; shift += 7 {
				if shift >= 64 {
					return 0, ErrIntOverflowStaking
				}
				if iNdEx >= l {
					return 0, io.ErrUnexpectedEOF
				}
				b := dAtA[iNdEx]
				iNdEx++
				length |= (int(b) & 0x7F) << shift
				if b < 0x80 {
					break
				}
			}
			if length < 0 {
				return 0, ErrInvalidLengthStaking
			}
			iNdEx += length
		case 3:
			depth++
		case 4:
			if depth == 0 {
				return 0, ErrUnexpectedEndOfGroupStaking
			}
			depth--
		case 5:
			iNdEx += 4
		default:
			return 0, fmt.Errorf("proto: illegal wireType %d", wireType)
		}
		if iNdEx < 0 {
			return 0, ErrInvalidLengthStaking
		}
		if depth == 0 {
			return iNdEx, nil
		}
	}
	return 0, io.ErrUnexpectedEOF
}

var (
	ErrInvalidLengthStaking        = fmt.Errorf("proto: negative length found during unmarshaling")
	ErrIntOverflowStaking          = fmt.Errorf("proto: integer overflow")
	ErrUnexpectedEndOfGroupStaking = fmt.Errorf("proto: unexpected end of group")
)
